(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var check = Package.check.check;
var Match = Package.check.Match;
var Random = Package.random.Random;
var _ = Package.underscore._;
var SandstormDb = Package['sandstorm-db'].SandstormDb;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var SandstormPermissions, path;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-permissions":{"permissions.js":["babel-runtime/helpers/typeof","babel-runtime/helpers/classCallCheck",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-permissions/permissions.js                                                                       //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof2 = require("babel-runtime/helpers/typeof");                                                                //
                                                                                                                       //
var _typeof3 = _interopRequireDefault(_typeof2);                                                                       //
                                                                                                                       //
var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");                                                //
                                                                                                                       //
var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       //
SandstormPermissions = {};                                                                                             // 19
                                                                                                                       //
var PermissionSet = function () {                                                                                      //
  // A wrapper around an array of booleans representing a set of permissions like "read" or                            //
  // "write". This might represent the permissions held by some user on some grain, or it might                        //
  // represent the permissions that one user has chosen to share with another user.                                    //
  //                                                                                                                   //
  // In our model, permissions are independent. You can have "read" without "write" and you can                        //
  // have "write" without "read". Many apps don't actually allow arbitrary permutations, and                           //
  // instead define "roles" like "editor" or "viewer", where "editor" implies both read and write                      //
  // permission while "viewer" implies only read. Roles, however, are just aliases for sets of                         //
  // permissions; all actual computation is done on permissions.                                                       //
                                                                                                                       //
  function PermissionSet(array) {                                                                                      // 32
    (0, _classCallCheck3["default"])(this, PermissionSet);                                                             //
                                                                                                                       //
    if (!array) {                                                                                                      // 33
      this.array = [];                                                                                                 // 34
    } else if (array instanceof Array) {                                                                               //
      this.array = array.slice(0);                                                                                     // 36
    } else {                                                                                                           //
      throw new Error("don't know how to interpret as PermissionSet: " + array);                                       // 38
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  PermissionSet.fromRoleAssignment = function () {                                                                     // 21
    function fromRoleAssignment(roleAssignment, viewInfo) {                                                            //
      // Create a PermissionSet based on a ViewSharingLink.RoleAssignment and a UiView.ViewInfo (as                    //
      // defined in grain.capnp). ViewInfo defines a mapping from roles to permission sets for a                       //
      // particular grain type. RoleAssignment represents the permissions passed from one user to                      //
      // another -- usually it specifies a single role, but sometimes also specifies permissions to                    //
      // add or remove as well.                                                                                        //
      //                                                                                                               //
      // A falsy value for `roleAssignment` is considered equivalent to a "none" value, which means                    //
      // that no role was explicitly chosen, so the default role should be assigned.                                   //
                                                                                                                       //
      var result = new PermissionSet([]);                                                                              // 52
                                                                                                                       //
      if (!roleAssignment || "none" in roleAssignment) {                                                               // 54
        // No role explicitly chosen, e.g. because the app did not define any roles at the time                        //
        // the sharing took place. Assign the default role, if there is one.                                           //
                                                                                                                       //
        if (viewInfo.roles) {                                                                                          // 58
          for (var ii = 0; ii < viewInfo.roles.length; ++ii) {                                                         // 59
            var roleDef = viewInfo.roles[ii];                                                                          // 60
            if (roleDef["default"]) {                                                                                  // 61
              result = new PermissionSet(roleDef.permissions);                                                         // 62
              break;                                                                                                   // 63
            }                                                                                                          //
          }                                                                                                            //
        }                                                                                                              //
      } else if ("allAccess" in roleAssignment) {                                                                      //
        // All permissions are shared, even if there is no explicitly-defined role for this.                           //
                                                                                                                       //
        var length = 0;                                                                                                // 70
        if (viewInfo.permissions) {                                                                                    // 71
          length = viewInfo.permissions.length;                                                                        // 72
        }                                                                                                              //
                                                                                                                       //
        var array = new Array(length);                                                                                 // 75
        for (var _ii = 0; _ii < array.length; ++_ii) {                                                                 // 76
          array[_ii] = true;                                                                                           // 77
        }                                                                                                              //
                                                                                                                       //
        result = new PermissionSet(array);                                                                             // 80
      } else if ("roleId" in roleAssignment && viewInfo.roles && viewInfo.roles.length > 0) {                          //
        // A specific role was chosen.                                                                                 //
                                                                                                                       //
        var _roleDef = viewInfo.roles[roleAssignment.roleId];                                                          // 84
        if (_roleDef) {                                                                                                // 85
          result = new PermissionSet(_roleDef.permissions);                                                            // 86
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      if (roleAssignment) {                                                                                            // 90
        // Add or remove specific permissions. This is uncommon.                                                       //
        result.add(new PermissionSet(roleAssignment.addPermissionSet));                                                // 92
        result.remove(new PermissionSet(roleAssignment.removePermissionSet));                                          // 93
      }                                                                                                                //
                                                                                                                       //
      return result;                                                                                                   // 96
    }                                                                                                                  //
                                                                                                                       //
    return fromRoleAssignment;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  PermissionSet.prototype.isEmpty = function () {                                                                      // 21
    function isEmpty() {                                                                                               //
      var result = true;                                                                                               // 100
      this.array.forEach(function (p) {                                                                                // 101
        if (p) {                                                                                                       // 102
          result = false;                                                                                              // 103
        }                                                                                                              //
      });                                                                                                              //
                                                                                                                       //
      return result;                                                                                                   // 107
    }                                                                                                                  //
                                                                                                                       //
    return isEmpty;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  PermissionSet.prototype.isSubsetOf = function () {                                                                   // 21
    function isSubsetOf(other) {                                                                                       //
      check(other, PermissionSet);                                                                                     // 111
      for (var ii = 0; ii < this.array.length; ++ii) {                                                                 // 112
        var mine = this.array[ii];                                                                                     // 113
        var yours = other.array[ii] || false;                                                                          // 114
        if (mine && !yours) {                                                                                          // 115
          return false;                                                                                                // 116
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return true;                                                                                                     // 120
    }                                                                                                                  //
                                                                                                                       //
    return isSubsetOf;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  // Methods for mutating a PermissionSet by combining it with another PermissionSet.                                  //
  // These return a boolean indicating whether the operation had any effect.                                           //
                                                                                                                       //
  PermissionSet.prototype.add = function () {                                                                          // 21
    function add(other) {                                                                                              //
      check(other, PermissionSet);                                                                                     // 127
      var changed = false;                                                                                             // 128
      for (var ii = 0; ii < other.array.length; ++ii) {                                                                // 129
        var old = !!this.array[ii];                                                                                    // 130
        this.array[ii] = !!this.array[ii] || other.array[ii];                                                          // 131
        if (old !== this.array[ii]) {                                                                                  // 132
          changed = true;                                                                                              // 133
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return changed;                                                                                                  // 137
    }                                                                                                                  //
                                                                                                                       //
    return add;                                                                                                        //
  }();                                                                                                                 //
                                                                                                                       //
  PermissionSet.prototype.remove = function () {                                                                       // 21
    function remove(other) {                                                                                           //
      check(other, PermissionSet);                                                                                     // 141
      var changed = false;                                                                                             // 142
      for (var ii = 0; ii < other.array.length && ii < this.array.length; ++ii) {                                      // 143
        var old = !!this.array[ii];                                                                                    // 144
        this.array[ii] = !!this.array[ii] && !other.array[ii];                                                         // 145
        if (old !== this.array[ii]) {                                                                                  // 146
          changed = true;                                                                                              // 147
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return changed;                                                                                                  // 151
    }                                                                                                                  //
                                                                                                                       //
    return remove;                                                                                                     //
  }();                                                                                                                 //
                                                                                                                       //
  PermissionSet.prototype.intersect = function () {                                                                    // 21
    function intersect(other) {                                                                                        //
      check(other, PermissionSet);                                                                                     // 155
      var changed = false;                                                                                             // 156
      for (var ii = 0; ii < this.array.length; ++ii) {                                                                 // 157
        var old = !!this.array[ii];                                                                                    // 158
        this.array[ii] = !!this.array[ii] && other.array[ii];                                                          // 159
        if (old !== this.array[ii]) {                                                                                  // 160
          changed = true;                                                                                              // 161
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return changed;                                                                                                  // 165
    }                                                                                                                  //
                                                                                                                       //
    return intersect;                                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  return PermissionSet;                                                                                                //
}();                                                                                                                   //
                                                                                                                       //
var RequirementSet = function () {                                                                                     //
  // A conjunction of permissions for identities on grains.                                                            //
  //                                                                                                                   //
  // This typically represents a set of `MembraneRequirement`s, as defined in `supervisor.capnp`.                      //
  // These represent conditions under which some connection formed between grains remains valid.                       //
  // When a capability travels from grain to grain, it passes across these connections -- if any                       //
  // of the connections becomes invalid (is revoked), then the capability must be revoked as well.                     //
  // The word "membrane" comes from the concept of revokable membranes; the capability is passing                      //
  // across such membranes as it travels.                                                                              //
  //                                                                                                                   //
  // For example, a RequirementSet might represent the statement "Alice has read access to Foo, Bob                    //
  // has write access to Foo, and Bob has read access to Bar". Specifically, this example situation                    //
  // would come about if:                                                                                              //
  // - Bob used his read access to Bar to extract a capability from it.                                                //
  // - Bob embedded that capability into Foo, using his write access.                                                  //
  // - Alice extracted the capability from Foo, using her read access.                                                 //
  // If any of these permissions are revoked, then the capability needs to be revoked as well.                         //
                                                                                                                       //
  function RequirementSet() {                                                                                          // 187
    (0, _classCallCheck3["default"])(this, RequirementSet);                                                            //
                                                                                                                       //
    this.permissionsHeldRequirements = {};                                                                             // 188
    // Two-level map. Maps a pair of a grain ID and an identity ID to a PermissionSet.                                 //
                                                                                                                       //
    this.userIsAdminRequirements = {};                                                                                 // 187
    // Map from account ID to boolean. Represents a set of `userIsAdmin` requirements.                                 //
                                                                                                                       //
    this.tokenValidRequirements = {};                                                                                  // 187
    // Map from token ID to boolean. Represents a set of `tokenValid` requirements.                                    //
  }                                                                                                                    // 187
                                                                                                                       //
  RequirementSet.prototype.isEmpty = function () {                                                                     // 169
    function isEmpty() {                                                                                               //
      for (var tokenId in meteorBabelHelpers.sanitizeForInObject(this.tokenValidRequirements)) {                       // 199
        return false;                                                                                                  // 200
      }                                                                                                                //
                                                                                                                       //
      for (var grainId in meteorBabelHelpers.sanitizeForInObject(this.permissionsHeldRequirements)) {                  // 203
        if (Object.keys(this.permissionsHeldRequirements[grainId]).length > 0) {                                       // 204
          return false;                                                                                                // 205
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return true;                                                                                                     // 209
    }                                                                                                                  //
                                                                                                                       //
    return isEmpty;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  RequirementSet.prototype.addRequirements = function () {                                                             // 169
    function addRequirements(requirements) {                                                                           //
      var _this = this;                                                                                                //
                                                                                                                       //
      // Updates this RequirementSet to include the permissions required by `requirements`, which                      //
      // is a decoded Cap'n Proto List(MembraneRequirement).                                                           //
                                                                                                                       //
      if (!requirements) return;                                                                                       // 216
      requirements.forEach(function (requirement) {                                                                    // 217
        if (requirement.permissionsHeld) {                                                                             // 218
          var grainId = requirement.permissionsHeld.grainId;                                                           // 219
          var identityId = requirement.permissionsHeld.identityId;                                                     // 220
          var permissions = new PermissionSet(requirement.permissionsHeld.permissions);                                // 221
          _this._ensureEntryExists(grainId, identityId);                                                               // 222
          _this.permissionsHeldRequirements[grainId][identityId].add(permissions);                                     // 223
        } else if (requirement.userIsAdmin) {                                                                          //
          _this.userIsAdminRequirements[requirement.userIsAdmin] = true;                                               // 225
        } else if (requirement.tokenValid) {                                                                           //
          _this.tokenValidRequirements[requirement.tokenValid] = true;                                                 // 227
        } else {                                                                                                       //
          throw new Error("unsupported requirement: " + JSON.toString(requirement));                                   // 229
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return addRequirements;                                                                                            //
  }();                                                                                                                 //
                                                                                                                       //
  RequirementSet.prototype._ensureEntryExists = function () {                                                          // 169
    function _ensureEntryExists(grainId, identityId) {                                                                 //
      check(grainId, String);                                                                                          // 235
      check(identityId, String);                                                                                       // 236
                                                                                                                       //
      if (!this.permissionsHeldRequirements[grainId]) {                                                                // 238
        this.permissionsHeldRequirements[grainId] = {};                                                                // 239
      }                                                                                                                //
                                                                                                                       //
      if (!this.permissionsHeldRequirements[grainId][identityId]) {                                                    // 242
        this.permissionsHeldRequirements[grainId][identityId] = new PermissionSet([]);                                 // 243
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return _ensureEntryExists;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  RequirementSet.prototype.getGrainIds = function () {                                                                 // 169
    function getGrainIds() {                                                                                           //
      return Object.keys(this.permissionsHeldRequirements);                                                            // 248
    }                                                                                                                  //
                                                                                                                       //
    return getGrainIds;                                                                                                //
  }();                                                                                                                 //
                                                                                                                       //
  RequirementSet.prototype.getTokenIds = function () {                                                                 // 169
    function getTokenIds() {                                                                                           //
      return Object.keys(this.tokenValidRequirements);                                                                 // 252
    }                                                                                                                  //
                                                                                                                       //
    return getTokenIds;                                                                                                //
  }();                                                                                                                 //
                                                                                                                       //
  RequirementSet.prototype.forEach = function () {                                                                     // 169
    function forEach(func) {                                                                                           //
      for (var tokenId in meteorBabelHelpers.sanitizeForInObject(this.tokenValidRequirements)) {                       // 256
        func({ tokenValid: tokenId });                                                                                 // 257
      }                                                                                                                //
                                                                                                                       //
      for (var accountId in meteorBabelHelpers.sanitizeForInObject(this.userIsAdminRequirements)) {                    // 260
        func({ userIsAdmin: accountId });                                                                              // 261
      }                                                                                                                //
                                                                                                                       //
      for (var grainId in meteorBabelHelpers.sanitizeForInObject(this.permissionsHeldRequirements)) {                  // 264
        for (var identityId in meteorBabelHelpers.sanitizeForInObject(this.permissionsHeldRequirements[grainId])) {    // 265
          var permissions = this.permissionsHeldRequirements[grainId][identityId];                                     // 266
          func({                                                                                                       // 267
            permissionsHeld: {                                                                                         // 268
              grainId: grainId,                                                                                        // 269
              identityId: identityId,                                                                                  // 270
              permissionSet: permissions                                                                               // 271
            }                                                                                                          //
          });                                                                                                          //
        }                                                                                                              //
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return forEach;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  return RequirementSet;                                                                                               //
}();                                                                                                                   //
                                                                                                                       //
// A permission ID is either the string "canAccess", corresponding to the implicit "can access                         //
// the grain at all" permission, or a non-negative integer, corresponding to a permission                              //
// defined by the app in its manifest.                                                                                 //
                                                                                                                       //
                                                                                                                       //
var PermissionId = Match.OneOf("canAccess", Match.Integer);                                                            // 282
                                                                                                                       //
function forEachPermission(permissions, func) {                                                                        // 284
  // Calls `func` on "canAccess" and each permission ID that corresponds to a `true`                                   //
  // value in `permissions`.                                                                                           //
  check(permissions, [Boolean]);                                                                                       // 287
  func("canAccess");                                                                                                   // 288
  for (var ii = 0; ii < permissions.length; ++ii) {                                                                    // 289
    if (permissions[ii]) {                                                                                             // 290
      func(ii);                                                                                                        // 291
    }                                                                                                                  //
  }                                                                                                                    //
}                                                                                                                      //
                                                                                                                       //
// A vertex is a principal in the sharing graph. A "vertex ID" is either "i:" + an identity ID,                        //
// or "t:" + a token ID. In some limited contexts, "o:Owner" is also allowed, signifying the                           //
// *account* of the grain owner, from which all permissions flow.                                                      //
                                                                                                                       //
function vertexIdOfTokenOwner(token) {                                                                                 // 300
  // Returns which vertex recieves permissions from this token.                                                        //
                                                                                                                       //
  var result = "t:" + token._id; // the bearer of the token                                                            // 303
  if (token.owner && token.owner.user) {                                                                               // 300
    result = "i:" + token.owner.user.identityId; // the identity that owns the token                                   // 305
  }                                                                                                                    // 304
                                                                                                                       //
  return result;                                                                                                       // 308
}                                                                                                                      //
                                                                                                                       //
var Variable =                                                                                                         //
// Our permissions computation can be framed as a propositional HORNSAT problem; this `Variable`                       //
// class represents a variable in that sense. There is a variable for every (grain ID, vertex ID,                      //
// permission ID) triple. There is also a variable for every non-UiView ApiToken, to account for                       //
// `tokenValid` requirements. In any given computation, we only explicitly construct those                             //
// variables that we know might actually be relevant to the result.                                                    //
//                                                                                                                     //
// The value of a variable represents an answer to the question "does this vertex in the sharing                       //
// graph receive this permission at this grain?" We start out by setting all variables to `false`,                     //
// and we only set a variable to `true` when an edge in the sharing graph forces us to. If                             //
// this forward-chaining eventually forces us to set our end goal variables to `true`, then the                        //
// HORNSAT problem is unsatisfiable and we have proved what we wanted. Otherwise, the HORNSAT                          //
// problem is satisfiable, i.e. there is a consistent way to set values to variables in which                          //
// our goal nodes do *not* receive the permissions we wanted them to receive.                                          //
                                                                                                                       //
function () {                                                                                                          //
  function Variable() {                                                                                                // 326
    (0, _classCallCheck3["default"])(this, Variable);                                                                  //
                                                                                                                       //
    this.value = false;                                                                                                // 327
                                                                                                                       //
    this.directDependents = [];                                                                                        // 329
    // List of token IDs for outgoing edges that need to be looked at once this variable gets set                      //
    // to `true`.                                                                                                      //
                                                                                                                       //
    this.requirementDependents = [];                                                                                   // 326
    // List of token IDs for tokens that have requirements that get fulfilled once this variable                       //
    // gets set to `true`.                                                                                             //
  }                                                                                                                    // 326
                                                                                                                       //
  return Variable;                                                                                                     //
}();                                                                                                                   //
                                                                                                                       //
var ActiveToken = function () {                                                                                        //
  // An "active token" is one that we allow to propagate permissions because we've decided                             //
  // that it might be relevant to our current computation. This class tracks which permissions                         //
  // the token can carry, which of those permissions we've actually proved to arrive at the source                     //
  // end of the token, and how many of the token's requirements are still unmet.                                       //
                                                                                                                       //
  function ActiveToken(tokenId, requirements, numUnmetRequirements, permissions, grainId, recipientId) {               // 345
    (0, _classCallCheck3["default"])(this, ActiveToken);                                                               //
                                                                                                                       //
    check(tokenId, String);                                                                                            // 346
    check(numUnmetRequirements, Match.Integer);                                                                        // 347
    check(grainId, String);                                                                                            // 348
    check(recipientId, String);                                                                                        // 349
                                                                                                                       //
    check(permissions, [Boolean]);                                                                                     // 351
    // The permissions that this token is capable of carrying, in addition to the implicit                             //
    // "canAccess" permission.                                                                                         //
                                                                                                                       //
    this.tokenId = tokenId;                                                                                            // 345
    this.requirements = requirements;                                                                                  // 356
    this.grainId = grainId;                                                                                            // 357
    this.recipientId = recipientId;                                                                                    // 358
                                                                                                                       //
    this.numUnmetRequirements = numUnmetRequirements;                                                                  // 360
    // How many of this token's requirements we have not yet proven to be met.                                         //
                                                                                                                       //
    this.receivedPermissions = new Array();                                                                            // 345
    // A map from permission ID to boolean. If a permission ID is present in this map,                                 //
    // then this token's roleAssignment includes that permission. If the corresponding                                 //
    // value is `true`, then we've proven that this token receives this permission and                                 //
    // therefore propagates it if the requirements are met.                                                            //
                                                                                                                       //
    this.receivedPermissions.canAccess = false;                                                                        // 345
    for (var ii = 0; ii < permissions.length; ++ii) {                                                                  // 370
      if (permissions[ii]) {                                                                                           // 371
        this.receivedPermissions[ii] = false;                                                                          // 372
      }                                                                                                                //
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  ActiveToken.prototype.requirementsAreMet = function () {                                                             // 339
    function requirementsAreMet() {                                                                                    //
      // Have we yet proved that all of this token's requirements are met?                                             //
      return this.numUnmetRequirements == 0;                                                                           // 379
    }                                                                                                                  //
                                                                                                                       //
    return requirementsAreMet;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  ActiveToken.prototype.decrementRequirements = function () {                                                          // 339
    function decrementRequirements(context) {                                                                          //
      var _this2 = this;                                                                                               //
                                                                                                                       //
      // Decrements the number of unmet requirements of this token.                                                    //
      check(context, Context);                                                                                         // 384
      this.numUnmetRequirements -= 1;                                                                                  // 385
      if (this.numUnmetRequirements < 0) {                                                                             // 386
        throw new Meteor.Error(500, "numUnmetRequirements is negative");                                               // 387
      }                                                                                                                //
                                                                                                                       //
      if (this.requirementsAreMet()) {                                                                                 // 390
        // This was the last missing requirement for this token, therefore we've triggered the                         //
        // outgoing edges from the token corresponding to each known incoming permission.                              //
        this.forEachReceivedPermission(function (permissionId) {                                                       // 393
          // We've triggered a new edge! Push it onto the queue.                                                       //
          context.setToTrueStack.push({ grainId: _this2.grainId,                                                       // 395
            vertexId: _this2.recipientId,                                                                              // 396
            permissionId: permissionId,                                                                                // 397
            responsibleTokenId: _this2.tokenId });                                                                     // 398
        });                                                                                                            //
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return decrementRequirements;                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  ActiveToken.prototype.setReceivesPermission = function () {                                                          // 339
    function setReceivesPermission(permissionId, context) {                                                            //
      // Records that this token receives a permission.                                                                //
      check(permissionId, PermissionId);                                                                               // 405
      check(context, Context);                                                                                         // 406
      if (permissionId in this.receivedPermissions) {                                                                  // 407
        this.receivedPermissions[permissionId] = true;                                                                 // 408
      }                                                                                                                //
                                                                                                                       //
      if (this.numUnmetRequirements == 0) {                                                                            // 411
        context.setToTrueStack.push({ grainId: this.grainId,                                                           // 412
          vertexId: this.recipientId,                                                                                  // 413
          permissionId: permissionId,                                                                                  // 414
          responsibleTokenId: this.tokenId });                                                                         // 415
      } else {                                                                                                         //
        // Since we know permissions flow to this token, and the token is active (meaning it                           //
        // may be relevant to the overall computation), we now know that it's worth checking                           //
        // the token's requirements. Add them to `unmetRequirements`. Note that these requirement                      //
        // could actually be ones that we've checked already, but we'll figure that out once                           //
        // processUnmetRequirements() runs and discovers it isn't activating any new tokens.                           //
        //                                                                                                             //
        // TODO(perf): This is an overestimate. It might be worthwhile to keep track of which                          //
        //   requirements are already met, so that we don't need to add them here.                                     //
                                                                                                                       //
        context.unmetRequirements.addRequirements(this.requirements);                                                  // 426
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return setReceivesPermission;                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  ActiveToken.prototype.forEachReceivedPermission = function () {                                                      // 339
    function forEachReceivedPermission(func) {                                                                         //
      // Calls `func` on each permission ID that we've proven this token receives.                                     //
                                                                                                                       //
      if (this.receivedPermissions.canAccess) {                                                                        // 433
        func("canAccess");                                                                                             // 434
      }                                                                                                                //
                                                                                                                       //
      // Note: Array.forEach() does hit the "canAccess" permission ID.                                                 //
      this.receivedPermissions.forEach(function (received, permissionId) {                                             // 430
        if (received) {                                                                                                // 439
          func(permissionId);                                                                                          // 440
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return forEachReceivedPermission;                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  return ActiveToken;                                                                                                  //
}();                                                                                                                   //
                                                                                                                       //
var Context = function () {                                                                                            //
  // An ongoing permissions computation, including cached database state.                                              //
                                                                                                                       //
  function Context() {                                                                                                 // 449
    (0, _classCallCheck3["default"])(this, Context);                                                                   //
                                                                                                                       //
    this.grains = {}; // Map from grain ID to entry in Grains table.                                                   // 450
    this.userIdentityIds = {}; // Map from account ID to list of linked identity IDs.                                  // 449
    this.adminUsers = {}; // Set of account IDs for admins.                                                            // 449
    this.tokensById = {}; // Map from token ID to token.                                                               // 449
    this.tokensByRecipient = {}; // Map from grain ID and identity ID to token array.                                  // 449
                                                                                                                       //
    this.variables = {};                                                                                               // 449
    // GrainId -> VertexId -> PermissionId -> Variable                                                                 //
    //                                                                                                                 //
    // We have a special fake grain ID "tokenValid", where we store the variables that track                           //
    // `tokenValid` requirements. Only the "canAccess" permission makes sense for that fake grain.                     //
                                                                                                                       //
    this.userIsAdminVariables = {};                                                                                    // 449
    // Account ID -> Variable                                                                                          //
                                                                                                                       //
    this.activeTokens = {}; // TokenId -> ActiveToken                                                                  // 449
                                                                                                                       //
    this.setToTrueStack = [];                                                                                          // 449
    // Variables enqueued to be set to true.                                                                           //
    // Array of { grainId: String, vertexId: String, permissionId: PermissionId,                                       //
    //            responsibleTokenId: Optional(String) }                                                               //
                                                                                                                       //
    this.unmetRequirements = new RequirementSet();                                                                     // 449
    // As we run our forward-chaining algorithm, when we encounter a token with unmet requirements                     //
    // we add those requirements to this set. Then, if we find that our current knowledge base                         //
    // is not large enough to prove our goal, we can expand our search by following these                              //
    // requirements backwards and activating tokens that might help prove that they are met.                           //
    // `unmetRequirements` is allowed to be an overestimate -- in fact, when adding requirements                       //
    // to `unmetRequirements` we generally do not check if they had already been proven. The next                      //
    // run of processUnmetRequirements(), however, will find that all of the tokens activated by                       //
    // the requirements were already active.                                                                           //
  }                                                                                                                    // 449
                                                                                                                       //
  Context.prototype.reset = function () {                                                                              // 446
    function reset() {                                                                                                 //
      // Resets all state except this.grains, this.userIdentityIds, and this.adminUsers.                               //
      this.tokensById = {};                                                                                            // 485
      this.tokensByRecipient = {};                                                                                     // 486
      this.unmetRequirements = new RequirementSet();                                                                   // 487
      this.setToTrueStack = [];                                                                                        // 488
      this.variables = {};                                                                                             // 489
      this.activeTokens = {};                                                                                          // 490
    }                                                                                                                  //
                                                                                                                       //
    return reset;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.addToken = function () {                                                                           // 446
    function addToken(token) {                                                                                         //
      // Adds a token to `this.tokensById`. If the token is a UiView, also adds it to                                  //
      // `this.tokensByRecipient`. Does not activate the token.                                                        //
                                                                                                                       //
      var isUiView = token.grainId && !token.objectId;                                                                 // 497
                                                                                                                       //
      if (this.tokensById[token._id]) return;                                                                          // 499
                                                                                                                       //
      this.tokensById[token._id] = token;                                                                              // 501
      if (isUiView && token.owner && token.owner.user) {                                                               // 502
        if (!this.tokensByRecipient[token.grainId]) {                                                                  // 503
          this.tokensByRecipient[token.grainId] = {};                                                                  // 504
        }                                                                                                              //
                                                                                                                       //
        if (!this.tokensByRecipient[token.grainId][token.owner.user.identityId]) {                                     // 507
          this.tokensByRecipient[token.grainId][token.owner.user.identityId] = [];                                     // 508
        }                                                                                                              //
                                                                                                                       //
        this.tokensByRecipient[token.grainId][token.owner.user.identityId].push(token);                                // 511
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return addToken;                                                                                                   //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.addGrains = function () {                                                                          // 446
    function addGrains(db, grainIds) {                                                                                 //
      var _this3 = this;                                                                                               //
                                                                                                                       //
      // Retrieves grains from the database.                                                                           //
                                                                                                                       //
      check(db, SandstormDb);                                                                                          // 518
      check(grainIds, [String]);                                                                                       // 519
      if (grainIds.length == 0) return; // Nothing to do.                                                              // 520
                                                                                                                       //
      db.collections.grains.find({ _id: { $in: grainIds }, trashed: { $exists: false } }).forEach(function (grain) {   // 515
        _this3.grains[grain._id] = grain;                                                                              // 523
        if (!_this3.userIdentityIds[grain.userId]) {                                                                   // 524
          _this3.userIdentityIds[grain.userId] = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: grain.userId }));
        }                                                                                                              //
      });                                                                                                              //
                                                                                                                       //
      var query = { grainId: { $in: grainIds },                                                                        // 530
        revoked: { $ne: true },                                                                                        // 531
        trashed: { $exists: false },                                                                                   // 532
        objectId: { $exists: false } };                                                                                // 533
      db.collections.apiTokens.find(query).forEach(function (token) {                                                  // 534
        return _this3.addToken(token);                                                                                 //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return addGrains;                                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.addTokensFromCursor = function () {                                                                // 446
    function addTokensFromCursor(cursor) {                                                                             //
      var _this4 = this;                                                                                               //
                                                                                                                       //
      cursor.forEach(function (token) {                                                                                // 538
        return _this4.addToken(token);                                                                                 //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return addTokensFromCursor;                                                                                        //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.activateOwnerEdges = function () {                                                                 // 446
    function activateOwnerEdges(grainId, edges) {                                                                      //
      var _this5 = this;                                                                                               //
                                                                                                                       //
      check(edges, [{ identityId: String, role: SandstormDb.prototype.roleAssignmentPattern }]);                       // 542
                                                                                                                       //
      edges.forEach(function (edge) {                                                                                  // 544
        var viewInfo = _this5.grains[grainId].cachedViewInfo || {};                                                    // 545
        var permissions = PermissionSet.fromRoleAssignment(edge.role, viewInfo);                                       // 546
        var vertexId = "i:" + edge.identityId;                                                                         // 547
        forEachPermission(permissions.array, function (permissionId) {                                                 // 548
          _this5.setToTrueStack.push({                                                                                 // 549
            grainId: grainId,                                                                                          // 550
            vertexId: vertexId,                                                                                        // 551
            permissionId: permissionId                                                                                 // 552
          });                                                                                                          //
        });                                                                                                            //
      });                                                                                                              //
                                                                                                                       //
      return edges.length > 0;                                                                                         // 557
    }                                                                                                                  //
                                                                                                                       //
    return activateOwnerEdges;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.registerInterestInRequirements = function () {                                                     // 446
    function registerInterestInRequirements(tokenId, requirements) {                                                   //
      var _this6 = this;                                                                                               //
                                                                                                                       //
      // Add all requirements.                                                                                         //
      var numUnmetRequirements = 0;                                                                                    // 562
      if (requirements) {                                                                                              // 563
        requirements.forEach(function (requirement) {                                                                  // 564
          if (requirement.permissionsHeld) {                                                                           // 565
            (function () {                                                                                             //
              var reqGrainId = requirement.permissionsHeld.grainId;                                                    // 566
              var reqVertexId = "i:" + requirement.permissionsHeld.identityId;                                         // 567
              var reqPermissions = requirement.permissionsHeld.permissions || [];                                      // 568
                                                                                                                       //
              forEachPermission(reqPermissions, function (permissionId) {                                              // 570
                var variable = _this6.getVariable(reqGrainId, reqVertexId, permissionId);                              // 571
                if (!variable.value) {                                                                                 // 572
                  // This requirement hasn't been proven yet. We add it to the variable's list of                      //
                  // dependents so that we get notified when that variable is proven, and we increment                 //
                  // numUnmetRequirements to indicate how many notifications we need to get before we                  //
                  // know all requirements are satisfied.                                                              //
                  numUnmetRequirements += 1;                                                                           // 577
                  variable.requirementDependents.push(tokenId);                                                        // 578
                }                                                                                                      //
              });                                                                                                      //
            })();                                                                                                      //
          } else if (requirement.userIsAdmin) {                                                                        //
            var accountId = requirement.userIsAdmin;                                                                   // 582
            var variable = _this6.getUserIsAdminVariable(accountId);                                                   // 583
            if (!variable.value) {                                                                                     // 584
              numUnmetRequirements += 1;                                                                               // 585
              variable.requirementDependents.push(tokenId);                                                            // 586
            }                                                                                                          //
          } else if (requirement.tokenValid) {                                                                         //
            var reqTokenId = requirement.tokenValid;                                                                   // 589
            var _variable = _this6.getVariable("tokenValid", "t:" + reqTokenId, "canAccess");                          // 590
            if (!_variable.value) {                                                                                    // 591
              numUnmetRequirements += 1;                                                                               // 592
              _variable.requirementDependents.push(tokenId);                                                           // 593
            }                                                                                                          //
          } else {                                                                                                     //
            throw new Error("unknown kind of requirement: " + JSON.stringify(requirement));                            // 596
          }                                                                                                            //
        });                                                                                                            //
      }                                                                                                                //
                                                                                                                       //
      return numUnmetRequirements;                                                                                     // 601
    }                                                                                                                  //
                                                                                                                       //
    return registerInterestInRequirements;                                                                             //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.activateToken = function () {                                                                      // 446
    function activateToken(tokenId) {                                                                                  //
      var _this7 = this;                                                                                               //
                                                                                                                       //
      // Includes a new token (which must already be in `this.tokensById`) in our computation. The                     //
      // tricky part here is dealing with our already-accumulated knowledge; we need to compute how                    //
      // many of the token's requirements are currently unmet and whether we need to push anything new                 //
      // onto `setToTrueStack`.                                                                                        //
                                                                                                                       //
      check(tokenId, String);                                                                                          // 610
      if (tokenId in this.activeTokens) {                                                                              // 611
        return false;                                                                                                  // 612
      }                                                                                                                //
                                                                                                                       //
      var token = this.tokensById[tokenId];                                                                            // 615
      var grainId = token.grainId;                                                                                     // 616
      var viewInfo = this.grains[grainId].cachedViewInfo || {};                                                        // 617
      var tokenPermissions = PermissionSet.fromRoleAssignment(token.roleAssignment, viewInfo);                         // 618
                                                                                                                       //
      var sharerId = token.parentToken ? "t:" + token.parentToken : "i:" + token.identityId;                           // 620
      var recipientId = vertexIdOfTokenOwner(token);                                                                   // 621
                                                                                                                       //
      var numUnmetRequirements = this.registerInterestInRequirements(tokenId, token.requirements);                     // 623
      var activeToken = new ActiveToken(tokenId, token.requirements, numUnmetRequirements, tokenPermissions.array, grainId, recipientId);
                                                                                                                       //
      // Add all edges represented by this token (one for each permission).                                            //
      forEachPermission(tokenPermissions.array, function (permissionId) {                                              // 604
        var recipientVariable = _this7.getVariable(grainId, recipientId, permissionId);                                // 629
        if (!recipientVariable.value) {                                                                                // 630
          var sharerVariable = _this7.getVariable(grainId, sharerId, permissionId);                                    // 631
          if (!sharerVariable.value) {                                                                                 // 632
            // Not proven yet that the source has this permission, so add to its direct dependents so                  //
            // that we get notified if that changes.                                                                   //
            sharerVariable.directDependents.push(tokenId);                                                             // 635
          } else {                                                                                                     //
            // The source has already been proven.                                                                     //
            activeToken.setReceivesPermission(permissionId, _this7);                                                   // 638
          }                                                                                                            //
        }                                                                                                              //
      });                                                                                                              //
                                                                                                                       //
      this.activeTokens[tokenId] = activeToken;                                                                        // 643
                                                                                                                       //
      return true;                                                                                                     // 645
    }                                                                                                                  //
                                                                                                                       //
    return activateToken;                                                                                              //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.activateTokenValidToken = function () {                                                            // 446
    function activateTokenValidToken(tokenId) {                                                                        //
      // Like `activateToken()`, but for a token that appears in a `tokenValid` requirement.                           //
      // Such tokens require some special handling to fit into our computation.                                        //
                                                                                                                       //
      check(tokenId, String);                                                                                          // 652
      if (tokenId in this.activeTokens) {                                                                              // 653
        return false;                                                                                                  // 654
      }                                                                                                                //
                                                                                                                       //
      var token = this.tokensById[tokenId];                                                                            // 657
      if (!token) {                                                                                                    // 658
        return false;                                                                                                  // 659
      }                                                                                                                //
                                                                                                                       //
      var numUnmetRequirements = this.registerInterestInRequirements(tokenId, token.requirements);                     // 662
      var activeToken = new ActiveToken(tokenId, token.requirements, numUnmetRequirements, [], "tokenValid", "t:" + tokenId);
                                                                                                                       //
      var recipientId = "t:" + tokenId;                                                                                // 666
      var sharerVariable = token.parentToken && this.getVariable("tokenValid", "t:" + token.parentToken, "canAccess");
                                                                                                                       //
      var recipientVariable = this.getVariable("tokenValid", recipientId, "canAccess");                                // 670
      if (!recipientVariable.value) {                                                                                  // 671
        if (!token.parentToken || sharerVariable && sharerVariable.value) {                                            // 672
          // The source has already been proven.                                                                       //
          activeToken.setReceivesPermission("canAccess", this);                                                        // 674
        } else {                                                                                                       //
          // Not proven yet that the source has this permission, so add to its direct dependents so                    //
          // that we get notified if that changes.                                                                     //
          sharerVariable.directDependents.push(tokenId);                                                               // 678
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      this.activeTokens[tokenId] = activeToken;                                                                        // 682
                                                                                                                       //
      return true;                                                                                                     // 684
    }                                                                                                                  //
                                                                                                                       //
    return activateTokenValidToken;                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.getVariable = function () {                                                                        // 446
    function getVariable(grainId, vertexId, permissionId) {                                                            //
      check(grainId, String);                                                                                          // 688
      check(vertexId, String);                                                                                         // 689
      check(permissionId, PermissionId);                                                                               // 690
                                                                                                                       //
      if (!this.variables[grainId]) {                                                                                  // 692
        this.variables[grainId] = {};                                                                                  // 693
      }                                                                                                                //
                                                                                                                       //
      if (!this.variables[grainId][vertexId]) {                                                                        // 696
        this.variables[grainId][vertexId] = new Array();                                                               // 697
      }                                                                                                                //
                                                                                                                       //
      if (!this.variables[grainId][vertexId][permissionId]) {                                                          // 700
        this.variables[grainId][vertexId][permissionId] = new Variable();                                              // 701
      }                                                                                                                //
                                                                                                                       //
      return this.variables[grainId][vertexId][permissionId];                                                          // 704
    }                                                                                                                  //
                                                                                                                       //
    return getVariable;                                                                                                //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.getUserIsAdminVariable = function () {                                                             // 446
    function getUserIsAdminVariable(accountId) {                                                                       //
      check(accountId, String);                                                                                        // 708
                                                                                                                       //
      if (!this.userIsAdminVariables[accountId]) {                                                                     // 710
        this.userIsAdminVariables[accountId] = new Variable();                                                         // 711
      }                                                                                                                //
                                                                                                                       //
      return this.userIsAdminVariables[accountId];                                                                     // 714
    }                                                                                                                  //
                                                                                                                       //
    return getUserIsAdminVariable;                                                                                     //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.getPermissions = function () {                                                                     // 446
    function getPermissions(grainId, vertexId) {                                                                       //
      // Looks up the permissions that have already been proven for the `vertexId` on `grainId`.                       //
                                                                                                                       //
      check(grainId, String);                                                                                          // 720
      check(vertexId, String);                                                                                         // 721
                                                                                                                       //
      if (!this.getVariable(grainId, vertexId, "canAccess").value) {                                                   // 723
        return null;                                                                                                   // 724
      } else {                                                                                                         //
        var length = this.variables[grainId][vertexId].length;                                                         // 726
        var permissions = new Array(length);                                                                           // 727
        for (var idx = 0; idx < length; ++idx) {                                                                       // 728
          if (this.variables[grainId][vertexId][idx]) {                                                                // 729
            permissions[idx] = !!this.variables[grainId][vertexId][idx].value;                                         // 730
          } else {                                                                                                     //
            permissions[idx] = false;                                                                                  // 732
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        return new PermissionSet(permissions);                                                                         // 736
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return getPermissions;                                                                                             //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.runForwardChaining = function () {                                                                 // 446
    function runForwardChaining(grainId, vertexId, permissionSet) {                                                    //
      var _this8 = this;                                                                                               //
                                                                                                                       //
      // Runs forward-chaining, consuming elements from `this.setToTrueStack` and propagating                          //
      // their permissions, until we've proven that `(grainId, vertexId)` has the permissions in                       //
      // `permissionSet`, or until we've exhausted `this.setToTrueStack`.                                              //
      //                                                                                                               //
      // TODO(perf): Exit early if we've already proven that permissionSet is fulfilled.                               //
                                                                                                                       //
      check(grainId, String);                                                                                          // 747
      check(vertexId, String);                                                                                         // 748
      check(permissionSet, PermissionSet);                                                                             // 749
                                                                                                                       //
      if (permissionSet.array.length > 0) {                                                                            // 751
        // Make sure that the result of this call, retrieved through `this.getPermissions()`,                          //
        // will have a full array of permissions, even if they won't all be set to `true`.                             //
        this.getVariable(grainId, vertexId, permissionSet.array.length - 1);                                           // 754
      }                                                                                                                //
                                                                                                                       //
      var _loop = function () {                                                                                        //
        function _loop() {                                                                                             //
          var current = _this8.setToTrueStack.pop();                                                                   // 758
          var variable = _this8.getVariable(current.grainId, current.vertexId, current.permissionId);                  // 759
          if (variable.value) {                                                                                        // 760
            return "continue";                                                                                         // 761
          }                                                                                                            //
                                                                                                                       //
          // For the first time, this vertex is now known to be satisfied.                                             //
          variable.value = true;                                                                                       // 765
                                                                                                                       //
          // For each edge (token) whose source is this vertex, mark that the input permission is                      //
          // fulfilled.                                                                                                //
          variable.responsibleTokenId = current.responsibleTokenId;                                                    // 769
          variable.directDependents.forEach(function (tokenId) {                                                       // 770
            // We know this permission must be met now. We also know that the permission was not met                   //
            // for this token previously becaues a token has exactly one source vertex for each                        //
            // permission, and we're processing that vertex now.                                                       //
                                                                                                                       //
            _this8.activeTokens[tokenId].setReceivesPermission(current.permissionId, _this8);                          // 775
          });                                                                                                          //
                                                                                                                       //
          // For each token that has a requirement on this vertex, mark that one of its requirements                   //
          // has ben fulfilled.                                                                                        //
          variable.requirementDependents.forEach(function (tokenId) {                                                  // 780
            _this8.activeTokens[tokenId].decrementRequirements(_this8);                                                // 781
          });                                                                                                          //
        }                                                                                                              //
                                                                                                                       //
        return _loop;                                                                                                  //
      }();                                                                                                             //
                                                                                                                       //
      while (this.setToTrueStack.length > 0) {                                                                         // 757
        var _ret2 = _loop();                                                                                           //
                                                                                                                       //
        if (_ret2 === "continue") continue;                                                                            //
      }                                                                                                                //
                                                                                                                       //
      return this.getPermissions(grainId, vertexId);                                                                   // 785
    }                                                                                                                  //
                                                                                                                       //
    return runForwardChaining;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.activateRelevantTokens = function () {                                                             // 446
    function activateRelevantTokens(grainId, vertexId) {                                                               //
      var _this9 = this;                                                                                               //
                                                                                                                       //
      // Returns true if more computation might yield more progress.                                                   //
                                                                                                                       //
      check(grainId, String);                                                                                          // 791
      check(vertexId, String);                                                                                         // 792
                                                                                                                       //
      var result = false;                                                                                              // 794
      var relevant = computeRelevantTokens(this, grainId, vertexId);                                                   // 795
      if (this.activateOwnerEdges(grainId, relevant.ownerEdges)) {                                                     // 796
        result = true;                                                                                                 // 797
      }                                                                                                                //
                                                                                                                       //
      relevant.tokenIds.forEach(function (tokenId) {                                                                   // 800
        if (_this9.activateToken(tokenId)) {                                                                           // 801
          result = true;                                                                                               // 802
        }                                                                                                              //
      });                                                                                                              //
                                                                                                                       //
      return result;                                                                                                   // 806
    }                                                                                                                  //
                                                                                                                       //
    return activateRelevantTokens;                                                                                     //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.processUnmetRequirements = function () {                                                           // 446
    function processUnmetRequirements(db) {                                                                            //
      var _this10 = this;                                                                                              //
                                                                                                                       //
      // Activate all tokens relevant to the requirements in `unmetRequirements`. May do a database                    //
      // query to look up new tokens.                                                                                  //
      //                                                                                                               //
      // Returns true if more computation might yield more progress, i.e., at least one token was                      //
      // newly-activated.                                                                                              //
                                                                                                                       //
      var grainIds = this.unmetRequirements.getGrainIds().filter(function (grainId) {                                  // 816
        return !(grainId in _this10.grains);                                                                           //
      });                                                                                                              //
                                                                                                                       //
      if (db) {                                                                                                        // 819
        this.addGrains(db, grainIds);                                                                                  // 820
      }                                                                                                                //
                                                                                                                       //
      var result = false;                                                                                              // 823
                                                                                                                       //
      // As we process our requirements, we might find new unmet requirments.                                          //
      // We defer processing those until the next time around.                                                         //
      var oldUnmetRequirements = this.unmetRequirements;                                                               // 809
      this.unmetRequirements = new RequirementSet();                                                                   // 828
                                                                                                                       //
      oldUnmetRequirements.forEach(function (req) {                                                                    // 830
        if (req.permissionsHeld) {                                                                                     // 831
          var next = req.permissionsHeld;                                                                              // 832
          // Activate all tokens relevant to this requirement.                                                         //
          // TODO(perf): We're actually overestimating, because we're activating tokens relevant to                    //
          //   *all* permissions rather than just the permissions specified by the requirement. E.g.                   //
          //   if the requirement is that Bob has write access, then tokens which only transmit read                   //
          //   access are not relevant, but we'll end up activating them anyway.                                       //
          if (_this10.activateRelevantTokens(next.grainId, "i:" + next.identityId)) {                                  // 831
            result = true;                                                                                             // 839
          }                                                                                                            //
        } else if (req.tokenValid) {                                                                                   //
          // Active the token and all of its transitive parents.                                                       //
          var currentTokenId = req.tokenValid;                                                                         // 843
          while (true) {                                                                                               // 844
            var currentToken = _this10.tokensById[currentTokenId];                                                     // 845
            if (!currentToken && db) {                                                                                 // 846
              currentToken = db.collections.apiTokens.findOne({                                                        // 847
                _id: currentTokenId,                                                                                   // 848
                revoked: { $ne: true }                                                                                 // 849
              });                                                                                                      //
              _this10.tokensById[currentTokenId] = currentToken;                                                       // 851
            }                                                                                                          //
                                                                                                                       //
            if (!currentToken) {                                                                                       // 854
              break;                                                                                                   // 855
            }                                                                                                          //
                                                                                                                       //
            if (_this10.activateTokenValidToken(currentTokenId)) {                                                     // 858
              result = true;                                                                                           // 859
            }                                                                                                          //
                                                                                                                       //
            if (currentToken.parentToken) {                                                                            // 862
              currentTokenId = currentToken.parentToken;                                                               // 863
            } else {                                                                                                   //
              break;                                                                                                   // 865
            }                                                                                                          //
          }                                                                                                            //
        } else if (req.userIsAdmin) {                                                                                  //
          var accountId = req.userIsAdmin;                                                                             // 869
          if (!(accountId in _this10.adminUsers) && db) {                                                              // 870
            Meteor.users.find({ isAdmin: true }).forEach(function (user) {                                             // 871
              _this10.adminUsers[user._id] = true;                                                                     // 872
            });                                                                                                        //
          }                                                                                                            //
                                                                                                                       //
          if (_this10.adminUsers[accountId]) {                                                                         // 876
            var variable = _this10.getUserIsAdminVariable(accountId);                                                  // 877
            variable.value = true;                                                                                     // 878
                                                                                                                       //
            // Might have some requirement dependents. Cannot have any direct depependents.                            //
            variable.requirementDependents.forEach(function (tokenId) {                                                // 876
              result = true;                                                                                           // 882
              _this10.activeTokens[tokenId].decrementRequirements(_this10);                                            // 883
            });                                                                                                        //
          }                                                                                                            //
        } else {                                                                                                       //
          throw new Error("unknown kind of requirement: " + JSON.stringify(req));                                      // 887
        }                                                                                                              //
      });                                                                                                              //
                                                                                                                       //
      return result;                                                                                                   // 891
    }                                                                                                                  //
                                                                                                                       //
    return processUnmetRequirements;                                                                                   //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.tryToProve = function () {                                                                         // 446
    function tryToProve(grainId, vertexId, permissionSet, db) {                                                        //
      // Tries to prove that `vertexId` has the given permissions on the given grain. Returns a                        //
      // `PermissionSet` representing the permissions proven, or null if it has not been proved                        //
      // yet that the vertex even has access to the grain.                                                             //
                                                                                                                       //
      check(grainId, String);                                                                                          // 899
      check(vertexId, String);                                                                                         // 900
      check(permissionSet, PermissionSet);                                                                             // 901
      check(db, Match.OneOf(undefined, SandstormDb));                                                                  // 902
      // If `db` is not provided, then this function will make no database queries.                                    //
                                                                                                                       //
      if (db) {                                                                                                        // 894
        this.addGrains(db, [grainId]);                                                                                 // 906
      }                                                                                                                //
                                                                                                                       //
      this.activateRelevantTokens(grainId, vertexId);                                                                  // 909
      while (true) {                                                                                                   // 910
        var result = this.runForwardChaining(grainId, vertexId, permissionSet);                                        // 911
        if (result && permissionSet.isSubsetOf(result)) {                                                              // 912
          return result;                                                                                               // 913
        }                                                                                                              //
                                                                                                                       //
        if (!this.processUnmetRequirements(db)) {                                                                      // 916
          return result;                                                                                               // 917
        }                                                                                                              //
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return tryToProve;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.getResponsibleTokens = function () {                                                               // 446
    function getResponsibleTokens(grainId, vertexId) {                                                                 //
      // For the permissions that we've already proven must be held by `vertexId`, transitively finds                  //
      // the tokens that we have used in that proof, including tokens responsible for fulfilling                       //
      // membrane requirements.                                                                                        //
      //                                                                                                               //
      // Whenever we prove a fact, we keep track of the immediately responsible token for that fact,                   //
      // This function works by walking backwards in the sharing graph, following this trail of                        //
      // "responsible tokens".                                                                                         //
      //                                                                                                               //
      // Returns an object with two fields:                                                                            //
      //    tokenIds: list of IDs of the responsible tokens.                                                           //
      //    grainIds: list of IDs of all relevant grains.                                                              //
                                                                                                                       //
      check(grainId, String);                                                                                          // 935
      check(vertexId, String);                                                                                         // 936
                                                                                                                       //
      var stack = []; // [{ grainId: String, vertexId: String, permissionId: PermissionId }]                           // 938
      var visited = new Array(); // grainId -> vertexId -> permissionId -> bool;                                       // 922
                                                                                                                       //
      function pushVertex(grainId, vertexId, permissionId) {                                                           // 922
        if (!visited[grainId]) {                                                                                       // 942
          visited[grainId] = {};                                                                                       // 943
        }                                                                                                              //
                                                                                                                       //
        if (!visited[grainId][vertexId]) {                                                                             // 946
          visited[grainId][vertexId] = {};                                                                             // 947
        }                                                                                                              //
                                                                                                                       //
        var vertex = visited[grainId][vertexId];                                                                       // 950
        if (!vertex[permissionId]) {                                                                                   // 951
          vertex[permissionId] = true;                                                                                 // 952
          stack.push({ grainId: grainId, vertexId: vertexId, permissionId: permissionId });                            // 953
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      var neededTokens = {}; // TokenId -> bool                                                                        // 957
                                                                                                                       //
      forEachPermission(this.getPermissions(grainId, vertexId).array, function (permissionId) {                        // 922
        pushVertex(grainId, vertexId, permissionId);                                                                   // 960
      });                                                                                                              //
                                                                                                                       //
      while (stack.length > 0) {                                                                                       // 963
        var _current = stack.pop();                                                                                    // 964
        var variable = this.getVariable(_current.grainId, _current.vertexId, _current.permissionId);                   // 965
        var tokenId = variable.responsibleTokenId;                                                                     // 966
        if (tokenId) {                                                                                                 // 967
          var token = this.tokensById[tokenId];                                                                        // 968
                                                                                                                       //
          if (token.grainId && !token.objectId) {                                                                      // 970
            var sharerId = token.parentToken ? "t:" + token.parentToken : "i:" + token.identityId;                     // 971
            pushVertex(token.grainId, sharerId, _current.permissionId);                                                // 972
          } else if (token.parentToken) {                                                                              //
            pushVertex("tokenValid", "t:" + token.parentToken, "canAccess");                                           // 974
          }                                                                                                            //
                                                                                                                       //
          if (!neededTokens[tokenId]) {                                                                                // 977
            neededTokens[tokenId] = true;                                                                              // 978
            if (token.requirements) {                                                                                  // 979
              token.requirements.forEach(function (requirement) {                                                      // 980
                if (requirement.permissionsHeld) {                                                                     // 981
                  (function () {                                                                                       //
                    var reqVertexId = "i:" + requirement.permissionsHeld.identityId;                                   // 982
                    forEachPermission(requirement.permissionsHeld.permissions, function (permissionId) {               // 983
                      pushVertex(requirement.permissionsHeld.grainId, reqVertexId, permissionId);                      // 984
                    });                                                                                                //
                  })();                                                                                                //
                } else if (requirement.tokenValid) {                                                                   //
                  pushVertex("tokenValid", "t:" + requirement.tokenValid, "canAccess");                                // 987
                }                                                                                                      //
              });                                                                                                      //
            }                                                                                                          //
          }                                                                                                            //
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return { tokenIds: Object.keys(neededTokens), grainIds: Object.keys(visited) };                                  // 995
    }                                                                                                                  //
                                                                                                                       //
    return getResponsibleTokens;                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  return Context;                                                                                                      //
}();                                                                                                                   //
                                                                                                                       //
function computeRelevantTokens(context, grainId, vertexId) {                                                           // 999
  // Finds all tokens in `context` that could possibly carry permissions of the grain `grainId` to                     //
  // the vertex `vertexId` -- that is, all tokens that are contained in a path starting at the                         //
  // grain owner and ending at `vertexId`. Ignores any requirements that those tokens might be                         //
  // conditional upon.                                                                                                 //
  //                                                                                                                   //
  // Returns an object with two fields:                                                                                //
  //    tokenIds: list of relevant token IDs.                                                                          //
  //    ownerEdges: objects of the form { identityId: String, role: RoleAssignment }, representing                     //
  //                initial pseudo-edges in the graph. `identityId` is typically an identity of                        //
  //                the grain's owning user, but for the case of a legacy public grain it could                        //
  //                be any identity.                                                                                   //
  //                                                                                                                   //
  // Works by traversing the sharing graph twice: first backwards starting from `vertexId`, then                       //
  // forwards starting from the grain owner using only those tokens touched in the first step.                         //
  //                                                                                                                   //
  // `context` contains all the information from the database which is available for now. This call                    //
  // will not make any new database lookups; edges not listed in `context` will not be considered                      //
  // (as if they'd been revoked).                                                                                      //
                                                                                                                       //
  check(context, Context);                                                                                             // 1019
  check(grainId, String);                                                                                              // 1020
  check(vertexId, String);                                                                                             // 1021
                                                                                                                       //
  var grain = context.grains[grainId];                                                                                 // 1023
  if (!grain) return { tokenIds: [], ownerEdges: [] };                                                                 // 1024
  var viewInfo = grain.cachedViewInfo || {};                                                                           // 1025
  var ownerIdentityIds = context.userIdentityIds[grain.userId];                                                        // 1026
                                                                                                                       //
  var vertexStack = []; // Vertex IDs that we need to explore.                                                         // 1028
  var visitedVertexIds = {}; // Set of vertex IDs that we have already enqueued to get explored.                       // 999
                                                                                                                       //
  visitedVertexIds[vertexId] = true;                                                                                   // 999
  vertexStack.push(vertexId);                                                                                          // 1032
                                                                                                                       //
  var visitedTokensBySharerId = {};                                                                                    // 1034
  var ownerEdges = [];                                                                                                 // 1035
                                                                                                                       //
  // Repeatedly pop a vertex from the stack, find all its incoming edges (i.e. all other vertexes                      //
  // that share permissions to this vertex), and push those vertexes onto the stack.                                   //
                                                                                                                       // 999
  var _loop2 = function _loop2() {                                                                                     //
    var vertexId = vertexStack.pop();                                                                                  // 1040
                                                                                                                       //
    var incomingEdges = [];                                                                                            // 1042
    // List of edges in the sharing graph ending at this vertex. Each is an object with the fields:                    //
    //     sharerId: The vertex ID of the edge's source.                                                               //
    //     token: the token object backing this edge, if there is one.                                                 //
                                                                                                                       //
    function tokenToEdge(token) {                                                                                      // 1047
      // Convert an ApiToken into an edge.                                                                             //
      return {                                                                                                         // 1049
        token: token,                                                                                                  // 1050
        sharerId: token.parentToken ? "t:" + token.parentToken : "i:" + token.identityId                               // 1051
      };                                                                                                               //
    }                                                                                                                  //
                                                                                                                       //
    if (vertexId.slice(0, 2) === "o:") {                                                                               // 1055
      // Owner. We don't need to do anything.                                                                          //
      incomingEdges = [];                                                                                              // 1057
    } else if (vertexId.slice(0, 2) === "t:") {                                                                        //
      // A webkey token. Extract it from the context (or ignore if it isn't present).                                  //
      var _token = context.tokensById[vertexId.slice(2)];                                                              // 1060
      if (_token) {                                                                                                    // 1061
        incomingEdges = [tokenToEdge(_token)];                                                                         // 1062
      }                                                                                                                //
    } else if (vertexId.slice(0, 2) === "i:") {                                                                        //
      // An identity.                                                                                                  //
      var identityId = vertexId.slice(2);                                                                              // 1066
      if (ownerIdentityIds.indexOf(identityId) >= 0) {                                                                 // 1067
        // This is one of the owner's identities.                                                                      //
        incomingEdges = [{ sharerId: "o:Owner" }];                                                                     // 1069
        ownerEdges.push({ identityId: identityId, role: { allAccess: null } });                                        // 1070
      } else if (!grain["private"]) {                                                                                  //
        // This is a legacy "public" grain, meaning that any user who knows the grain ID receives                      //
        // the grain's default role. If the user doesn't know the grain ID then they are unable                        //
        // to express a request to open the grain in the first place and we'll never get to the                        //
        // point of this permissions computation, so for this purpose we can assume all users                          //
        // have the default role. (Similarly, a user who doesn't know the grain ID couldn't                            //
        // possibly be the subject of any MembraneRequirements against the grain because they                          //
        // have never interacted with the grain and so couldn't have caused such                                       //
        // MembraneRequiments to come about. Note that this is kind of shaky non-local reasoning,                      //
        // but literally no such legacy grain has been created since early 2015 and none will ever                     //
        // be created again, so it's not a huge deal.)                                                                 //
        incomingEdges = [{ sharerId: "o:Owner" }];                                                                     // 1082
        ownerEdges.push({ identityId: identityId, role: { none: null } });                                             // 1083
      } else {                                                                                                         //
        // Not a special case. Gather all tokens where this user is the recipient.                                     //
        incomingEdges = ((context.tokensByRecipient[grainId] || {})[vertexId.slice(2)] || []).map(tokenToEdge);        // 1086
      }                                                                                                                //
    } else {                                                                                                           //
      throw new Meteor.Error(500, "Unrecognized vertex ID: " + vertexId);                                              // 1090
    }                                                                                                                  //
                                                                                                                       //
    // For each edge incoming to this vertex, backpropagate this vertex's PermissionFlow to the                        //
    // source vertex, joining it with the edge's constraints.                                                          //
    incomingEdges.forEach(function (edge) {                                                                            // 1095
      var sharerId = edge.sharerId;                                                                                    // 1096
      if (edge.token) {                                                                                                // 1097
        if (!visitedTokensBySharerId[sharerId]) {                                                                      // 1098
          visitedTokensBySharerId[sharerId] = {};                                                                      // 1099
        }                                                                                                              //
                                                                                                                       //
        visitedTokensBySharerId[sharerId][edge.token._id] = edge.token;                                                // 1102
      }                                                                                                                //
                                                                                                                       //
      if (!visitedVertexIds[sharerId]) {                                                                               // 1105
        // Never saw this vertex before.                                                                               //
        visitedVertexIds[sharerId] = true;                                                                             // 1107
        vertexStack.push(sharerId);                                                                                    // 1108
      }                                                                                                                //
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  while (vertexStack.length > 0) {                                                                                     // 1039
    _loop2();                                                                                                          //
  }                                                                                                                    //
                                                                                                                       //
  // Now walk forward from the owner.                                                                                  //
  var relevantTokens = {};                                                                                             // 999
  var visitedSharers = {};                                                                                             // 1116
                                                                                                                       //
  var sharerStack = [];                                                                                                // 1118
  ownerIdentityIds.forEach(function (identityId) {                                                                     // 1119
    sharerStack.push("i:" + identityId);                                                                               // 1119
  });                                                                                                                  //
  while (sharerStack.length > 0) {                                                                                     // 1120
    var sharerId = sharerStack.pop();                                                                                  // 1121
    for (var tokenId in meteorBabelHelpers.sanitizeForInObject(visitedTokensBySharerId[sharerId])) {                   // 1122
      relevantTokens[tokenId] = true;                                                                                  // 1123
      var token = visitedTokensBySharerId[sharerId][tokenId];                                                          // 1124
      var recipientId = vertexIdOfTokenOwner(token);                                                                   // 1125
                                                                                                                       //
      if (!visitedSharers[recipientId]) {                                                                              // 1127
        visitedSharers[recipientId] = true;                                                                            // 1128
        sharerStack.push(recipientId);                                                                                 // 1129
      }                                                                                                                //
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  return {                                                                                                             // 1134
    tokenIds: Object.keys(relevantTokens),                                                                             // 1135
    ownerEdges: ownerEdges                                                                                             // 1136
  };                                                                                                                   //
}                                                                                                                      //
                                                                                                                       //
var vertexPattern = Match.OneOf({ token: Match.ObjectIncluding({ _id: String, grainId: String }) }, {                  // 1140
  grain: Match.ObjectIncluding({                                                                                       // 1143
    _id: String,                                                                                                       // 1144
    identityId: Match.OneOf(String, null, undefined)                                                                   // 1145
  })                                                                                                                   //
});                                                                                                                    //
// A vertex in the sharing graph is a principal, e.g. a user (identity) or a token. Complicating                       //
// matters, we may have to traverse sharing graphs for multiple grains in the same computation. A                      //
// token is specific to one grain, but a user of course can have access to multiple grains, so in                      //
// the case of a user we represent the vertex as a (user, grain) pair.                                                 //
//                                                                                                                     //
// TODO(cleanup): Perhaps `grain` should be renamed to `user` or `identity`? In the common case                        //
//   where only a single grain's shares need to be considered, it feels weird to think of the                          //
//   grain ID as being the primary distinguishing feature of the vertex.                                               //
                                                                                                                       //
SandstormPermissions.mayOpenGrain = function (db, vertex) {                                                            // 1158
  // Determines whether the vertex is allowed to open the grain. May make multiple database                            //
  // queries.                                                                                                          //
                                                                                                                       //
  check(vertex, vertexPattern);                                                                                        // 1162
  var grainId = vertex.token ? vertex.token.grainId : vertex.grain._id;                                                // 1163
  var vertexId = vertex.token ? "t:" + vertex.token._id : "i:" + vertex.grain.identityId;                              // 1164
  var context = new Context();                                                                                         // 1165
  var emptyPermissions = new PermissionSet([]);                                                                        // 1166
  return !!context.tryToProve(grainId, vertexId, emptyPermissions, db);                                                // 1167
};                                                                                                                     //
                                                                                                                       //
var CompoundObserveHandle = function () {                                                                              //
  function CompoundObserveHandle() {                                                                                   // 1171
    (0, _classCallCheck3["default"])(this, CompoundObserveHandle);                                                     //
                                                                                                                       //
    this._handles = [];                                                                                                // 1172
  }                                                                                                                    //
                                                                                                                       //
  CompoundObserveHandle.prototype.push = function () {                                                                 // 1170
    function push(handle) {                                                                                            //
      this._handles.push(handle);                                                                                      // 1176
    }                                                                                                                  //
                                                                                                                       //
    return push;                                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  CompoundObserveHandle.prototype.stop = function () {                                                                 // 1170
    function stop() {                                                                                                  //
      this._handles.forEach(function (handle) {                                                                        // 1180
        return handle.stop();                                                                                          //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return stop;                                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  return CompoundObserveHandle;                                                                                        //
}();                                                                                                                   //
                                                                                                                       //
SandstormPermissions.grainPermissions = function (db, vertex, viewInfo, onInvalidated) {                               // 1184
  // Computes the set of permissions received by `vertex`. Returns an object with a                                    //
  // `permissions` field containing the computed permissions. If the field is null then                                //
  // the `vertex` does not even have the base "allowed to access at all" permission.                                   //
  //                                                                                                                   //
  // `onInvalidated` is an optional callback. If provided, it will be called when the result                           //
  // has been invalidated. If `onValidated` is provided, the result of `grainPermissions` will                         //
  // have a `observeHandle` field, containing an object with a `stop()` method that must be                            //
  // called once the computation becomes so longer relevant.                                                           //
                                                                                                                       //
  check(db, SandstormDb);                                                                                              // 1194
  check(vertex, vertexPattern);                                                                                        // 1195
  var grainId = vertex.token ? vertex.token.grainId : vertex.grain._id;                                                // 1196
  var vertexId = vertex.token ? "t:" + vertex.token._id : "i:" + vertex.grain.identityId;                              // 1197
                                                                                                                       //
  var resultPermissions = void 0;                                                                                      // 1199
  var observeHandle = void 0;                                                                                          // 1200
  var onInvalidatedActive = false;                                                                                     // 1201
                                                                                                                       //
  var startTime = new Date();                                                                                          // 1203
  function measureElapsedTime(result) {                                                                                // 1204
    var elapsedMilliseconds = new Date() - startTime;                                                                  // 1205
    if (elapsedMilliseconds > 200) {                                                                                   // 1206
      console.log("Warning: SandstormPermissions.grainPermissions() took " + elapsedMilliseconds + " milliseconds to complete for the vertex " + JSON.stringify(vertex));
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  // Our computation proceeds in two phases. In the first, we determine which permissions the vertex                   //
  // appears to have and we compute set of tokens which appears to be sufficent to prove those                         //
  // permissions. However, concurrent database modifications may render the computation invalid, so                    //
  // in the second phases we verify that our proof is still valid and arrange for onInvalidated                        //
  // to be called when necessary. This is an optimisistic approach to concurrency. If the                              //
  // verification phase fails, we try again before giving up entirely.                                                 //
                                                                                                                       // 1184
  var _loop3 = function _loop3(attemptCount) {                                                                         //
    if (observeHandle) {                                                                                               // 1219
      observeHandle.stop();                                                                                            // 1220
      observeHandle = null;                                                                                            // 1221
    }                                                                                                                  //
                                                                                                                       //
    var context = new Context();                                                                                       // 1224
    var allPermissions = PermissionSet.fromRoleAssignment({ allAccess: null }, viewInfo);                              // 1225
    var firstPhasePermissions = context.tryToProve(grainId, vertexId, allPermissions, db);                             // 1226
                                                                                                                       //
    if (!firstPhasePermissions) return {                                                                               // 1228
        v: { permissions: null }                                                                                       //
      };                                                                                                               //
                                                                                                                       //
    var needed = context.getResponsibleTokens(grainId, vertexId);                                                      // 1230
    var neededTokens = needed.tokenIds;                                                                                // 1231
    var neededGrains = needed.grainIds;                                                                                // 1232
                                                                                                                       //
    // Phase 2: Now let's verify those permissions.                                                                    //
                                                                                                                       //
    context.reset();                                                                                                   // 1236
                                                                                                                       //
    var invalidated = false;                                                                                           // 1238
    function guardedOnInvalidated() {                                                                                  // 1239
      var shouldCall = onInvalidatedActive && !invalidated;                                                            // 1240
      invalidated = true;                                                                                              // 1241
      if (shouldCall) {                                                                                                // 1242
        onInvalidated();                                                                                               // 1243
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    var tokenCursor = db.collections.apiTokens.find({                                                                  // 1247
      _id: { $in: neededTokens },                                                                                      // 1248
      revoked: { $ne: true },                                                                                          // 1249
      objectId: { $exists: false }                                                                                     // 1250
    });                                                                                                                //
                                                                                                                       //
    if (onInvalidated) {                                                                                               // 1253
      observeHandle = new CompoundObserveHandle();                                                                     // 1254
      observeHandle.push(tokenCursor.observe({                                                                         // 1255
        changed: function () {                                                                                         // 1256
          function changed(newApiToken, oldApiToken) {                                                                 //
            if (newApiToken.trashed || !_.isEqual(newApiToken.roleAssignment, oldApiToken.roleAssignment) || !_.isEqual(newApiToken.revoked, oldApiToken.revoked)) {
              observeHandle.stop();                                                                                    // 1260
              guardedOnInvalidated();                                                                                  // 1261
            }                                                                                                          //
          }                                                                                                            //
                                                                                                                       //
          return changed;                                                                                              //
        }(),                                                                                                           //
        removed: function () {                                                                                         // 1265
          function removed(oldApiToken) {                                                                              //
            observeHandle.stop();                                                                                      // 1266
            guardedOnInvalidated();                                                                                    // 1267
          }                                                                                                            //
                                                                                                                       //
          return removed;                                                                                              //
        }()                                                                                                            //
      }));                                                                                                             //
                                                                                                                       //
      var grainCursor = db.collections.grains.find({ _id: { $in: neededGrains } });                                    // 1271
      observeHandle.push(grainCursor.observe({                                                                         // 1272
        changed: function () {                                                                                         // 1273
          function changed(newGrain, oldGrain) {                                                                       //
            if (newGrain.trashed || !oldGrain["private"] && newGrain["private"]) {                                     // 1274
              observeHandle.stop();                                                                                    // 1277
              guardedOnInvalidated();                                                                                  // 1278
            }                                                                                                          //
          }                                                                                                            //
                                                                                                                       //
          return changed;                                                                                              //
        }(),                                                                                                           //
        removed: function () {                                                                                         // 1282
          function removed(oldGrain) {                                                                                 //
            observeHandle.stop();                                                                                      // 1283
            guardedOnInvalidated();                                                                                    // 1284
          }                                                                                                            //
                                                                                                                       //
          return removed;                                                                                              //
        }()                                                                                                            //
      }));                                                                                                             //
    }                                                                                                                  //
                                                                                                                       //
    context.addTokensFromCursor(tokenCursor);                                                                          // 1289
                                                                                                                       //
    // TODO(someday): Also account for linking/unlinking of identities and accounts losing admin                       //
    //   privileges. Currently we do not call `onInvalided()` on such events. We would need to set                     //
    //   up more cursor observers.                                                                                     //
                                                                                                                       //
    resultPermissions = context.tryToProve(grainId, vertexId, firstPhasePermissions);                                  // 1295
                                                                                                                       //
    if (resultPermissions && firstPhasePermissions.isSubsetOf(resultPermissions)) {                                    // 1297
      // We've confirmed the permissions that we found the in the first phase. Done!                                   //
      return "break";                                                                                                  // 1299
    }                                                                                                                  //
  };                                                                                                                   //
                                                                                                                       //
  _loop4: for (var attemptCount = 0; attemptCount < 3; ++attemptCount) {                                               //
    var _ret5 = _loop3(attemptCount);                                                                                  //
                                                                                                                       //
    switch (_ret5) {                                                                                                   //
      case "break":                                                                                                    //
        break _loop4;                                                                                                  // 1299
                                                                                                                       //
      default:                                                                                                         //
        if ((typeof _ret5 === "undefined" ? "undefined" : (0, _typeof3["default"])(_ret5)) === "object") return _ret5.v;
    }                                                                                                                  //
  } // for (let attemptCount ...) {                                                                                    //
                                                                                                                       //
  onInvalidatedActive = true;                                                                                          // 1184
  var result = {};                                                                                                     // 1304
  if (resultPermissions) result.permissions = resultPermissions.array;                                                 // 1305
  if (observeHandle) result.observeHandle = observeHandle;                                                             // 1306
  measureElapsedTime();                                                                                                // 1307
  return result;                                                                                                       // 1308
};                                                                                                                     //
                                                                                                                       //
SandstormPermissions.downstreamTokens = function (db, root) {                                                          // 1311
  // Computes a list of the UiView tokens that are downstream in the sharing graph from a given                        //
  // source. The source, `root`, can either be a token or a (grain, user) pair. The exact format                       //
  // of `root` is specified in the `check()` invocation below.                                                         //
  //                                                                                                                   //
  // TODO(someday): Account for membrane requirements in this computation.                                             //
                                                                                                                       //
  check(root, Match.OneOf({ token: Match.ObjectIncluding({ _id: String, grainId: String }) }, { grain: Match.ObjectIncluding({ _id: String, identityId: String }) }));
                                                                                                                       //
  var result = [];                                                                                                     // 1321
  var tokenStack = [];                                                                                                 // 1322
  var stackedTokens = {};                                                                                              // 1323
  var tokensBySharer = {};                                                                                             // 1324
  var tokensByParent = {};                                                                                             // 1325
  var tokensById = {};                                                                                                 // 1326
                                                                                                                       //
  function addChildren(tokenId) {                                                                                      // 1328
    var children = tokensByParent[tokenId];                                                                            // 1329
    if (children) {                                                                                                    // 1330
      children.forEach(function (child) {                                                                              // 1331
        if (!stackedTokens[child._id]) {                                                                               // 1332
          tokenStack.push(child);                                                                                      // 1333
          stackedTokens[child._id] = true;                                                                             // 1334
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  function addSharedTokens(sharer) {                                                                                   // 1340
    var sharedTokens = tokensBySharer[sharer];                                                                         // 1341
    if (sharedTokens) {                                                                                                // 1342
      sharedTokens.forEach(function (sharedToken) {                                                                    // 1343
        if (!stackedTokens[sharedToken._id]) {                                                                         // 1344
          tokenStack.push(sharedToken);                                                                                // 1345
          stackedTokens[sharedToken._id] = true;                                                                       // 1346
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  var grainId = root.token ? root.token.grainId : root.grain._id;                                                      // 1352
  var grain = db.getGrain(grainId);                                                                                    // 1353
  if (!grain || !grain["private"]) {                                                                                   // 1354
    return result;                                                                                                     // 1354
  }                                                                                                                    //
                                                                                                                       //
  db.collections.apiTokens.find({ grainId: grainId,                                                                    // 1356
    revoked: { $ne: true } }).forEach(function (token) {                                                               // 1357
    tokensById[token._id] = token;                                                                                     // 1358
    if (token.parentToken) {                                                                                           // 1359
      if (!tokensByParent[token.parentToken]) {                                                                        // 1360
        tokensByParent[token.parentToken] = [];                                                                        // 1361
      }                                                                                                                //
                                                                                                                       //
      tokensByParent[token.parentToken].push(token);                                                                   // 1364
    } else if (token.identityId) {                                                                                     //
      if (!tokensBySharer[token.identityId]) {                                                                         // 1366
        tokensBySharer[token.identityId] = [];                                                                         // 1367
      }                                                                                                                //
                                                                                                                       //
      tokensBySharer[token.identityId].push(token);                                                                    // 1370
    }                                                                                                                  //
  });                                                                                                                  //
                                                                                                                       //
  if (root.token) {                                                                                                    // 1374
    addChildren(root.token._id);                                                                                       // 1375
  } else if (root.grain) {                                                                                             //
    addSharedTokens(root.grain.identityId);                                                                            // 1377
  }                                                                                                                    //
                                                                                                                       //
  while (tokenStack.length > 0) {                                                                                      // 1380
    var token = tokenStack.pop();                                                                                      // 1381
    result.push(token);                                                                                                // 1382
    addChildren(token._id);                                                                                            // 1383
    if (token.owner && token.owner.user) {                                                                             // 1384
      addSharedTokens(token.owner.user.identityId);                                                                    // 1385
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  return result;                                                                                                       // 1389
};                                                                                                                     //
                                                                                                                       //
var HeaderSafeString = Match.Where(function (str) {                                                                    // 1392
  check(str, String);                                                                                                  // 1393
  return str.match(/^[\x20-\x7E]*$/);                                                                                  // 1394
});                                                                                                                    //
                                                                                                                       //
var DavClass = Match.Where(function (str) {                                                                            // 1397
  check(str, String);                                                                                                  // 1398
  return str.match(/^[a-zA-Z0-9!#$%&'*+.^_`|~-]+$/) || str.match(/^<[\x21-\x7E]*>$/); // supposed to be a URL          // 1399
});                                                                                                                    // 1397
                                                                                                                       //
var ResourceMap = Match.Where(function (map) {                                                                         // 1403
  for (path in meteorBabelHelpers.sanitizeForInObject(map)) {                                                          // 1404
    if (!path.match(/^\/[\x21-\x7E]*$/)) {                                                                             // 1405
      return false;                                                                                                    // 1406
    }                                                                                                                  //
                                                                                                                       //
    check(map[path], {                                                                                                 // 1409
      type: HeaderSafeString,                                                                                          // 1410
      language: Match.Optional(HeaderSafeString),                                                                      // 1411
      encoding: Match.Optional(HeaderSafeString),                                                                      // 1412
      body: String                                                                                                     // 1413
    });                                                                                                                //
  }                                                                                                                    //
                                                                                                                       //
  return true;                                                                                                         // 1417
});                                                                                                                    //
                                                                                                                       //
var LocalizedString = {                                                                                                // 1420
  defaultText: String,                                                                                                 // 1421
  localizations: Match.Optional([{ locale: String, text: String }])                                                    // 1422
};                                                                                                                     //
                                                                                                                       //
SandstormPermissions.createNewApiToken = function (db, provider, grainId, petname, roleAssignment, owner, unauthenticated) {
  // Creates a new UiView API token. If `rawParentToken` is set, creates a child token.                                //
  check(grainId, String);                                                                                              // 1430
  check(petname, String);                                                                                              // 1431
  check(roleAssignment, db.roleAssignmentPattern);                                                                     // 1432
  // Meteor bug #3877: we get null here instead of undefined when we                                                   //
  // explicitly pass in undefined.                                                                                     //
  check(provider, Match.OneOf({ identityId: String, accountId: String }, { rawParentToken: Match.OneOf(String, Buffer) }));
  check(owner, Match.OneOf({                                                                                           // 1437
    webkey: Match.OneOf(null, {                                                                                        // 1438
      forSharing: Boolean,                                                                                             // 1439
      expiresIfUnusedDuration: Match.Optional(Number)                                                                  // 1440
    })                                                                                                                 //
  }, {                                                                                                                 //
    user: {                                                                                                            // 1443
      identityId: String,                                                                                              // 1444
      title: String,                                                                                                   // 1445
      renamed: Match.Optional(Boolean),                                                                                // 1446
      upstreamTitle: Match.Optional(String)                                                                            // 1447
    }                                                                                                                  //
  }, {                                                                                                                 //
    grain: {                                                                                                           // 1450
      grainId: String,                                                                                                 // 1451
      saveLabel: LocalizedString,                                                                                      // 1452
      introducerIdentity: String                                                                                       // 1453
    }                                                                                                                  //
  }, {                                                                                                                 //
    frontend: null                                                                                                     // 1456
  }));                                                                                                                 //
                                                                                                                       //
  check(unauthenticated, Match.OneOf(undefined, null, {                                                                // 1459
    options: Match.Optional({ dav: [Match.Optional(DavClass)] }),                                                      // 1460
    resources: Match.Optional(ResourceMap)                                                                             // 1461
  }));                                                                                                                 //
                                                                                                                       //
  if (unauthenticated && JSON.stringify(unauthenticated).length > 4096) {                                              // 1464
    throw new Meteor.Error(400, "Unauthenticated params too large; limit 4kb.");                                       // 1465
  }                                                                                                                    //
                                                                                                                       //
  var grain = db.getGrain(grainId);                                                                                    // 1468
  if (!grain) {                                                                                                        // 1469
    throw new Meteor.Error(403, "Unauthorized", "No grain found.");                                                    // 1470
  }                                                                                                                    //
                                                                                                                       //
  var token = Random.secret();                                                                                         // 1473
  var apiToken = {                                                                                                     // 1474
    _id: Crypto.createHash("sha256").update(token).digest("base64"),                                                   // 1475
    grainId: grainId,                                                                                                  // 1476
    roleAssignment: roleAssignment,                                                                                    // 1477
    petname: petname,                                                                                                  // 1478
    created: new Date(),                                                                                               // 1479
    expires: null                                                                                                      // 1480
  };                                                                                                                   //
                                                                                                                       //
  var result = {};                                                                                                     // 1483
  var parentForSharing = false;                                                                                        // 1484
  if (provider.rawParentToken) {                                                                                       // 1485
    var parentToken = Crypto.createHash("sha256").update(provider.rawParentToken).digest("base64");                    // 1486
    var parentApiToken = db.collections.apiTokens.findOne({ _id: parentToken, grainId: grainId, objectId: { $exists: false } });
    if (!parentApiToken) {                                                                                             // 1489
      throw new Meteor.Error(403, "No such parent token found.");                                                      // 1490
    }                                                                                                                  //
                                                                                                                       //
    if (parentApiToken.forSharing) {                                                                                   // 1493
      parentForSharing = true;                                                                                         // 1494
    }                                                                                                                  //
                                                                                                                       //
    apiToken.identityId = parentApiToken.identityId;                                                                   // 1497
    apiToken.accountId = parentApiToken.accountId;                                                                     // 1498
                                                                                                                       //
    apiToken.parentToken = parentToken;                                                                                // 1500
    result.parentApiToken = parentApiToken;                                                                            // 1501
  } else if (provider.identityId) {                                                                                    //
    apiToken.identityId = provider.identityId;                                                                         // 1503
    apiToken.accountId = provider.accountId;                                                                           // 1504
  }                                                                                                                    //
                                                                                                                       //
  if (owner.webkey) {                                                                                                  // 1507
    // Non-null webkey is a special case not covered in ApiTokenOwner.                                                 //
    // TODO(cleanup): Maybe ApiTokenOwner.webkey should be extended with these fields?                                 //
    apiToken.owner = { webkey: null };                                                                                 // 1510
    apiToken.forSharing = parentForSharing || owner.webkey.forSharing;                                                 // 1511
    if (owner.webkey.expiresIfUnusedDuration) {                                                                        // 1512
      apiToken.expiresIfUnused = new Date(Date.now() + owner.webkey.expiresIfUnusedDuration);                          // 1513
    }                                                                                                                  //
  } else if (owner.user) {                                                                                             //
    var grainInfo = db.getDenormalizedGrainInfo(grainId);                                                              // 1516
    apiToken.owner = {                                                                                                 // 1517
      user: {                                                                                                          // 1518
        identityId: owner.user.identityId,                                                                             // 1519
        title: owner.user.title,                                                                                       // 1520
        denormalizedGrainMetadata: grainInfo                                                                           // 1521
      }                                                                                                                //
    };                                                                                                                 //
                                                                                                                       //
    if (grain.title !== owner.user.title) {                                                                            // 1525
      apiToken.owner.user.upstreamTitle = grain.title;                                                                 // 1526
    }                                                                                                                  //
  } else {                                                                                                             //
    // Note: Also covers the case of `webkey: null`.                                                                   //
    apiToken.owner = owner;                                                                                            // 1530
  }                                                                                                                    //
                                                                                                                       //
  if (unauthenticated) {                                                                                               // 1533
    var apiHost = {                                                                                                    // 1534
      _id: db.apiHostIdHashForToken(token),                                                                            // 1535
      hash2: Crypto.createHash("sha256").update(apiToken._id).digest("base64")                                         // 1536
    };                                                                                                                 //
    if (unauthenticated.options) {                                                                                     // 1538
      apiHost.options = unauthenticated.options;                                                                       // 1539
    }                                                                                                                  //
                                                                                                                       //
    if (unauthenticated.resources) {                                                                                   // 1542
      // Mongo requires keys in objects to be escaped. Ugh.                                                            //
      apiHost.resources = {};                                                                                          // 1544
      for (var key in meteorBabelHelpers.sanitizeForInObject(unauthenticated.resources)) {                             // 1545
        apiHost.resources[SandstormDb.escapeMongoKey(key)] = unauthenticated.resources[key];                           // 1546
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    db.collections.apiHosts.insert(apiHost);                                                                           // 1550
    apiToken.hasApiHost = true;                                                                                        // 1551
  }                                                                                                                    //
                                                                                                                       //
  db.collections.apiTokens.insert(apiToken);                                                                           // 1554
                                                                                                                       //
  result.id = apiToken._id;                                                                                            // 1556
  result.token = token;                                                                                                // 1557
  return result;                                                                                                       // 1558
};                                                                                                                     //
                                                                                                                       //
// Make self-destructing tokens actually self-destruct, so they don't                                                  //
// clutter the token list view.                                                                                        //
SandstormPermissions.cleanupSelfDestructing = function (db) {                                                          // 1563
  return function () {                                                                                                 // 1564
    var now = new Date();                                                                                              // 1565
    db.removeApiTokens({ expiresIfUnused: { $lt: now } });                                                             // 1566
  };                                                                                                                   //
};                                                                                                                     //
                                                                                                                       //
Meteor.methods({                                                                                                       // 1570
  transitiveShares: function () {                                                                                      // 1571
    function transitiveShares(identityId, grainId) {                                                                   // 1571
      check(identityId, String);                                                                                       // 1572
      check(grainId, String);                                                                                          // 1573
      if (this.userId) {                                                                                               // 1574
        var db = this.connection.sandstormDb;                                                                          // 1575
        return SandstormPermissions.downstreamTokens(db, { grain: { _id: grainId, identityId: identityId } });         // 1576
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return transitiveShares;                                                                                           //
  }(),                                                                                                                 //
                                                                                                                       //
  newApiToken: function () {                                                                                           // 1581
    function newApiToken(provider, grainId, petname, roleAssignment, owner, unauthenticated) {                         // 1581
      check(provider, Match.OneOf({ identityId: String }, { rawParentToken: String }));                                // 1582
      // other check()s happen in SandstormPermissions.createNewApiToken().                                            //
      var db = this.connection.sandstormDb;                                                                            // 1581
      if (provider.identityId) {                                                                                       // 1585
        if (!this.userId || !db.userHasIdentity(this.userId, provider.identityId)) {                                   // 1586
          throw new Meteor.Error(403, "Not an identity of the current user: " + provider.identityId);                  // 1587
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      if (provider.identityId) {                                                                                       // 1591
        provider.accountId = this.userId;                                                                              // 1592
      }                                                                                                                //
                                                                                                                       //
      return SandstormPermissions.createNewApiToken(this.connection.sandstormDb, provider, grainId, petname, roleAssignment, owner, unauthenticated);
    }                                                                                                                  //
                                                                                                                       //
    return newApiToken;                                                                                                //
  }(),                                                                                                                 //
                                                                                                                       //
  updateApiToken: function () {                                                                                        // 1600
    function updateApiToken(token, newFields) {                                                                        // 1600
      var db = this.connection.sandstormDb;                                                                            // 1601
                                                                                                                       //
      check(token, String);                                                                                            // 1603
      check(newFields, { petname: Match.Optional(String),                                                              // 1604
        roleAssignment: Match.Optional(db.roleAssignmentPattern),                                                      // 1605
        revoked: Match.Optional(Boolean) });                                                                           // 1606
                                                                                                                       //
      if (!this.userId) {                                                                                              // 1608
        throw new Meteor.Error(403, "Must be logged in to modify a token");                                            // 1609
      }                                                                                                                //
                                                                                                                       //
      var apiToken = db.collections.apiTokens.findOne(token);                                                          // 1612
      if (!apiToken) {                                                                                                 // 1613
        throw new Meteor.Error(404, "No such token found.");                                                           // 1614
      }                                                                                                                //
                                                                                                                       //
      if (db.userHasIdentity(this.userId, apiToken.identityId)) {                                                      // 1617
        var modifier = { $set: newFields };                                                                            // 1618
        db.collections.apiTokens.update(token, modifier);                                                              // 1619
      } else {                                                                                                         //
        throw new Meteor.Error(403, "User not authorized to modify this token.");                                      // 1621
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return updateApiToken;                                                                                             //
  }()                                                                                                                  //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-permissions/permissions.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-permissions'] = {}, {
  SandstormPermissions: SandstormPermissions
});

})();

//# sourceMappingURL=sandstorm-permissions.js.map
