(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var MongoInternals = Package.mongo.MongoInternals;
var Mongo = Package.mongo.Mongo;
var Random = Package.random.Random;
var check = Package.check.check;
var Match = Package.check.Match;
var _ = Package.underscore._;
var Accounts = Package['accounts-base'].Accounts;
var HTTP = Package.http.HTTP;
var HTTPInternals = Package.http.HTTPInternals;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var Packages, DevPackages, UserActions, Grains, RoleAssignments, Contacts, Sessions, SignupKeys, ActivityStats, DeleteStats, FileTokens, ApiTokens, ApiHosts, Notifications, StatsTokens, Misc, Settings, Migrations, StaticAssets, AssetUploadTokens, Plans, AppIndex, KeybaseProfiles, FeatureKey, SetupSession, successfulReferralsCount, getUserQuota, isUserOverQuota, isUserExcessivelyOverQuota, isAdmin, isAdminById, findAdminUserForToken, matchWildcardHost, makeWildcardHost, getWildcardOrigin, allowDevAccounts, sendReferralProgramNotification, roleAssignmentPattern, SandstormDb, appName, addStaticAsset, userPictureUrl, fetchPicture;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-db":{"db.js":["babel-runtime/helpers/typeof",function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sandstorm-db/db.js                                                                                        //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
var _typeof2 = require("babel-runtime/helpers/typeof");                                                               //
                                                                                                                      //
var _typeof3 = _interopRequireDefault(_typeof2);                                                                      //
                                                                                                                      //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                     //
                                                                                                                      //
// Sandstorm - Personal Cloud Sandbox                                                                                 //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                              //
// All rights reserved.                                                                                               //
//                                                                                                                    //
// Licensed under the Apache License, Version 2.0 (the "License");                                                    //
// you may not use this file except in compliance with the License.                                                   //
// You may obtain a copy of the License at                                                                            //
//                                                                                                                    //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                       //
//                                                                                                                    //
// Unless required by applicable law or agreed to in writing, software                                                //
// distributed under the License is distributed on an "AS IS" BASIS,                                                  //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                           //
// See the License for the specific language governing permissions and                                                //
// limitations under the License.                                                                                     //
                                                                                                                      //
// This file defines the database schema.                                                                             //
                                                                                                                      //
// Useful for debugging: Set the env variable LOG_MONGO_QUERIES to have the server write every                        //
// query it makes, so you can see if it's doing queries too often, etc.                                               //
if (Meteor.isServer && process.env.LOG_MONGO_QUERIES) {                                                               // 21
  (function () {                                                                                                      //
    var oldFind = Mongo.Collection.prototype.find;                                                                    // 22
    Mongo.Collection.prototype.find = function () {                                                                   // 23
      console.log(this._prefix, arguments);                                                                           // 24
      return oldFind.apply(this, arguments);                                                                          // 25
    };                                                                                                                //
  })();                                                                                                               //
}                                                                                                                     //
                                                                                                                      //
// Helper so that we don't have to if (Meteor.isServer) before declaring indexes.                                     //
if (Meteor.isServer) {                                                                                                // 30
  Mongo.Collection.prototype.ensureIndexOnServer = Mongo.Collection.prototype._ensureIndex;                           // 31
} else {                                                                                                              //
  Mongo.Collection.prototype.ensureIndexOnServer = function () {};                                                    // 33
}                                                                                                                     //
                                                                                                                      //
// TODO(soon): Systematically go through this file and add ensureIndexOnServer() as needed.                           //
                                                                                                                      //
// Users = new Mongo.Collection("users");                                                                             //
// The users collection is special and can be accessed through `Meteor.users`.                                        //
// See https://docs.meteor.com/#/full/meteor_users.                                                                   //
//                                                                                                                    //
// There are two distinct types of entries in the users collection: identities and accounts. An                       //
// identity contains personal profile information and typically includes some intrinsic method for                    //
// authenticating as the owner of that information.                                                                   //
//                                                                                                                    //
// An account is an owner of app actions, grains, contacts, notifications, and payment info.                          //
// Each account can have multiple identities linked to it. To log in as an account you must first                     //
// authenticate as one of its linked identities.                                                                      //
//                                                                                                                    //
// Every user contains the following fields:                                                                          //
//   _id: Unique string ID. For accounts, this is random. For identities, this is the globally                        //
//        stable SHA-256 ID of this identity, hex-encoded.                                                            //
//   createdAt: Date when this entry was added to the collection.                                                     //
//   lastActive: Date of the user's most recent interaction with this Sandstorm server.                               //
//   services: Object containing login data used by Meteor authentication services.                                   //
//   expires: Date when this user should be deleted. Only present for demo users.                                     //
//   upgradedFromDemo: If present, the date when this user was upgraded from being a demo user.                       //
//                     TODO(cleanup): Unlike other dates in our database, this is stored as a number                  //
//                     rather than as a Date object. We should fix that.                                              //
//   appDemoId: If present and non-null, then the user is a demo user who arrived via an /appdemo/                    //
//              link. This field contains the app ID of the app that the user started out demoing.                    //
//              Unlike the `expires` field, this field is not cleared when the user upgrades from                     //
//              being a demo user.                                                                                    //
//                                                                                                                    //
// Identity users additionally contain the following fields:                                                          //
//   profile: Object containing the data that will be shared with users and grains that come into                     //
//            contact with this identity. Includes the following fields:                                              //
//       service: String containing the name of this identity's authentication method.                                //
//       name: String containing the chosen display name of the identity.                                             //
//       handle: String containing the identity's preferred handle.                                                   //
//       picture: _id into the StaticAssets table for the identity's picture. If not present,                         //
//                an identicon will be used.                                                                          //
//       pronoun: One of "male", "female", "neutral", or "robot".                                                     //
//   unverifiedEmail: If present, a string containing an email address specified by the user.                         //
//   referredBy: ID of the Account that referred this Identity.                                                       //
//                                                                                                                    //
// Account users additionally contain the following fields:                                                           //
//   loginIdentities: Array of identity objects, each of which may include the following fields.                      //
//       id: The globally-stable SHA-256 ID of this identity, hex-encoded.                                            //
//   nonloginIdentities: Array of identity objects, of the same form as `loginIdentities`. We use                     //
//                       a separate array here so that we can use a Mongo index to enforce the                        //
//                       invariant that an identity only be a login identity for a single account.                    //
//   primaryEmail: String containing this account's primary email address. Must be a verified adress                  //
//                 of one of this account's linked identities. Call SandstormDb.getUserEmails()                       //
//                 to do this checking automatically.                                                                 //
//   isAdmin: Boolean indicating whether this account is allowed to access the Sandstorm admin panel.                 //
//   signupKey: If this is an invited user, then this field contains their signup key.                                //
//   signupNote: If the user was invited through a link, then this field contains the note that the                   //
//               inviter admin attached to the key.                                                                   //
//   signupEmail: If the user was invited by email, then this field contains the email address that                   //
//                the invite was sent to.                                                                             //
//   hasCompletedSignup: True if this account has confirmed its profile and agreed to this server's                   //
//                       terms of service.                                                                            //
//   plan: _id of an entry in the Plans table which determines the user's quota.                                      //
//   planBonus: {storage, compute, grains} bonus amounts to add to the user's plan. The payments                      //
//              module writes data here; we merely read it. Missing fields should be treated as                       //
//              zeroes. Does not yet include referral bonus, which is calculated separately.                          //
//              TODO(cleanup): Use for referral bonus too.                                                            //
//   storageUsage: Number of bytes this user is currently storing.                                                    //
//   payments: Object defined by payments module, if loaded.                                                          //
//   dailySentMailCount: Number of emails sent by this user today; used to limit spam.                                //
//   accessRequests: Object containing the following fields; used to limit spam.                                      //
//       count: Number of "request access" emails during sent during the current interval.                            //
//       resetOn: Date when the count should be reset.                                                                //
//   referredByComplete: ID of the Account that referred this Account. If this is set, we                             //
//                        stop writing new referredBy values onto Identities for this account.                        //
//   referredCompleteDate: The Date at which the completed referral occurred.                                         //
//   referredIdentityIds: List of Identity IDs that this Account has referred. This is used for                       //
//                        reliably determining which Identity's names are safe to display.                            //
//   experiments: Object where each field is an experiment that the user is in, and each value                        //
//           is the parameters for that experiment. Typically, the value simply names which                           //
//           experiment group which the user is in, where "control" is one group. If an experiment                    //
//           is not listed, then the user should not be considered at all for the purpose of that                     //
//           experiment. Each experiment may define a point in time where users not already in the                    //
//           experiment may be added to it and assigned to a group (for example, at user creation                     //
//           time). Current experiments:                                                                              //
//       firstTimeBillingPrompt: Value is "control" or "test". Users are assigned to groups at                        //
//               account creation on servers where billing is enabled (i.e. Oasis). Users in the                      //
//               test group will see a plan selection dialog and asked to make an explitic choice                     //
//               (possibly "free") before they can create grains (but not when opening someone                        //
//               else's shared grain). The goal of the experiment is to determine whether this                        //
//               prompt scares users away -- and also whether it increases paid signups.                              //
//   stashedOldUser: A complete copy of this user from before the accounts/identities migration.                      //
//                   TODO(cleanup): Delete this field once we're sure it's safe to do so.                             //
                                                                                                                      //
Meteor.users.ensureIndexOnServer("services.google.email", { sparse: 1 });                                             // 126
Meteor.users.ensureIndexOnServer("services.github.emails.email", { sparse: 1 });                                      // 127
Meteor.users.ensureIndexOnServer("services.email.email", { unique: 1, sparse: 1 });                                   // 128
Meteor.users.ensureIndexOnServer("loginIdentities.id", { unique: 1, sparse: 1 });                                     // 129
Meteor.users.ensureIndexOnServer("nonloginIdentities.id", { sparse: 1 });                                             // 130
Meteor.users.ensureIndexOnServer("services.google.id", { unique: 1, sparse: 1 });                                     // 131
Meteor.users.ensureIndexOnServer("services.github.id", { unique: 1, sparse: 1 });                                     // 132
                                                                                                                      //
// TODO(cleanup): This index is obsolete; delete it.                                                                  //
Meteor.users.ensureIndexOnServer("identities.id", { unique: 1, sparse: 1 });                                          // 135
                                                                                                                      //
Packages = new Mongo.Collection("packages");                                                                          // 137
// Packages which are installed or downloading.                                                                       //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:  128-bit prefix of SHA-256 hash of spk file, hex-encoded.                                                   //
//   status:  String.  One of "download", "verify", "unpack", "analyze", "ready", "failed", "delete"                  //
//   progress:  Float.  -1 = N/A, 0-1 = fractional progress (e.g. download percentage),                               //
//       >1 = download byte count.                                                                                    //
//   error:  If status is "failed", error message string.                                                             //
//   manifest:  If status is "ready", the package manifest.  See "Manifest" in package.capnp.                         //
//   appId:  If status is "ready", the application ID string.  Packages representing different                        //
//       versions of the same app have the same appId.  The spk tool defines the app ID format                        //
//       and can cryptographically verify that a package belongs to a particular app ID.                              //
//   shouldCleanup:  If true, a reference to this package was recently dropped, and the package                       //
//       collector should at some point check whether there are any other references and, if not,                     //
//       delete the package.                                                                                          //
//   url:  When status is "download", the URL from which the SPK can be obtained, if provided.                        //
//   isAutoUpdated: This package was downloaded as part of an auto-update. We shouldn't clean it up                   //
//     even if it has no users.                                                                                       //
//   authorPgpKeyFingerprint: Verified PGP key fingerprint (SHA-1, hex, all-caps) of the app                          //
//     packager.                                                                                                      //
                                                                                                                      //
DevPackages = new Mongo.Collection("devpackages");                                                                    // 159
// List of packages currently made available via the dev tools running on the local machine.                          //
// This is normally empty; the only time it is non-empty is when a developer is using the spk tool                    //
// on the local machine to publish an under-development app to this server. That should only ever                     //
// happen on developers' desktop machines.                                                                            //
//                                                                                                                    //
// While a dev package is published, it automatically appears as installed by every user of the                       //
// server, and it overrides all packages with the same application ID. If any instances of those                      //
// packages are currently open, they are killed and reset on publish.                                                 //
//                                                                                                                    //
// When the dev tool disconnects, the package is automatically unpublished, and any open instances                    //
// are again killed and refreshed.                                                                                    //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:  The package ID string (as with Packages._id).                                                              //
//   appId: The app ID this package is intended to override (as with Packages.appId).                                 //
//   timestamp:  Time when the package was last updated. If this changes while the package is                         //
//     published, all running instances are reset. This is used e.g. to reset the app each time                       //
//     changes are made to the source code.                                                                           //
//   manifest:  The app's manifest, as with Packages.manifest.                                                        //
                                                                                                                      //
UserActions = new Mongo.Collection("userActions");                                                                    // 180
// List of actions that each user has installed which create new grains.  Each app may install                        //
// some number of actions (usually, one).                                                                             //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:  random                                                                                                     //
//   userId:  User who has installed this action.                                                                     //
//   packageId:  Package used to run this action.                                                                     //
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                               //
//   appTitle:  Same as Packages.findOne(packageId).manifest.appTitle; denormalized so                                //
//       that clients can access it without subscribing to the Packages collection.                                   //
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                           //
//       searchability.                                                                                               //
//   appMarketingVersion:  Human-readable presentation of the app version, e.g. "2.9.17"                              //
//   title: JSON-encoded LocalizedText title for this action, e.g.                                                    //
//       `{defaultText: "New Spreadsheet"}`.                                                                          //
//   nounPhrase: JSON-encoded LocalizedText describing what is created when this action is run.                       //
//   command:  Manifest.Command to run this action (see package.capnp).                                               //
                                                                                                                      //
Grains = new Mongo.Collection("grains");                                                                              // 199
// Grains belonging to users.                                                                                         //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:  random                                                                                                     //
//   packageId:  _id of the package of which this grain is an instance.                                               //
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                               //
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                           //
//       searchability.                                                                                               //
//   userId: The _id of the account that owns this grain.                                                             //
//   identityId: The identity with which the owning account prefers to open this grain.                               //
//   title:  Human-readable string title, as chosen by the user.                                                      //
//   lastUsed:  Date when the grain was last used by a user.                                                          //
//   private: If true, then knowledge of `_id` does not suffice to open this grain.                                   //
//   cachedViewInfo: The JSON-encoded result of `UiView.getViewInfo()`, cached from the most recent                   //
//                   time a session to this grain was opened.                                                         //
//   trashed: If present, the Date when this grain was moved to the trash bin. Thirty days after                      //
//            this date, the grain will be automatically deleted.                                                     //
//                                                                                                                    //
// The following fields *might* also exist. These are temporary hacks used to implement e-mail and                    //
// web publishing functionality without powerbox support; they will be replaced once the powerbox                     //
// is implemented.                                                                                                    //
//   publicId:  An id used to publicly identify this grain. Used e.g. to route incoming e-mail and                    //
//       web publishing. This field is initialized when first requested by the app.                                   //
                                                                                                                      //
RoleAssignments = new Mongo.Collection("roleAssignments");                                                            // 224
// *OBSOLETE* Before `user` was a variant of ApiTokenOwner, this collection was used to store edges                   //
// in the permissions sharing graph. This functionality has been subsumed by the ApiTokens                            //
// collection.                                                                                                        //
                                                                                                                      //
Contacts = new Mongo.Collection("contacts");                                                                          // 229
// Edges in the social graph.                                                                                         //
//                                                                                                                    //
// If Alice has Bob as a contact, then she is allowed to see Bob's profile information and Bob                        //
// will show up in her user-picker UI for actions like share-by-identity.                                             //
//                                                                                                                    //
// Contacts are not symmetric. Bob might be one of Alice's contacts even if Alice is not one of                       //
// Bob's.                                                                                                             //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id: random                                                                                                      //
//   ownerId: The accountId of the user account who owns this contact.                                                //
//   petname: Human-readable label chosen by and only visible to the owner. Uniquely identifies                       //
//            the contact to the owner.                                                                               //
//   created: Date when this contact was created.                                                                     //
//   identityId: The `_id` of the user whose contact info this contains.                                              //
                                                                                                                      //
Sessions = new Mongo.Collection("sessions");                                                                          // 246
// UI sessions open to particular grains.  A new session is created each time a user opens a grain.                   //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:  random                                                                                                     //
//   grainId:  _id of the grain to which this session is connected.                                                   //
//   hostId: ID part of the hostname from which this grain is being served. I.e. this replaces the                    //
//       '*' in WILDCARD_HOST.                                                                                        //
//   tabId: Random value unique to the grain tab in which this session is displayed. Typically                        //
//       every session has a different `tabId`, but embedded sessions (including in the powerbox)                     //
//       have the same `tabId` as the outer session.                                                                  //
//   timestamp:  Time of last keep-alive message to this session.  Sessions time out after some                       //
//       period.                                                                                                      //
//   userId:  User ID of the user who owns this session.                                                              //
//   identityId:  Identity ID of the user who owns this session.                                                      //
//   hashedToken: If the session is owned by an anonymous user, the _id of the entry in ApiTokens                     //
//       that was used to open it. Note that for old-style sharing (i.e. when !grain.private),                        //
//       anonymous users can get access without an API token and so neither userId nor hashedToken                    //
//       are present.                                                                                                 //
//   powerboxView: If present, this is a view that should be presented as part of a powerbox                          //
//       interaction.                                                                                                 //
//     offer: The webkey that corresponds to cap that was passed to the `offer` RPC.                                  //
//   viewInfo: The UiView.ViewInfo corresponding to the underlying UiSession. This isn't populated                    //
//       until newSession is called on the UiView.                                                                    //
//   permissions: The permissions for the current identity on this UiView. This isn't populated                       //
//       until newSession is called on the UiView.                                                                    //
//   hasLoaded: Marked as true by the proxy when the underlying UiSession has responded to its first                  //
//       request                                                                                                      //
                                                                                                                      //
SignupKeys = new Mongo.Collection("signupKeys");                                                                      // 275
// Invite keys which may be used by users to get access to Sandstorm.                                                 //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:  random                                                                                                     //
//   used:  Boolean indicating whether this key has already been consumed.                                            //
//   note:  Text note assigned when creating key, to keep track of e.g. whom the key was for.                         //
//   email: If this key was sent as an email invite, the email address to which it was sent.                          //
                                                                                                                      //
ActivityStats = new Mongo.Collection("activityStats");                                                                // 284
// Contains usage statistics taken on a regular interval. Each entry is a data point.                                 //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   timestamp: Date when measurements were taken.                                                                    //
//   daily: Contains stats counts pertaining to the last day before the sample time.                                  //
//   weekly: Contains stats counts pertaining to the last seven days before the sample time.                          //
//   monthly: Contains stats counts pertaining to the last thirty days before the timestamp.                          //
//                                                                                                                    //
// Each of daily, weekly, and monthly contains:                                                                       //
//   activeUsers: The number of unique users who have used a grain on the server in the time                          //
//       interval. Only counts logged-in users.                                                                       //
//   demoUsers: Demo users.                                                                                           //
//   appDemoUsers: Users that came in through "app demo".                                                             //
//   activeGrains: The number of unique grains that have been used in the time interval.                              //
//   apps: An object indexed by app ID recording, for each app:                                                       //
//       owners: Number of unique owners of this app (counting only grains that still exist).                         //
//       sharedUsers: Number of users who have accessed other people's grains of this app (counting                   //
//         only grains that still exist).                                                                             //
//       grains: Number of active grains of this app (that still exist).                                              //
//       deleted: Number of non-demo grains of this app that were deleted.                                            //
//       demoed: Number of demo grains created and expired.                                                           //
//       appDemoUsers: Number of app demos initiated with this app.                                                   //
                                                                                                                      //
DeleteStats = new Mongo.Collection("deleteStats");                                                                    // 308
// Contains records of objects that were deleted, for stat-keeping purposes.                                          //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   type: "grain" or "user" or "demoGrain" or "demoUser" or "appDemoUser"                                            //
//   lastActive: Date of the user's or grain's last activity.                                                         //
//   appId: For type = "grain", the app ID of the grain. For type = "appDemoUser", the app ID they                    //
//     arrived to demo. For others, undefined.                                                                        //
                                                                                                                      //
FileTokens = new Mongo.Collection("fileTokens");                                                                      // 317
// Tokens corresponding to backup files that are currently stored on the server. A user receives                      //
// a token when they create a backup file (either by uploading it, or by backing up one of their                      //
// grains) and may use the token to read the file (either to download it, or to restore a new                         //
// grain from it).                                                                                                    //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:       The unguessable token string.                                                                         //
//   name:      Suggested filename.                                                                                   //
//   timestamp: File creation time. Used to figure out when the token and file should be wiped.                       //
                                                                                                                      //
ApiTokens = new Mongo.Collection("apiTokens");                                                                        // 328
// Access tokens for APIs exported by apps.                                                                           //
//                                                                                                                    //
// Originally API tokens were only used by external users through the HTTP API endpoint. However,                     //
// now they are also used to implement SturdyRefs, not just held by external users, but also when                     //
// an app holds a SturdyRef to another app within the same server. See the various `save()`,                          //
// `restore()`, and `drop()` methods in `grain.capnp` (on `SandstormApi`, `AppPersistent`, and                        //
// `MainView`) -- the fields of type `Data` are API tokens.                                                           //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:       A SHA-256 hash of the token, base64-encoded.                                                          //
//   grainId:   The grain servicing this API. (Not present if the API isn't serviced by a grain.)                     //
//   identityId: For UiView capabilities, this is the identity for which the view is attenuated.                      //
//              That is, the UiView's newSession() method will intersect the requested permissions                    //
//              with this identity's permissions before forwarding on to the underlying app. If                       //
//              `identityId` is not present, then no identity attenuation is applied, i.e. this is                    //
//              a raw UiView as implemented by the app. (The `roleAssignment` field, below, may                       //
//              still apply. For non-UiView capabilities, `identityId` is never present. Note that                    //
//              this is NOT the identity against which the `requiredPermissions` parameter of                         //
//              `SandstormApi.restore()` is checked; that would be `owner.grain.introducerIdentity`.                  //
//   accountId: For tokens where `identityId` is set, the `_id` (in the Users table) of the account                   //
//              that created the token.                                                                               //
//   roleAssignment: If this API token represents a UiView, this field contains a JSON-encoded                        //
//              Grain.ViewSharingLink.RoleAssignment representing the permissions it carries. These                   //
//              permissions will be intersected with those held by `identityId` when the view is                      //
//              opened.                                                                                               //
//   forSharing: If true, requests sent to the HTTP API endpoint with this token will be treated as                   //
//              anonymous rather than as directly associated with `identityId`. This has no effect                    //
//              on the permissions granted.                                                                           //
//   objectId:  If present, this token represents an arbitrary Cap'n Proto capability exported by                     //
//              the app or its supervisor (whereas without this it strictly represents UiView).                       //
//              sturdyRef is the JSON-encoded SupervisorObjectId (defined in `supervisor.capnp`).                     //
//              Note that if the SupervisorObjectId contains an AppObjectId, that field is                            //
//              treated as type AnyPointer, and so encoded as a raw Cap'n Proto message.                              //
//   frontendRef: If present, this token actually refers to an object implemented by the front-end,                   //
//              not a particular grain. (`grainId` and `identityId` are not set.) This is an object                   //
//              containing exactly one of the following fields:                                                       //
//       notificationHandle: A `Handle` for an ongoing notification, as returned by                                   //
//                           `NotificationTarget.addOngoing`. The value is an `_id` from the                          //
//                           `Notifications` collection.                                                              //
//       ipNetwork: An IpNetwork capability that is implemented by the frontend. Eventually, this                     //
//                  will be moved out of the frontend and into the backend, but we'll migrate the                     //
//                  database when that happens. This field contains the boolean true to signify that                  //
//                  it has been set.                                                                                  //
//       ipInterface: Ditto IpNetwork, except it's an IpInterface.                                                    //
//       emailVerifier: An EmailVerifier capability that is implemented by the frontend. The                          //
//                      value is an object containing the field `services`, which itself is a                         //
//                      list of names of identity providers that are trusted to verify addresses.                     //
//                      If `services` is omitted or falsy, all configured identity providers are                      //
//                      trusted. Note that a malicious user could specify invalid names in the                        //
//                      list; they should be ignored.                                                                 //
//       verifiedEmail: An VerifiedEmail capability that is implemented by the frontend.                              //
//                      An object containing `verifierId`, `tabId`, and `address`.                                    //
//   parentToken: If present, then this token represents exactly the capability represented by                        //
//              the ApiToken with _id = parentToken, except possibly (if it is a UiView) attenuated                   //
//              by `roleAssignment` (if present). To facilitate permissions computations, if the                      //
//              capability is a UiView, then `grainId` is set to the backing grain, `identityId`                      //
//              is set to the identity that shared the view, and `accountId` is set to the account                    //
//              that shared the view. Neither `objectId` nor `frontendRef` is present when                            //
//              `parentToken` is present.                                                                             //
//   petname:   Human-readable label for this access token, useful for identifying tokens for                         //
//              revocation. This should be displayed when visualizing incoming capabilities to                        //
//              the grain identified by `grainId`.                                                                    //
//   created:   Date when this token was created.                                                                     //
//   revoked:   If true, then this sturdyref has been revoked and can no longer be restored. It may                   //
//              become un-revoked in the future.                                                                      //
//   trashed:   If present, the Date when this token was moved to the trash bin. Thirty days after                    //
//              this date, the token will be automatically deleted.                                                   //
//   expires:   Optional expiration Date. If undefined, the token does not expire.                                    //
//   lastUsed:  Optional Date when this token was last used.                                                          //
//   owner:     A `ApiTokenOwner` (defined in `supervisor.capnp`, stored as a JSON object)                            //
//              as passed to the `save()` call that created this token. If not present, treat                         //
//              as `webkey` (the default for `ApiTokenOwner`).                                                        //
//   expiresIfUnused:                                                                                                 //
//              Optional Date after which the token, if it has not been used yet, expires.                            //
//              This field should be cleared on a token's first use.                                                  //
//   requirements: List of conditions which must hold for this token to be considered valid.                          //
//              Semantically, this list specifies the powers which were *used* to originally                          //
//              create the token. If any condition in the list becomes untrue, then the token must                    //
//              be considered revoked, and all live refs and sturdy refs obtained transitively                        //
//              through it must also become revoked. Each item is the JSON serialization of the                       //
//              `MembraneRequirement` structure defined in `supervisor.capnp`.                                        //
//   hasApiHost: If true, there is an entry in ApiHosts for this token, which will need to be                         //
//              cleaned up when the token is.                                                                         //
//                                                                                                                    //
// It is important to note that a token's owner and provider are independent from each other. To                      //
// illustrate, here is an approximate definition of ApiToken in pseudo Cap'n Proto schema language:                   //
//                                                                                                                    //
// struct ApiToken {                                                                                                  //
//   owner :ApiTokenOwner;                                                                                            //
//   provider :union {                                                                                                //
//     grain :group {                                                                                                 //
//       grainId :Text;                                                                                               //
//       union {                                                                                                      //
//         uiView :group {                                                                                            //
//           identityId :Text;                                                                                        //
//           roleAssignment :RoleAssignment;                                                                          //
//           forSharing :Bool;                                                                                        //
//         }                                                                                                          //
//         objectId :SupervisorObjectId;                                                                              //
//       }                                                                                                            //
//     }                                                                                                              //
//     frontendRef :union {                                                                                           //
//       notificationHandle :Text;                                                                                    //
//       ipNetwork :Bool;                                                                                             //
//       ipInterface :Bool;                                                                                           //
//       emailVerifier :group {                                                                                       //
//         services :List(String);                                                                                    //
//       }                                                                                                            //
//       verifiedEmail :group {                                                                                       //
//         verifierId :Text;                                                                                          //
//         tabId :Text;                                                                                               //
//         address :Text;                                                                                             //
//       }                                                                                                            //
//     }                                                                                                              //
//     child :group {                                                                                                 //
//       parentToken :Text;                                                                                           //
//       union {                                                                                                      //
//         uiView :group {                                                                                            //
//           grainId :Text;                                                                                           //
//           identityId :Text;                                                                                        //
//           roleAssignment :RoleAssignment = (allAccess = ());                                                       //
//         }                                                                                                          //
//         other :Void;                                                                                               //
//       }                                                                                                            //
//     }                                                                                                              //
//   }                                                                                                                //
//   requirements: List(Supervisor.MembraneRequirement);                                                              //
//   ...                                                                                                              //
// }                                                                                                                  //
                                                                                                                      //
ApiTokens.ensureIndexOnServer("grainId", { sparse: 1 });                                                              // 459
ApiTokens.ensureIndexOnServer("owner.user.identityId", { sparse: 1 });                                                // 460
                                                                                                                      //
ApiHosts = new Mongo.Collection("apiHosts");                                                                          // 462
// Allows defining some limited static behavior for an API host when accessed unauthenticated. This                   //
// mainly exists to allow backwards-compatibility with client applications that expect to be able                     //
// to probe an API host without authentication to determine capabilities such as DAV protocols                        //
// supported, before authenticating to perform real requests. An app can specify these properties                     //
// when creating an offerTemplate.                                                                                    //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:          apiHostIdHashForToken() of the corresponding API token.                                            //
//   hash2:        hash(hash(token)), aka hash(ApiToken._id). Used to allow ApiHosts to be cleaned                    //
//                 up when ApiTokens are deleted.                                                                     //
//   options:      Specifies how to respond to unauthenticated OPTIONS requests on this host.                         //
//                 This is an object containing fields:                                                               //
//     dav:        List of strings specifying DAV header `compliance-class`es, e.g. "1" or                            //
//                 "calendar-access". https://tools.ietf.org/html/rfc4918#section-10.1                                //
//   resources:    Object mapping URL paths (including initial '/') to static HTTP responses to                       //
//                 give when those paths are accessed unauthenticated. Due to Mongo disliking '.'                     //
//                 and '$' in keys, these characters must be escaped as '\uFF0E' and '\uFF04'                         //
//                 (see SandstormDb.escapeMongoKey). Each value in this map is an object with                         //
//                 fields:                                                                                            //
//     type:       Content-Type.                                                                                      //
//     language:   Content-Language.                                                                                  //
//     encoding:   Content-Encoding.                                                                                  //
//     body:       Entity-body as a string or buffer.                                                                 //
                                                                                                                      //
Notifications = new Mongo.Collection("notifications");                                                                // 487
// Notifications for a user.                                                                                          //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:          random                                                                                             //
//   grainId:      The grain originating this notification, if any.                                                   //
//   userId:       The user receiving the notification.                                                               //
//   text:         The JSON-ified LocalizedText to display in the notification.                                       //
//   isUnread:     Boolean indicating if this notification is unread.                                                 //
//   timestamp:    Date when this notification was last updated                                                       //
//   ongoing:      If present, this is an ongoing notification, and this field contains an                            //
//                 ApiToken referencing the `OngoingNotification` capability.                                         //
//   admin:        If present, this is a notification intended for an admin.                                          //
//     action:     If present, this is a (string) link that the notification should direct the                        //
//                 admin to.                                                                                          //
//     type:       The type of notification (currently only "reportStats").                                           //
//   appUpdates:   If present, this is an app update notification. It is an object with the appIds                    //
//                 as keys.                                                                                           //
//     $appId:     The appId that has an outstanding update.                                                          //
//       packageId: The packageId that it will update to.                                                             //
//       name: The name of the app. (appTitle from package.manifest)                                                  //
//       version: The app's version number. (appVersion from package.manifest)                                        //
//       marketingVersion: String marketing version of this app. (appMarketingVersion from package.manifest)          //
//   referral:     If this boolean field is true, then treat this notification as a referral                          //
//                 notification. This causes text to be ignored, since we need custom logic.                          //
//   mailingListBonus: Like `referral`, but notify the user about the mailing list bonus. This is                     //
//                 a one-time notification only to Oasis users who existed when the bonus program                     //
//                 was implemented.                                                                                   //
                                                                                                                      //
StatsTokens = new Mongo.Collection("statsTokens");                                                                    // 516
// Access tokens for the Stats collection                                                                             //
//                                                                                                                    //
// These tokens are used for accessing the ActivityStats collection remotely                                          //
// (ie. from a dashboard webapp)                                                                                      //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:       The token. At least 128 bits entropy (Random.id(22)).                                                 //
                                                                                                                      //
Misc = new Mongo.Collection("misc");                                                                                  // 525
// Miscellaneous configuration and other settings                                                                     //
//                                                                                                                    //
// This table is currently only used for persisting BASE_URL from one session to the next,                            //
// but in general any miscellaneous settings should go in here                                                        //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:       The name of the setting. eg. "BASE_URL"                                                               //
//   value:     The value of the setting.                                                                             //
                                                                                                                      //
Settings = new Mongo.Collection("settings");                                                                          // 535
// Settings for this Sandstorm instance go here. They are configured through the adminSettings                        //
// route. This collection differs from misc in that any admin user can update it through the admin                    //
// interface.                                                                                                         //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:       The name of the setting. eg. "smtpConfig"                                                             //
//   value:     The value of the setting.                                                                             //
//   automaticallyReset: Sometimes the server needs to automatically reset a setting. When it does                    //
//                       so, it will also write an object to this field indicating why the reset was                  //
//                       needed. That object can have the following variants:                                         //
//       baseUrlChangedFrom: The reset was due to BASE_URL changing. This field contains a string                     //
//                           with the old BASE_URL.                                                                   //
//                                                                                                                    //
//   potentially other fields that are unique to the setting                                                          //
                                                                                                                      //
Migrations = new Mongo.Collection("migrations");                                                                      // 551
// This table tracks which migrations we have applied to this instance.                                               //
// It contains a single entry:                                                                                        //
//   _id:       "migrations_applied"                                                                                  //
//   value:     The number of migrations this instance has successfully completed.                                    //
                                                                                                                      //
StaticAssets = new Mongo.Collection("staticAssets");                                                                  // 557
// Collection of static assets served up from the Sandstorm server's "static" host. We only                           //
// support relatively small assets: under 1MB each.                                                                   //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:       Random ID; will be used in the URL.                                                                   //
//   hash:      A base64-encoded SHA-256 hash of the data, used to de-dupe.                                           //
//   mimeType:  MIME type of the asset, suitable for Content-Type header.                                             //
//   encoding:  Either "gzip" or not present, suitable for Content-Encoding header.                                   //
//   content:   The asset content (byte buffer).                                                                      //
//   refcount:  Number of places where this asset's ID appears in the database. Since Mongo doesn't                   //
//       have transactions, this needs to bias towards over-counting; a backup GC could be used                       //
//       to catch leaked assets, although it's probably not a big deal in practice.                                   //
                                                                                                                      //
AssetUploadTokens = new Mongo.Collection("assetUploadTokens");                                                        // 571
// Collection of tokens representing a single-use permission to upload an asset, such as a new                        //
// profile picture.                                                                                                   //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:       Random ID.                                                                                            //
//   purpose:   Contains one of the following, indicating how the asset is to be used:                                //
//       profilePicture: Indicates that the upload is a new profile picture. Contains fields:                         //
//           userId: User whose picture shall be replaced.                                                            //
//           identityId: Which of the user's identities shall be updated.                                             //
//   expires:   Time when this token will go away if unused.                                                          //
                                                                                                                      //
Plans = new Mongo.Collection("plans");                                                                                // 583
// Subscription plans, which determine quota.                                                                         //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id: Plan ID, usually a short string like "free", "standard", "large", "mega", ...                               //
//   storage: Number of bytes this user is allowed to store.                                                          //
//   compute: Number of kilobyte-RAM-seconds this user is allowed to consume.                                         //
//   computeLabel: Label to display to the user describing this plan's compute units.                                 //
//   grains: Total number of grains this user can create (often `Infinity`).                                          //
//   price: Price per month in US cents.                                                                              //
//   hidden: If true, a user cannot switch to this plan, but some users may be on it and are                          //
//       allowed to switch away.                                                                                      //
//   title: Title from display purposes. If missing, default to capitalizing _id.                                     //
                                                                                                                      //
AppIndex = new Mongo.Collection("appIndex");                                                                          // 597
// A mirror of the data from the App Market index                                                                     //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id: the appId of the app                                                                                        //
//  The rest of the fields are defined in src/sandstorm/app-index/app-index.capnp:AppIndexForMarket                   //
                                                                                                                      //
KeybaseProfiles = new Mongo.Collection("keybaseProfiles");                                                            // 604
// Cache of Keybase profile information. The profile for a user is re-fetched every time a package                    //
// by that user is installed, as well as if the keybase profile is requested and not already                          //
// present for some reason.                                                                                           //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id: PGP key fingerprint (SHA-1, hex, all-caps)                                                                  //
//   displayName: Display name from Keybase. (NOT VERIFIED AT ALL.)                                                   //
//   handle: Keybase handle.                                                                                          //
//   proofs: The "proofs_summary.all" array from the Keybase lookup. See the non-existent Keybase                     //
//     docs for details. We also add a boolean "status" field to each proof indicating whether                        //
//     we have directly verified the proof ourselves. Its values may be "unverified" (Keybase                         //
//     returned this but we haven't checked it directly), "verified" (we verified the proof and it                    //
//     is valid), "invalid" (we checked the proof and it was definitely bogus), or "checking" (the                    //
//     server is currently actively checking this proof). Note that if a check fails due to network                   //
//     errors, the status goes back to "unverified".                                                                  //
//                                                                                                                    //
//     WARNING: Currently verification is NOT IMPLEMENTED, so all proofs will be "unverified"                         //
//       for now and we just trust Keybase.                                                                           //
                                                                                                                      //
FeatureKey = new Mongo.Collection("featureKey");                                                                      // 624
// Responsible for storing the current feature key that is active on the server.  Contains a single                   //
// document with two keys:                                                                                            //
//                                                                                                                    //
//   _id: "currentFeatureKey"                                                                                         //
//   value: the still-signed, binary-encoded feature key                                                              //
//          (a feature key with comments removed and base64 decoded)                                                  //
//                                                                                                                    //
// This is only intended to be visible on the server.                                                                 //
                                                                                                                      //
SetupSession = new Mongo.Collection("setupSession");                                                                  // 634
// Responsible for storing information about setup sessions.  Contains a single document with three                   //
// keys:                                                                                                              //
//                                                                                                                    //
//   _id: "current-session"                                                                                           //
//   creationDate: Date object indicating when this session was created.                                              //
//   hashedSessionId: the sha256 of the secret session id that was returned to the client                             //
                                                                                                                      //
if (Meteor.isServer) {                                                                                                // 642
  Meteor.publish("credentials", function () {                                                                         // 643
    // Data needed for isSignedUp() and isAdmin() to work.                                                            //
                                                                                                                      //
    if (this.userId) {                                                                                                // 646
      return [Meteor.users.find({ _id: this.userId }, { fields: { signupKey: 1, isAdmin: 1, expires: 1, storageUsage: 1,
          plan: 1, planBonus: 1, hasCompletedSignup: 1, experiments: 1,                                               // 650
          referredIdentityIds: 1 } }), Plans.find()];                                                                 // 651
    } else {                                                                                                          //
      return [];                                                                                                      // 655
    }                                                                                                                 //
  });                                                                                                                 //
}                                                                                                                     //
                                                                                                                      //
var countReferrals = function countReferrals(user) {                                                                  // 660
  var referredIdentityIds = user.referredIdentityIds;                                                                 // 661
  return referredIdentityIds && referredIdentityIds.length || 0;                                                      // 662
};                                                                                                                    //
                                                                                                                      //
var calculateReferralBonus = function calculateReferralBonus(user) {                                                  // 665
  // This function returns an object of the form:                                                                     //
  //                                                                                                                  //
  // - {grains: 0, storage: 0}                                                                                        //
  //                                                                                                                  //
  // which are extra resources this account gets as part of participating in the referral                             //
  // program. (Storage is measured in bytes, as usual for plans.)                                                     //
                                                                                                                      //
  // TODO(cleanup): Consider moving referral bonus logic into Oasis payments module (since it's                       //
  //   payments-specific) and aggregating into `planBonus`.                                                           //
                                                                                                                      //
  // Authorization note: Only call this if accountId is the current user!                                             //
  var isPaid = user.plan && user.plan !== "free";                                                                     // 677
                                                                                                                      //
  successfulReferralsCount = countReferrals(user);                                                                    // 679
  if (isPaid) {                                                                                                       // 680
    var maxPaidStorageBonus = 30 * 1e9;                                                                               // 681
    return { grains: 0,                                                                                               // 682
      storage: Math.min(successfulReferralsCount * 2 * 1e9, maxPaidStorageBonus) };                                   // 683
  } else {                                                                                                            //
    var maxFreeStorageBonus = 2 * 1e9;                                                                                // 687
    var bonus = {                                                                                                     // 688
      storage: Math.min(successfulReferralsCount * 50 * 1e6, maxFreeStorageBonus)                                     // 689
    };                                                                                                                //
    if (successfulReferralsCount > 0) {                                                                               // 693
      bonus.grains = Infinity;                                                                                        // 694
    } else {                                                                                                          //
      bonus.grains = 0;                                                                                               // 696
    }                                                                                                                 //
                                                                                                                      //
    return bonus;                                                                                                     // 699
  }                                                                                                                   //
};                                                                                                                    //
                                                                                                                      //
getUserQuota = function getUserQuota(user) {                                                                          // 703
  var plan = Plans.findOne(user.plan || "free");                                                                      // 704
  var referralBonus = calculateReferralBonus(user);                                                                   // 705
  var bonus = user.planBonus || {};                                                                                   // 706
  var userQuota = {                                                                                                   // 707
    storage: plan.storage + referralBonus.storage + (bonus.storage || 0),                                             // 708
    grains: plan.grains + referralBonus.grains + (bonus.grains || 0),                                                 // 709
    compute: plan.compute + (bonus.compute || 0)                                                                      // 710
  };                                                                                                                  //
  return userQuota;                                                                                                   // 712
};                                                                                                                    //
                                                                                                                      //
isUserOverQuota = function isUserOverQuota(user) {                                                                    // 715
  // Return false if user has quota space remaining, true if it is full. When this returns true,                      //
  // we will not allow the user to create new grains, though they may be able to open existing ones                   //
  // which may still increase their storage usage.                                                                    //
  //                                                                                                                  //
  // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                 //
                                                                                                                      //
  if (!Meteor.settings["public"].quotaEnabled || user.isAdmin) return false;                                          // 722
                                                                                                                      //
  var plan = getUserQuota(user);                                                                                      // 724
  if (plan.grains < Infinity) {                                                                                       // 725
    var count = Grains.find({ userId: user._id }, { fields: {}, limit: plan.grains }).count();                        // 726
    if (count >= plan.grains) return "outOfGrains";                                                                   // 727
  }                                                                                                                   //
                                                                                                                      //
  return plan && user.storageUsage && user.storageUsage >= plan.storage && "outOfStorage";                            // 730
};                                                                                                                    //
                                                                                                                      //
isUserExcessivelyOverQuota = function isUserExcessivelyOverQuota(user) {                                              // 733
  // Return true if user is so far over quota that we should prevent their existing grains from                       //
  // running at all.                                                                                                  //
  //                                                                                                                  //
  // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                 //
                                                                                                                      //
  if (!Meteor.settings["public"].quotaEnabled || user.isAdmin) return false;                                          // 739
                                                                                                                      //
  var quota = getUserQuota(user);                                                                                     // 741
                                                                                                                      //
  // quota.grains = Infinity means unlimited grains. IEEE754 defines Infinity == Infinity.                            //
  if (quota.grains < Infinity) {                                                                                      // 733
    var count = Grains.find({ userId: user._id }, { fields: {}, limit: quota.grains * 2 }).count();                   // 745
    if (count >= quota.grains * 2) return "outOfGrains";                                                              // 746
  }                                                                                                                   //
                                                                                                                      //
  return quota && user.storageUsage && user.storageUsage >= quota.storage * 1.2 && "outOfStorage";                    // 749
};                                                                                                                    //
                                                                                                                      //
isAdmin = function isAdmin() {                                                                                        // 752
  // Returns true if the user is the administrator.                                                                   //
                                                                                                                      //
  var user = Meteor.user();                                                                                           // 755
  if (user && user.isAdmin) {                                                                                         // 756
    return true;                                                                                                      // 757
  } else {                                                                                                            //
    return false;                                                                                                     // 759
  }                                                                                                                   //
};                                                                                                                    //
                                                                                                                      //
isAdminById = function isAdminById(id) {                                                                              // 763
  // Returns true if the user's id is the administrator.                                                              //
                                                                                                                      //
  var user = Meteor.users.findOne({ _id: id }, { fields: { isAdmin: 1 } });                                           // 766
  if (user && user.isAdmin) {                                                                                         // 767
    return true;                                                                                                      // 768
  } else {                                                                                                            //
    return false;                                                                                                     // 770
  }                                                                                                                   //
};                                                                                                                    //
                                                                                                                      //
findAdminUserForToken = function findAdminUserForToken(token) {                                                       // 774
  if (!token.requirements) {                                                                                          // 775
    return;                                                                                                           // 776
  }                                                                                                                   //
                                                                                                                      //
  var requirements = token.requirements.filter(function (requirement) {                                               // 779
    return "userIsAdmin" in requirement;                                                                              // 780
  });                                                                                                                 //
                                                                                                                      //
  if (requirements.length > 1) {                                                                                      // 783
    return;                                                                                                           // 784
  }                                                                                                                   //
                                                                                                                      //
  if (requirements.length === 0) {                                                                                    // 787
    return;                                                                                                           // 788
  }                                                                                                                   //
                                                                                                                      //
  return requirements[0].userIsAdmin;                                                                                 // 791
};                                                                                                                    //
                                                                                                                      //
var wildcardHost = Meteor.settings["public"].wildcardHost.toLowerCase().split("*");                                   // 794
                                                                                                                      //
if (wildcardHost.length != 2) {                                                                                       // 796
  throw new Error("Wildcard host must contain exactly one asterisk.");                                                // 797
}                                                                                                                     //
                                                                                                                      //
matchWildcardHost = function matchWildcardHost(host) {                                                                // 800
  // See if the hostname is a member of our wildcard. If so, extract the ID.                                          //
                                                                                                                      //
  // We remove everything after the first ":" character so that our                                                   //
  // comparison logic ignores port numbers.                                                                           //
  var prefix = wildcardHost[0];                                                                                       // 805
  var suffix = wildcardHost[1].split(":")[0];                                                                         // 806
  var hostSansPort = host.split(":")[0];                                                                              // 807
                                                                                                                      //
  if (hostSansPort.lastIndexOf(prefix, 0) >= 0 && hostSansPort.indexOf(suffix, -suffix.length) >= 0 && hostSansPort.length >= prefix.length + suffix.length) {
    var id = hostSansPort.slice(prefix.length, -suffix.length);                                                       // 812
    if (id.match(/^[-a-z0-9]*$/)) {                                                                                   // 813
      return id;                                                                                                      // 814
    }                                                                                                                 //
  }                                                                                                                   //
                                                                                                                      //
  return null;                                                                                                        // 818
};                                                                                                                    //
                                                                                                                      //
makeWildcardHost = function makeWildcardHost(id) {                                                                    // 821
  return wildcardHost[0] + id + wildcardHost[1];                                                                      // 822
};                                                                                                                    //
                                                                                                                      //
var isApiHostId = function isApiHostId(hostId) {                                                                      // 825
  if (hostId) {                                                                                                       // 826
    var split = hostId.split("-");                                                                                    // 827
    if (split[0] === "api") return split[1] || "*";                                                                   // 828
  }                                                                                                                   //
                                                                                                                      //
  return false;                                                                                                       // 831
};                                                                                                                    //
                                                                                                                      //
var isTokenSpecificHostId = function isTokenSpecificHostId(hostId) {                                                  // 834
  return hostId.lastIndexOf("api-", 0) === 0;                                                                         // 835
};                                                                                                                    //
                                                                                                                      //
var apiHostIdHashForToken = void 0;                                                                                   // 838
if (Meteor.isServer) {                                                                                                // 839
  (function () {                                                                                                      //
    var Crypto = Npm.require("crypto");                                                                               // 840
    apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                   // 841
      // Given an API token, compute the host ID that must be used when requesting this token.                        //
                                                                                                                      //
      // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                     //
      // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                    //
      // of tokens). This doesn't technically add any security, but helps prove that we don't have                    //
      // any bugs which would allow someone who knows only the hostname to access the app API.                        //
      return Crypto.createHash("sha256").update("x" + token).digest("hex").slice(0, 32);                              // 848
    };                                                                                                                //
  })();                                                                                                               //
} else {                                                                                                              //
  apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                     // 851
    // Given an API token, compute the host ID that must be used when requesting this token.                          //
                                                                                                                      //
    // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                       //
    // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                      //
    // of tokens). This doesn't technically add any security, but helps prove that we don't have                      //
    // any bugs which would allow someone who knows only the hostname to access the app API.                          //
    return SHA256("x" + token).slice(0, 32);                                                                          // 858
  };                                                                                                                  //
}                                                                                                                     //
                                                                                                                      //
var apiHostIdForToken = function apiHostIdForToken(token) {                                                           // 862
  return "api-" + apiHostIdHashForToken(token);                                                                       // 863
};                                                                                                                    //
                                                                                                                      //
var makeApiHost = function makeApiHost(token) {                                                                       // 866
  return makeWildcardHost(apiHostIdForToken(token));                                                                  // 867
};                                                                                                                    //
                                                                                                                      //
if (Meteor.isServer) {                                                                                                // 870
  (function () {                                                                                                      //
    var Url = Npm.require("url");                                                                                     // 871
    getWildcardOrigin = function getWildcardOrigin() {                                                                // 872
      // The wildcard URL can be something like "foo-*-bar.example.com", but sometimes when we're                     //
      // trying to specify a pattern matching hostnames (say, a Content-Security-Policy directive),                   //
      // an astrisk is only allowed as the first character and must be followed by a period. So we need               //
      // "*.example.com" instead -- which matches more than we actually want, but is the best we can                  //
      // really do. We also add the protocol to the front (again, that's what CSP wants).                             //
                                                                                                                      //
      // TODO(cleanup): `protocol` is computed in other files, like proxy.js. Put it somewhere common.                //
      var protocol = Url.parse(process.env.ROOT_URL).protocol;                                                        // 880
                                                                                                                      //
      var dotPos = wildcardHost[1].indexOf(".");                                                                      // 882
      if (dotPos < 0) {                                                                                               // 883
        return protocol + "//*";                                                                                      // 884
      } else {                                                                                                        //
        return protocol + "//*" + wildcardHost[1].slice(dotPos);                                                      // 886
      }                                                                                                               //
    };                                                                                                                //
  })();                                                                                                               //
}                                                                                                                     //
                                                                                                                      //
allowDevAccounts = function allowDevAccounts() {                                                                      // 891
  var setting = Settings.findOne({ _id: "devAccounts" });                                                             // 892
  if (setting) {                                                                                                      // 893
    return setting.value;                                                                                             // 894
  } else {                                                                                                            //
    return Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].allowDevAccounts;                // 896
  }                                                                                                                   //
};                                                                                                                    //
                                                                                                                      //
sendReferralProgramNotification = function sendReferralProgramNotification(userId) {                                  // 901
  Notifications.upsert({                                                                                              // 902
    userId: userId,                                                                                                   // 903
    referral: true                                                                                                    // 904
  }, {                                                                                                                //
    userId: userId,                                                                                                   // 906
    referral: true,                                                                                                   // 907
    timestamp: new Date(),                                                                                            // 908
    isUnread: true                                                                                                    // 909
  });                                                                                                                 //
};                                                                                                                    //
                                                                                                                      //
roleAssignmentPattern = {                                                                                             // 913
  none: Match.Optional(null),                                                                                         // 914
  allAccess: Match.Optional(null),                                                                                    // 915
  roleId: Match.Optional(Match.Integer),                                                                              // 916
  addPermissions: Match.Optional([Boolean]),                                                                          // 917
  removePermissions: Match.Optional([Boolean])                                                                        // 918
};                                                                                                                    //
                                                                                                                      //
SandstormDb = function SandstormDb() {                                                                                // 921
  this.collections = {                                                                                                // 922
    // Direct access to underlying collections. DEPRECATED.                                                           //
    //                                                                                                                //
    // TODO(cleanup): Over time, we will provide methods covering each supported query and remove                     //
    //   direct access to the collections.                                                                            //
                                                                                                                      //
    packages: Packages,                                                                                               // 928
    devPackages: DevPackages,                                                                                         // 929
    userActions: UserActions,                                                                                         // 930
    grains: Grains,                                                                                                   // 931
    contacts: Contacts,                                                                                               // 932
    sessions: Sessions,                                                                                               // 933
    signupKeys: SignupKeys,                                                                                           // 934
    activityStats: ActivityStats,                                                                                     // 935
    deleteStats: DeleteStats,                                                                                         // 936
    fileTokens: FileTokens,                                                                                           // 937
    apiTokens: ApiTokens,                                                                                             // 938
    apiHosts: ApiHosts,                                                                                               // 939
    notifications: Notifications,                                                                                     // 940
    statsTokens: StatsTokens,                                                                                         // 941
    misc: Misc,                                                                                                       // 942
    settings: Settings,                                                                                               // 943
    appIndex: AppIndex,                                                                                               // 944
    keybaseProfiles: KeybaseProfiles,                                                                                 // 945
    featureKey: FeatureKey,                                                                                           // 946
    setupSession: SetupSession,                                                                                       // 947
    users: Meteor.users                                                                                               // 948
                                                                                                                      //
  };                                                                                                                  //
};                                                                                                                    //
                                                                                                                      //
// TODO(cleanup): These methods should not be defined freestanding and should use collection                          //
//   objects created in SandstormDb's constructor rather than globals.                                                //
                                                                                                                      //
// Intentionally omitted:                                                                                             //
// - Migrations, since it's used only within this package.                                                            //
// - RoleAssignments, since it is deprecated and only used by the migration that eliminated it.                       //
_.extend(SandstormDb.prototype, {                                                                                     // 959
  getUserQuota: getUserQuota,                                                                                         // 960
  isUserOverQuota: isUserOverQuota,                                                                                   // 961
  isUserExcessivelyOverQuota: isUserExcessivelyOverQuota,                                                             // 962
  isAdmin: isAdmin,                                                                                                   // 963
  isAdminById: isAdminById,                                                                                           // 964
  findAdminUserForToken: findAdminUserForToken,                                                                       // 965
  matchWildcardHost: matchWildcardHost,                                                                               // 966
  makeWildcardHost: makeWildcardHost,                                                                                 // 967
  isApiHostId: isApiHostId,                                                                                           // 968
  isTokenSpecificHostId: isTokenSpecificHostId,                                                                       // 969
  apiHostIdHashForToken: apiHostIdHashForToken,                                                                       // 970
  apiHostIdForToken: apiHostIdForToken,                                                                               // 971
  makeApiHost: makeApiHost,                                                                                           // 972
  allowDevAccounts: allowDevAccounts,                                                                                 // 973
  roleAssignmentPattern: roleAssignmentPattern,                                                                       // 974
                                                                                                                      //
  isDemoUser: function () {                                                                                           // 976
    function isDemoUser() {                                                                                           // 976
      // Returns true if this is a demo user.                                                                         //
                                                                                                                      //
      var user = Meteor.user();                                                                                       // 979
      if (user && user.expires) {                                                                                     // 980
        return true;                                                                                                  // 981
      } else {                                                                                                        //
        return false;                                                                                                 // 983
      }                                                                                                               //
    }                                                                                                                 //
                                                                                                                      //
    return isDemoUser;                                                                                                //
  }(),                                                                                                                //
                                                                                                                      //
  isSignedUp: function () {                                                                                           // 987
    function isSignedUp() {                                                                                           // 987
      var user = Meteor.user();                                                                                       // 988
      return this.isAccountSignedUp(user);                                                                            // 989
    }                                                                                                                 //
                                                                                                                      //
    return isSignedUp;                                                                                                //
  }(),                                                                                                                //
                                                                                                                      //
  isAccountSignedUp: function () {                                                                                    // 992
    function isAccountSignedUp(user) {                                                                                // 992
      // Returns true if the user has presented an invite key.                                                        //
                                                                                                                      //
      if (!user) return false; // not signed in                                                                       // 995
                                                                                                                      //
      if (!user.loginIdentities) return false; // not an account                                                      // 992
                                                                                                                      //
      if (user.expires) return false; // demo user.                                                                   // 992
                                                                                                                      //
      if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                              // 992
                                                                                                                      //
      if (user.signupKey) return true; // user is invited                                                             // 992
                                                                                                                      //
      if (this.isUserInOrganization(user)) return true;                                                               // 992
                                                                                                                      //
      return false;                                                                                                   // 1007
    }                                                                                                                 //
                                                                                                                      //
    return isAccountSignedUp;                                                                                         //
  }(),                                                                                                                //
                                                                                                                      //
  isSignedUpOrDemo: function () {                                                                                     // 1010
    function isSignedUpOrDemo() {                                                                                     // 1010
      var user = Meteor.user();                                                                                       // 1011
      return this.isAccountSignedUpOrDemo(user);                                                                      // 1012
    }                                                                                                                 //
                                                                                                                      //
    return isSignedUpOrDemo;                                                                                          //
  }(),                                                                                                                //
                                                                                                                      //
  isAccountSignedUpOrDemo: function () {                                                                              // 1015
    function isAccountSignedUpOrDemo(user) {                                                                          // 1015
      if (!user) return false; // not signed in                                                                       // 1016
                                                                                                                      //
      if (!user.loginIdentities) return false; // not an account                                                      // 1015
                                                                                                                      //
      if (user.expires) return true; // demo user.                                                                    // 1015
                                                                                                                      //
      if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                              // 1015
                                                                                                                      //
      if (user.signupKey) return true; // user is invited                                                             // 1015
                                                                                                                      //
      if (this.isUserInOrganization(user)) return true;                                                               // 1015
                                                                                                                      //
      return false;                                                                                                   // 1028
    }                                                                                                                 //
                                                                                                                      //
    return isAccountSignedUpOrDemo;                                                                                   //
  }(),                                                                                                                //
                                                                                                                      //
  isIdentityInOrganization: function () {                                                                             // 1031
    function isIdentityInOrganization(identity) {                                                                     // 1031
      if (!identity || !identity.services) {                                                                          // 1032
        return false;                                                                                                 // 1033
      }                                                                                                               //
                                                                                                                      //
      var orgMembership = this.getOrganizationMembership();                                                           // 1036
      var googleEnabled = orgMembership && orgMembership.google && orgMembership.google.enabled;                      // 1037
      var googleDomain = orgMembership && orgMembership.google && orgMembership.google.domain;                        // 1038
      var emailEnabled = orgMembership && orgMembership.emailToken && orgMembership.emailToken.enabled;               // 1039
      var emailDomain = orgMembership && orgMembership.emailToken && orgMembership.emailToken.domain;                 // 1040
      var ldapEnabled = orgMembership && orgMembership.ldap && orgMembership.ldap.enabled;                            // 1041
      var samlEnabled = orgMembership && orgMembership.saml && orgMembership.saml.enabled;                            // 1042
      if (emailEnabled && emailDomain && identity.services.email) {                                                   // 1043
        if (identity.services.email.email.toLowerCase().split("@").pop() === emailDomain) {                           // 1044
          return true;                                                                                                // 1045
        }                                                                                                             //
      } else if (ldapEnabled && identity.services.ldap) {                                                             //
        return true;                                                                                                  // 1048
      } else if (samlEnabled && identity.services.saml) {                                                             //
        return true;                                                                                                  // 1050
      } else if (googleEnabled && googleDomain && identity.services.google && identity.services.google.hd) {          //
        if (identity.services.google.hd.toLowerCase() === googleDomain) {                                             // 1052
          return true;                                                                                                // 1053
        }                                                                                                             //
      }                                                                                                               //
                                                                                                                      //
      return false;                                                                                                   // 1057
    }                                                                                                                 //
                                                                                                                      //
    return isIdentityInOrganization;                                                                                  //
  }(),                                                                                                                //
                                                                                                                      //
  isUserInOrganization: function () {                                                                                 // 1060
    function isUserInOrganization(user) {                                                                             // 1060
      if (!this.isFeatureKeyValid()) {                                                                                // 1061
        return false;                                                                                                 // 1062
      }                                                                                                               //
                                                                                                                      //
      for (var i = 0; i < user.loginIdentities.length; i++) {                                                         // 1065
        var identity = Meteor.users.findOne({ _id: user.loginIdentities[i].id });                                     // 1066
        if (this.isIdentityInOrganization(identity)) {                                                                // 1067
          return true;                                                                                                // 1068
        }                                                                                                             //
      }                                                                                                               //
                                                                                                                      //
      return false;                                                                                                   // 1072
    }                                                                                                                 //
                                                                                                                      //
    return isUserInOrganization;                                                                                      //
  }()                                                                                                                 //
});                                                                                                                   //
                                                                                                                      //
if (Meteor.isServer) {                                                                                                // 1076
  (function () {                                                                                                      //
    SandstormDb.prototype.getWildcardOrigin = getWildcardOrigin;                                                      // 1077
                                                                                                                      //
    var Crypto = Npm.require("crypto");                                                                               // 1079
    SandstormDb.prototype.removeApiTokens = function (query) {                                                        // 1080
      // Remove all API tokens matching the query, making sure to clean up ApiHosts as well.                          //
                                                                                                                      //
      this.collections.apiTokens.find(query).forEach(function (token) {                                               // 1083
        // Clean up ApiHosts for webkey tokens.                                                                       //
        if (token.hasApiHost) {                                                                                       // 1085
          var hash2 = Crypto.createHash("sha256").update(token._id).digest("base64");                                 // 1086
          ApiHosts.remove({ hash2: hash2 });                                                                          // 1087
        }                                                                                                             //
      });                                                                                                             //
                                                                                                                      //
      this.collections.apiTokens.remove(query);                                                                       // 1091
    };                                                                                                                //
  })();                                                                                                               //
}                                                                                                                     //
                                                                                                                      //
// =======================================================================================                            //
// Below this point are newly-written or refactored functions.                                                        //
                                                                                                                      //
_.extend(SandstormDb.prototype, {                                                                                     // 1098
  getUser: function () {                                                                                              // 1099
    function getUser(userId) {                                                                                        // 1099
      check(userId, Match.OneOf(String, undefined, null));                                                            // 1100
      if (userId) {                                                                                                   // 1101
        return Meteor.users.findOne(userId);                                                                          // 1102
      }                                                                                                               //
    }                                                                                                                 //
                                                                                                                      //
    return getUser;                                                                                                   //
  }(),                                                                                                                //
                                                                                                                      //
  getIdentity: function () {                                                                                          // 1106
    function getIdentity(identityId) {                                                                                // 1106
      check(identityId, String);                                                                                      // 1107
      var identity = Meteor.users.findOne({ _id: identityId });                                                       // 1108
      if (identity) {                                                                                                 // 1109
        SandstormDb.fillInProfileDefaults(identity);                                                                  // 1110
        SandstormDb.fillInIntrinsicName(identity);                                                                    // 1111
        SandstormDb.fillInPictureUrl(identity);                                                                       // 1112
        return identity;                                                                                              // 1113
      }                                                                                                               //
    }                                                                                                                 //
                                                                                                                      //
    return getIdentity;                                                                                               //
  }(),                                                                                                                //
                                                                                                                      //
  userHasIdentity: function () {                                                                                      // 1117
    function userHasIdentity(userId, identityId) {                                                                    // 1117
      check(userId, String);                                                                                          // 1118
      check(identityId, String);                                                                                      // 1119
                                                                                                                      //
      if (userId === identityId) return true;                                                                         // 1121
                                                                                                                      //
      var user = Meteor.users.findOne(userId);                                                                        // 1123
      return SandstormDb.getUserIdentityIds(user).indexOf(identityId) != -1;                                          // 1124
    }                                                                                                                 //
                                                                                                                      //
    return userHasIdentity;                                                                                           //
  }(),                                                                                                                //
                                                                                                                      //
  userGrains: function () {                                                                                           // 1127
    function userGrains(userId) {                                                                                     // 1127
      check(userId, Match.OneOf(String, undefined, null));                                                            // 1128
      return this.collections.grains.find({ userId: userId });                                                        // 1129
    }                                                                                                                 //
                                                                                                                      //
    return userGrains;                                                                                                //
  }(),                                                                                                                //
                                                                                                                      //
  currentUserGrains: function () {                                                                                    // 1132
    function currentUserGrains() {                                                                                    // 1132
      return this.userGrains(Meteor.userId());                                                                        // 1133
    }                                                                                                                 //
                                                                                                                      //
    return currentUserGrains;                                                                                         //
  }(),                                                                                                                //
                                                                                                                      //
  getGrain: function () {                                                                                             // 1136
    function getGrain(grainId) {                                                                                      // 1136
      check(grainId, String);                                                                                         // 1137
      return this.collections.grains.findOne(grainId);                                                                // 1138
    }                                                                                                                 //
                                                                                                                      //
    return getGrain;                                                                                                  //
  }(),                                                                                                                //
                                                                                                                      //
  userApiTokens: function () {                                                                                        // 1141
    function userApiTokens(userId) {                                                                                  // 1141
      check(userId, Match.OneOf(String, undefined, null));                                                            // 1142
      var identityIds = SandstormDb.getUserIdentityIds(this.getUser(userId));                                         // 1143
      return this.collections.apiTokens.find({ "owner.user.identityId": { $in: identityIds } });                      // 1144
    }                                                                                                                 //
                                                                                                                      //
    return userApiTokens;                                                                                             //
  }(),                                                                                                                //
                                                                                                                      //
  currentUserApiTokens: function () {                                                                                 // 1147
    function currentUserApiTokens() {                                                                                 // 1147
      return this.userApiTokens(Meteor.userId());                                                                     // 1148
    }                                                                                                                 //
                                                                                                                      //
    return currentUserApiTokens;                                                                                      //
  }(),                                                                                                                //
                                                                                                                      //
  userActions: function () {                                                                                          // 1151
    function userActions(user) {                                                                                      // 1151
      return this.collections.userActions.find({ userId: user });                                                     // 1152
    }                                                                                                                 //
                                                                                                                      //
    return userActions;                                                                                               //
  }(),                                                                                                                //
                                                                                                                      //
  currentUserActions: function () {                                                                                   // 1155
    function currentUserActions() {                                                                                   // 1155
      return this.userActions(Meteor.userId());                                                                       // 1156
    }                                                                                                                 //
                                                                                                                      //
    return currentUserActions;                                                                                        //
  }(),                                                                                                                //
                                                                                                                      //
  iconSrcForPackage: function () {                                                                                    // 1159
    function iconSrcForPackage(pkg, usage) {                                                                          // 1159
      return Identicon.iconSrcForPackage(pkg, usage, this.makeWildcardHost("static"));                                // 1160
    }                                                                                                                 //
                                                                                                                      //
    return iconSrcForPackage;                                                                                         //
  }(),                                                                                                                //
                                                                                                                      //
  getDenormalizedGrainInfo: function () {                                                                             // 1163
    function getDenormalizedGrainInfo(grainId) {                                                                      // 1163
      var grain = this.getGrain(grainId);                                                                             // 1164
      var pkg = this.collections.packages.findOne(grain.packageId);                                                   // 1165
                                                                                                                      //
      if (!pkg) {                                                                                                     // 1167
        pkg = this.collections.devPackages.findOne(grain.packageId);                                                  // 1168
      }                                                                                                               //
                                                                                                                      //
      var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || { defaultText: "" };                             // 1171
      var grainInfo = { appTitle: appTitle };                                                                         // 1172
                                                                                                                      //
      if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                              // 1174
        var icons = pkg.manifest.metadata.icons;                                                                      // 1175
        grainInfo.icon = icons.grain || icons.appGrid;                                                                // 1176
      }                                                                                                               //
                                                                                                                      //
      // Only provide an app ID if we have no icon asset to provide and need to offer an identicon.                   //
      if (!grainInfo.icon && pkg) {                                                                                   // 1163
        grainInfo.appId = pkg.appId;                                                                                  // 1181
      }                                                                                                               //
                                                                                                                      //
      return grainInfo;                                                                                               // 1184
    }                                                                                                                 //
                                                                                                                      //
    return getDenormalizedGrainInfo;                                                                                  //
  }(),                                                                                                                //
                                                                                                                      //
  getPlan: function () {                                                                                              // 1187
    function getPlan(id) {                                                                                            // 1187
      check(id, String);                                                                                              // 1188
      var plan = Plans.findOne(id);                                                                                   // 1189
      if (!plan) {                                                                                                    // 1190
        throw new Error("no such plan: " + id);                                                                       // 1191
      }                                                                                                               //
                                                                                                                      //
      return plan;                                                                                                    // 1194
    }                                                                                                                 //
                                                                                                                      //
    return getPlan;                                                                                                   //
  }(),                                                                                                                //
                                                                                                                      //
  listPlans: function () {                                                                                            // 1197
    function listPlans() {                                                                                            // 1197
      return Plans.find({}, { sort: { price: 1 } });                                                                  // 1198
    }                                                                                                                 //
                                                                                                                      //
    return listPlans;                                                                                                 //
  }(),                                                                                                                //
                                                                                                                      //
  getMyPlan: function () {                                                                                            // 1201
    function getMyPlan() {                                                                                            // 1201
      var user = Meteor.user();                                                                                       // 1202
      return user && Plans.findOne(user.plan || "free");                                                              // 1203
    }                                                                                                                 //
                                                                                                                      //
    return getMyPlan;                                                                                                 //
  }(),                                                                                                                //
                                                                                                                      //
  getMyReferralBonus: function () {                                                                                   // 1206
    function getMyReferralBonus(user) {                                                                               // 1206
      // This function is called from the server and from the client, similar to getMyPlan().                         //
      //                                                                                                              //
      // The parameter may be omitted in which case the current user is assumed.                                      //
                                                                                                                      //
      return calculateReferralBonus(user || Meteor.user());                                                           // 1211
    }                                                                                                                 //
                                                                                                                      //
    return getMyReferralBonus;                                                                                        //
  }(),                                                                                                                //
                                                                                                                      //
  getMyUsage: function () {                                                                                           // 1214
    function getMyUsage(user) {                                                                                       // 1214
      user = user || Meteor.user();                                                                                   // 1215
      if (user && (Meteor.isServer || user.pseudoUsage)) {                                                            // 1216
        if (Meteor.isClient) {                                                                                        // 1217
          // Filled by pseudo-subscription to "getMyUsage". WARNING: The subscription is currenly                     //
          // not reactive.                                                                                            //
          return user.pseudoUsage;                                                                                    // 1220
        } else {                                                                                                      //
          return {                                                                                                    // 1222
            grains: Grains.find({ userId: user._id }).count(),                                                        // 1223
            storage: user.storageUsage || 0,                                                                          // 1224
            compute: 0 };                                                                                             // 1225
        }                                                                                                             //
      } else // not tracked yet                                                                                       //
        {                                                                                                             // 1228
          return { grains: 0, storage: 0, compute: 0 };                                                               // 1229
        }                                                                                                             //
    }                                                                                                                 //
                                                                                                                      //
    return getMyUsage;                                                                                                //
  }(),                                                                                                                //
                                                                                                                      //
  isUninvitedFreeUser: function () {                                                                                  // 1233
    function isUninvitedFreeUser() {                                                                                  // 1233
      if (!Meteor.settings["public"].allowUninvited) return false;                                                    // 1234
                                                                                                                      //
      var user = Meteor.user();                                                                                       // 1236
      return user && !user.expires && (!user.plan || user.plan === "free");                                           // 1237
    }                                                                                                                 //
                                                                                                                      //
    return isUninvitedFreeUser;                                                                                       //
  }(),                                                                                                                //
                                                                                                                      //
  getSetting: function () {                                                                                           // 1240
    function getSetting(name) {                                                                                       // 1240
      var setting = Settings.findOne(name);                                                                           // 1241
      return setting && setting.value;                                                                                // 1242
    }                                                                                                                 //
                                                                                                                      //
    return getSetting;                                                                                                //
  }(),                                                                                                                //
                                                                                                                      //
  getSettingWithFallback: function () {                                                                               // 1245
    function getSettingWithFallback(name, fallbackValue) {                                                            // 1245
      var value = this.getSetting(name);                                                                              // 1246
      if (value === undefined) {                                                                                      // 1247
        return fallbackValue;                                                                                         // 1248
      }                                                                                                               //
                                                                                                                      //
      return value;                                                                                                   // 1251
    }                                                                                                                 //
                                                                                                                      //
    return getSettingWithFallback;                                                                                    //
  }(),                                                                                                                //
                                                                                                                      //
  addUserActions: function () {                                                                                       // 1254
    function addUserActions(packageId) {                                                                              // 1254
      //TODO(cleanup): implement this with meteor methods rather than client-side inserts/removes.                    //
      var pack = Packages.findOne(packageId);                                                                         // 1256
      if (pack) {                                                                                                     // 1257
        // Remove old versions.                                                                                       //
        UserActions.find({ userId: Meteor.userId(), appId: pack.appId }).forEach(function (action) {                  // 1259
          UserActions.remove(action._id);                                                                             // 1261
        });                                                                                                           //
                                                                                                                      //
        // Install new.                                                                                               //
        var actions = pack.manifest.actions;                                                                          // 1257
        for (var i in meteorBabelHelpers.sanitizeForInObject(actions)) {                                              // 1266
          var action = actions[i];                                                                                    // 1267
          if ("none" in action.input) {                                                                               // 1268
            var userAction = {                                                                                        // 1269
              userId: Meteor.userId(),                                                                                // 1270
              packageId: pack._id,                                                                                    // 1271
              appId: pack.appId,                                                                                      // 1272
              appTitle: pack.manifest.appTitle,                                                                       // 1273
              appMarketingVersion: pack.manifest.appMarketingVersion,                                                 // 1274
              appVersion: pack.manifest.appVersion,                                                                   // 1275
              title: action.title,                                                                                    // 1276
              nounPhrase: action.nounPhrase,                                                                          // 1277
              command: action.command                                                                                 // 1278
            };                                                                                                        //
            UserActions.insert(userAction);                                                                           // 1280
          } else {}                                                                                                   //
          // TODO(someday):  Implement actions with capability inputs.                                                //
          //jscs:ignore disallowEmptyBlocks                                                                           //
        }                                                                                                             // 1268
                                                                                                                      //
        Meteor.call("deleteUnusedPackages", pack.appId);                                                              // 1286
      }                                                                                                               //
    }                                                                                                                 //
                                                                                                                      //
    return addUserActions;                                                                                            //
  }(),                                                                                                                //
                                                                                                                      //
  sendAdminNotification: function () {                                                                                // 1290
    function sendAdminNotification(message, link) {                                                                   // 1290
      Meteor.users.find({ isAdmin: true }, { fields: { _id: 1 } }).forEach(function (user) {                          // 1291
        Notifications.insert({                                                                                        // 1292
          admin: {                                                                                                    // 1293
            action: link,                                                                                             // 1294
            type: "reportStats"                                                                                       // 1295
          },                                                                                                          //
          userId: user._id,                                                                                           // 1297
          text: { defaultText: message },                                                                             // 1298
          timestamp: new Date(),                                                                                      // 1299
          isUnread: true                                                                                              // 1300
        });                                                                                                           //
      });                                                                                                             //
    }                                                                                                                 //
                                                                                                                      //
    return sendAdminNotification;                                                                                     //
  }(),                                                                                                                //
                                                                                                                      //
  getKeybaseProfile: function () {                                                                                    // 1305
    function getKeybaseProfile(keyFingerprint) {                                                                      // 1305
      return this.collections.keybaseProfiles.findOne(keyFingerprint) || {};                                          // 1306
    }                                                                                                                 //
                                                                                                                      //
    return getKeybaseProfile;                                                                                         //
  }(),                                                                                                                //
                                                                                                                      //
  getServerTitle: function () {                                                                                       // 1309
    function getServerTitle() {                                                                                       // 1309
      var setting = Settings.findOne({ _id: "serverTitle" });                                                         // 1310
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1311
    }                                                                                                                 // 1309
                                                                                                                      //
    return getServerTitle;                                                                                            //
  }(),                                                                                                                //
                                                                                                                      //
  getSmtpConfig: function () {                                                                                        // 1314
    function getSmtpConfig() {                                                                                        //
      var setting = Settings.findOne({ _id: "smtpConfig" });                                                          // 1315
      return setting ? setting.value : undefined; // undefined if subscription is not ready.                          // 1316
    }                                                                                                                 // 1314
                                                                                                                      //
    return getSmtpConfig;                                                                                             //
  }(),                                                                                                                //
                                                                                                                      //
                                                                                                                      //
  getReturnAddress: function () {                                                                                     // 1319
    function getReturnAddress() {                                                                                     // 1319
      var config = this.getSmtpConfig();                                                                              // 1320
      return config && config.returnAddress || ""; // empty if subscription is not ready.                             // 1321
    }                                                                                                                 // 1319
                                                                                                                      //
    return getReturnAddress;                                                                                          //
  }(),                                                                                                                //
                                                                                                                      //
  getReturnAddressWithDisplayName: function () {                                                                      // 1324
    function getReturnAddressWithDisplayName(identityId) {                                                            // 1324
      check(identityId, String);                                                                                      // 1325
      var identity = this.getIdentity(identityId);                                                                    // 1326
      var displayName = identity.profile.name + " (via " + this.getServerTitle() + ")";                               // 1327
                                                                                                                      //
      // First remove any instances of characters that cause trouble for SimpleSmtp. Ideally,                         //
      // we could escape such characters with a backslash, but that does not seem to help here.                       //
      var sanitized = displayName.replace(/"|<|>|\\|\r/g, "");                                                        // 1324
                                                                                                                      //
      return "\"" + sanitized + "\" <" + this.getReturnAddress() + ">";                                               // 1333
    }                                                                                                                 //
                                                                                                                      //
    return getReturnAddressWithDisplayName;                                                                           //
  }(),                                                                                                                //
                                                                                                                      //
  getPrimaryEmail: function () {                                                                                      // 1336
    function getPrimaryEmail(accountId, identityId) {                                                                 // 1336
      check(accountId, String);                                                                                       // 1337
      check(identityId, String);                                                                                      // 1338
                                                                                                                      //
      var identity = this.getIdentity(identityId);                                                                    // 1340
      var senderEmails = SandstormDb.getVerifiedEmails(identity);                                                     // 1341
      var senderPrimaryEmail = _.findWhere(senderEmails, { primary: true });                                          // 1342
      var accountPrimaryEmailAddress = this.getUser(accountId).primaryEmail;                                          // 1343
      if (_.findWhere(senderEmails, { email: accountPrimaryEmailAddress })) {                                         // 1344
        return accountPrimaryEmailAddress;                                                                            // 1345
      } else if (senderPrimaryEmail) {                                                                                //
        return senderPrimaryEmail.email;                                                                              // 1347
      } else {                                                                                                        //
        return null;                                                                                                  // 1349
      }                                                                                                               //
    }                                                                                                                 //
                                                                                                                      //
    return getPrimaryEmail;                                                                                           //
  }(),                                                                                                                //
                                                                                                                      //
  incrementDailySentMailCount: function () {                                                                          // 1353
    function incrementDailySentMailCount(accountId) {                                                                 // 1353
      check(accountId, String);                                                                                       // 1354
                                                                                                                      //
      var DAILY_LIMIT = 50;                                                                                           // 1356
      var user = Meteor.users.findAndModify({                                                                         // 1357
        query: { _id: accountId },                                                                                    // 1358
        update: {                                                                                                     // 1359
          $inc: {                                                                                                     // 1360
            dailySentMailCount: 1                                                                                     // 1361
          }                                                                                                           //
        },                                                                                                            //
        fields: { dailySentMailCount: 1 }                                                                             // 1364
      });                                                                                                             //
                                                                                                                      //
      if (user.dailySentMailCount >= DAILY_LIMIT) {                                                                   // 1367
        throw new Error("Sorry, you've reached your e-mail sending limit for today. Currently, Sandstorm " + "limits each user to " + DAILY_LIMIT + " e-mails per day for spam control reasons. " + "Please feel free to contact us if this is a problem.");
      }                                                                                                               //
    }                                                                                                                 //
                                                                                                                      //
    return incrementDailySentMailCount;                                                                               //
  }(),                                                                                                                //
                                                                                                                      //
  isFeatureKeyValid: function () {                                                                                    // 1375
    function isFeatureKeyValid() {                                                                                    // 1375
      var featureKey = this.currentFeatureKey();                                                                      // 1376
      return !!featureKey;                                                                                            // 1377
    }                                                                                                                 //
                                                                                                                      //
    return isFeatureKeyValid;                                                                                         //
  }(),                                                                                                                //
                                                                                                                      //
  isFeatureKeyValidAndNotExpired: function () {                                                                       // 1380
    function isFeatureKeyValidAndNotExpired() {                                                                       // 1380
      var featureKey = this.currentFeatureKey();                                                                      // 1381
      return featureKey && parseInt(featureKey.expires) > Date.now() / 1000;                                          // 1382
    }                                                                                                                 //
                                                                                                                      //
    return isFeatureKeyValidAndNotExpired;                                                                            //
  }(),                                                                                                                //
                                                                                                                      //
  getLdapUrl: function () {                                                                                           // 1385
    function getLdapUrl() {                                                                                           // 1385
      var setting = Settings.findOne({ _id: "ldapUrl" });                                                             // 1386
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1387
    }                                                                                                                 // 1385
                                                                                                                      //
    return getLdapUrl;                                                                                                //
  }(),                                                                                                                //
                                                                                                                      //
  getLdapBase: function () {                                                                                          // 1390
    function getLdapBase() {                                                                                          // 1390
      var setting = Settings.findOne({ _id: "ldapBase" });                                                            // 1391
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1392
    }                                                                                                                 // 1390
                                                                                                                      //
    return getLdapBase;                                                                                               //
  }(),                                                                                                                //
                                                                                                                      //
  getLdapDnPattern: function () {                                                                                     // 1395
    function getLdapDnPattern() {                                                                                     // 1395
      var setting = Settings.findOne({ _id: "ldapDnPattern" });                                                       // 1396
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1397
    }                                                                                                                 // 1395
                                                                                                                      //
    return getLdapDnPattern;                                                                                          //
  }(),                                                                                                                //
                                                                                                                      //
  getLdapSearchUsername: function () {                                                                                // 1400
    function getLdapSearchUsername() {                                                                                // 1400
      var setting = Settings.findOne({ _id: "ldapSearchUsername" });                                                  // 1401
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1402
    }                                                                                                                 // 1400
                                                                                                                      //
    return getLdapSearchUsername;                                                                                     //
  }(),                                                                                                                //
                                                                                                                      //
  getLdapNameField: function () {                                                                                     // 1405
    function getLdapNameField() {                                                                                     // 1405
      var setting = Settings.findOne({ _id: "ldapNameField" });                                                       // 1406
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1407
    }                                                                                                                 // 1405
                                                                                                                      //
    return getLdapNameField;                                                                                          //
  }(),                                                                                                                //
                                                                                                                      //
  getLdapEmailField: function () {                                                                                    // 1410
    function getLdapEmailField() {                                                                                    // 1410
      var setting = Settings.findOne({ _id: "ldapEmailField" });                                                      // 1411
      return setting ? setting.value : "mail";                                                                        // 1412
      // default to "mail". This setting was added later, and so could potentially be unset.                          //
    }                                                                                                                 // 1410
                                                                                                                      //
    return getLdapEmailField;                                                                                         //
  }(),                                                                                                                //
                                                                                                                      //
  getLdapExplicitDnSelected: function () {                                                                            // 1416
    function getLdapExplicitDnSelected() {                                                                            // 1416
      var setting = Settings.findOne({ _id: "ldapExplicitDnSelected" });                                              // 1417
      return setting && setting.value;                                                                                // 1418
    }                                                                                                                 //
                                                                                                                      //
    return getLdapExplicitDnSelected;                                                                                 //
  }(),                                                                                                                //
                                                                                                                      //
  getLdapFilter: function () {                                                                                        // 1421
    function getLdapFilter() {                                                                                        // 1421
      var setting = Settings.findOne({ _id: "ldapFilter" });                                                          // 1422
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1423
    }                                                                                                                 // 1421
                                                                                                                      //
    return getLdapFilter;                                                                                             //
  }(),                                                                                                                //
                                                                                                                      //
  getLdapSearchBindDn: function () {                                                                                  // 1426
    function getLdapSearchBindDn() {                                                                                  // 1426
      var setting = Settings.findOne({ _id: "ldapSearchBindDn" });                                                    // 1427
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1428
    }                                                                                                                 // 1426
                                                                                                                      //
    return getLdapSearchBindDn;                                                                                       //
  }(),                                                                                                                //
                                                                                                                      //
  getLdapSearchBindPassword: function () {                                                                            // 1431
    function getLdapSearchBindPassword() {                                                                            // 1431
      var setting = Settings.findOne({ _id: "ldapSearchBindPassword" });                                              // 1432
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1433
    }                                                                                                                 // 1431
                                                                                                                      //
    return getLdapSearchBindPassword;                                                                                 //
  }(),                                                                                                                //
                                                                                                                      //
  getOrganizationMembership: function () {                                                                            // 1436
    function getOrganizationMembership() {                                                                            // 1436
      var setting = Settings.findOne({ _id: "organizationMembership" });                                              // 1437
      return setting && setting.value;                                                                                // 1438
    }                                                                                                                 //
                                                                                                                      //
    return getOrganizationMembership;                                                                                 //
  }(),                                                                                                                //
                                                                                                                      //
  getOrganizationEmailEnabled: function () {                                                                          // 1441
    function getOrganizationEmailEnabled() {                                                                          // 1441
      var membership = this.getOrganizationMembership();                                                              // 1442
      return membership && membership.emailToken && membership.emailToken.enabled;                                    // 1443
    }                                                                                                                 //
                                                                                                                      //
    return getOrganizationEmailEnabled;                                                                               //
  }(),                                                                                                                //
                                                                                                                      //
  getOrganizationEmailDomain: function () {                                                                           // 1446
    function getOrganizationEmailDomain() {                                                                           // 1446
      var membership = this.getOrganizationMembership();                                                              // 1447
      return membership && membership.emailToken && membership.emailToken.domain;                                     // 1448
    }                                                                                                                 //
                                                                                                                      //
    return getOrganizationEmailDomain;                                                                                //
  }(),                                                                                                                //
                                                                                                                      //
  getOrganizationGoogleEnabled: function () {                                                                         // 1451
    function getOrganizationGoogleEnabled() {                                                                         // 1451
      var membership = this.getOrganizationMembership();                                                              // 1452
      return membership && membership.google && membership.google.enabled;                                            // 1453
    }                                                                                                                 //
                                                                                                                      //
    return getOrganizationGoogleEnabled;                                                                              //
  }(),                                                                                                                //
                                                                                                                      //
  getOrganizationGoogleDomain: function () {                                                                          // 1456
    function getOrganizationGoogleDomain() {                                                                          // 1456
      var membership = this.getOrganizationMembership();                                                              // 1457
      return membership && membership.google && membership.google.domain;                                             // 1458
    }                                                                                                                 //
                                                                                                                      //
    return getOrganizationGoogleDomain;                                                                               //
  }(),                                                                                                                //
                                                                                                                      //
  getOrganizationLdapEnabled: function () {                                                                           // 1461
    function getOrganizationLdapEnabled() {                                                                           // 1461
      var membership = this.getOrganizationMembership();                                                              // 1462
      return membership && membership.ldap && membership.ldap.enabled;                                                // 1463
    }                                                                                                                 //
                                                                                                                      //
    return getOrganizationLdapEnabled;                                                                                //
  }(),                                                                                                                //
                                                                                                                      //
  getOrganizationSamlEnabled: function () {                                                                           // 1466
    function getOrganizationSamlEnabled() {                                                                           // 1466
      var membership = this.getOrganizationMembership();                                                              // 1467
      return membership && membership.saml && membership.saml.enabled;                                                // 1468
    }                                                                                                                 //
                                                                                                                      //
    return getOrganizationSamlEnabled;                                                                                //
  }(),                                                                                                                //
                                                                                                                      //
  getOrganizationDisallowGuests: function () {                                                                        // 1471
    function getOrganizationDisallowGuests() {                                                                        // 1471
      return this.getOrganizationDisallowGuestsRaw() && this.isFeatureKeyValid();                                     // 1472
    }                                                                                                                 //
                                                                                                                      //
    return getOrganizationDisallowGuests;                                                                             //
  }(),                                                                                                                //
                                                                                                                      //
  getOrganizationDisallowGuestsRaw: function () {                                                                     // 1475
    function getOrganizationDisallowGuestsRaw() {                                                                     // 1475
      var setting = Settings.findOne({ _id: "organizationSettings" });                                                // 1476
      return setting && setting.value && setting.value.disallowGuests;                                                // 1477
    }                                                                                                                 //
                                                                                                                      //
    return getOrganizationDisallowGuestsRaw;                                                                          //
  }(),                                                                                                                //
                                                                                                                      //
  getOrganizationShareContacts: function () {                                                                         // 1480
    function getOrganizationShareContacts() {                                                                         // 1480
      return this.getOrganizationShareContactsRaw() && this.isFeatureKeyValid();                                      // 1481
    }                                                                                                                 //
                                                                                                                      //
    return getOrganizationShareContacts;                                                                              //
  }(),                                                                                                                //
                                                                                                                      //
  getOrganizationShareContactsRaw: function () {                                                                      // 1484
    function getOrganizationShareContactsRaw() {                                                                      // 1484
      var setting = Settings.findOne({ _id: "organizationSettings" });                                                // 1485
      if (!setting || !setting.value || setting.value.shareContacts === undefined) {                                  // 1486
        // default to true if undefined                                                                               //
        return true;                                                                                                  // 1488
      } else {                                                                                                        //
        return setting.value.shareContacts;                                                                           // 1490
      }                                                                                                               //
    }                                                                                                                 //
                                                                                                                      //
    return getOrganizationShareContactsRaw;                                                                           //
  }(),                                                                                                                //
                                                                                                                      //
  getSamlEntryPoint: function () {                                                                                    // 1494
    function getSamlEntryPoint() {                                                                                    // 1494
      var setting = Settings.findOne({ _id: "samlEntryPoint" });                                                      // 1495
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1496
    }                                                                                                                 // 1494
                                                                                                                      //
    return getSamlEntryPoint;                                                                                         //
  }(),                                                                                                                //
                                                                                                                      //
  getSamlPublicCert: function () {                                                                                    // 1499
    function getSamlPublicCert() {                                                                                    // 1499
      var setting = Settings.findOne({ _id: "samlPublicCert" });                                                      // 1500
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1501
    }                                                                                                                 // 1499
                                                                                                                      //
    return getSamlPublicCert;                                                                                         //
  }(),                                                                                                                //
                                                                                                                      //
  getSamlEntityId: function () {                                                                                      // 1504
    function getSamlEntityId() {                                                                                      // 1504
      var setting = Settings.findOne({ _id: "samlEntityId" });                                                        // 1505
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1506
    }                                                                                                                 // 1504
                                                                                                                      //
    return getSamlEntityId;                                                                                           //
  }()                                                                                                                 //
});                                                                                                                   //
                                                                                                                      //
SandstormDb.escapeMongoKey = function (key) {                                                                         // 1510
  // This incredibly poor mechanism for escaping Mongo keys is recommended by the Mongo docs here:                    //
  //   https://docs.mongodb.org/manual/faq/developers/#dollar-sign-operator-escaping                                  //
  // and seems to be a de facto standard, for example:                                                                //
  //   https://www.npmjs.com/package/mongo-key-escape                                                                 //
  return key.replace(".", "．").replace("$", "＄");                                                                     // 1515
};                                                                                                                    //
                                                                                                                      //
var appNameFromPackage = function appNameFromPackage(packageObj) {                                                    // 1518
  // This function takes a Package object from Mongo and returns an                                                   //
  // app title.                                                                                                       //
  var manifest = packageObj.manifest;                                                                                 // 1521
  if (!manifest) return packageObj.appId || packageObj._id || "unknown";                                              // 1522
  var action = manifest.actions[0];                                                                                   // 1523
  appName = manifest.appTitle && manifest.appTitle.defaultText || appNameFromActionName(action.title.defaultText);    // 1524
  return appName;                                                                                                     // 1526
};                                                                                                                    //
                                                                                                                      //
var appNameFromActionName = function appNameFromActionName(name) {                                                    // 1529
  // Hack: Historically we only had action titles, like "New Etherpad Document", not app                              //
  //   titles. But for this UI we want app titles. As a transitionary measure, try to                                 //
  //   derive the app title from the action title.                                                                    //
  // TODO(cleanup): Get rid of this once apps have real titles.                                                       //
  if (!name) {                                                                                                        // 1534
    return "(unnamed)";                                                                                               // 1535
  }                                                                                                                   //
                                                                                                                      //
  if (name.lastIndexOf("New ", 0) === 0) {                                                                            // 1538
    name = name.slice(4);                                                                                             // 1539
  }                                                                                                                   //
                                                                                                                      //
  if (name.lastIndexOf("Hacker CMS", 0) === 0) {                                                                      // 1542
    name = "Hacker CMS";                                                                                              // 1543
  } else {                                                                                                            //
    var space = name.indexOf(" ");                                                                                    // 1545
    if (space > 0) {                                                                                                  // 1546
      name = name.slice(0, space);                                                                                    // 1547
    }                                                                                                                 //
  }                                                                                                                   //
                                                                                                                      //
  return name;                                                                                                        // 1551
};                                                                                                                    //
                                                                                                                      //
var appShortDescriptionFromPackage = function appShortDescriptionFromPackage(pkg) {                                   // 1554
  return pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.shortDescription && pkg.manifest.metadata.shortDescription.defaultText;
};                                                                                                                    //
                                                                                                                      //
var nounPhraseForActionAndAppTitle = function nounPhraseForActionAndAppTitle(action, appTitle) {                      // 1560
  // A hack to deal with legacy apps not including fields in their manifests.                                         //
  // I look forward to the day I can remove most of this code.                                                        //
  // Attempt to figure out the appropriate noun that this action will create.                                         //
  // Use an explicit noun phrase is one is available.  Apps should add these in the future.                           //
  if (action.nounPhrase) return action.nounPhrase.defaultText;                                                        // 1565
  // Otherwise, try to guess one from the structure of the action title field                                         //
  if (action.title && action.title.defaultText) {                                                                     // 1560
    var text = action.title.defaultText;                                                                              // 1568
    // Strip a leading "New "                                                                                         //
    if (text.lastIndexOf("New ", 0) === 0) {                                                                          // 1567
      var candidate = text.slice(4);                                                                                  // 1571
      // Strip a leading appname too, if provided                                                                     //
      if (candidate.lastIndexOf(appTitle, 0) === 0) {                                                                 // 1570
        var newCandidate = candidate.slice(appTitle.length);                                                          // 1574
        // Unless that leaves you with no noun, in which case, use "grain"                                            //
        if (newCandidate.length > 0) {                                                                                // 1573
          return newCandidate.toLowerCase();                                                                          // 1577
        } else {                                                                                                      //
          return "grain";                                                                                             // 1579
        }                                                                                                             //
      }                                                                                                               //
                                                                                                                      //
      return candidate.toLowerCase();                                                                                 // 1583
    }                                                                                                                 //
    // Some other verb phrase was given.  Just use it verbatim, and hope the app author updates                       //
    // the package soon.                                                                                              //
    return text;                                                                                                      // 1567
  } else {                                                                                                            //
    return "grain";                                                                                                   // 1589
  }                                                                                                                   //
};                                                                                                                    //
                                                                                                                      //
// Static methods on SandstormDb that don't need an instance.                                                         //
// Largely things that deal with backwards-compatibility.                                                             //
_.extend(SandstormDb, {                                                                                               // 1595
  appNameFromActionName: appNameFromActionName,                                                                       // 1596
  appNameFromPackage: appNameFromPackage,                                                                             // 1597
  appShortDescriptionFromPackage: appShortDescriptionFromPackage,                                                     // 1598
  nounPhraseForActionAndAppTitle: nounPhraseForActionAndAppTitle                                                      // 1599
});                                                                                                                   //
                                                                                                                      //
if (Meteor.isServer) {                                                                                                // 1602
  (function () {                                                                                                      //
    var cleanupExpiredAssetUploads = function cleanupExpiredAssetUploads() {                                          //
      AssetUploadTokens.remove({ expires: { $lt: Date.now() } });                                                     // 1800
    };                                                                                                                //
                                                                                                                      //
    // Cleanup tokens every hour.                                                                                     //
                                                                                                                      //
                                                                                                                      //
    var Crypto = Npm.require("crypto");                                                                               // 1603
    var ContentType = Npm.require("content-type");                                                                    // 1604
    var Zlib = Npm.require("zlib");                                                                                   // 1605
                                                                                                                      //
    var replicaNumber = Meteor.settings.replicaNumber || 0;                                                           // 1607
                                                                                                                      //
    var computeStagger = function computeStagger(n) {                                                                 // 1609
      // Compute a fraction in the range [0, 1) such that, for any natural number k, the values                       //
      // of computeStagger(n) for all n in [1, 2^k) are uniformly distributed between 0 and 1.                        //
      // The sequence looks like:                                                                                     //
      //   0, 1/2, 1/4, 3/4, 1/8, 3/8, 5/8, 7/8, 1/16, ...                                                            //
      //                                                                                                              //
      // We use this to determine how we'll stagger periodic events performed by this replica.                        //
      // Notice that this allows us to compute a stagger which is independent of the number of                        //
      // front-end replicas present; we can add more replicas to the end without affecting how the                    //
      // earlier ones schedule their events.                                                                          //
      var denom = 1;                                                                                                  // 1619
      while (denom <= n) {                                                                                            // 1620
        denom <<= 1;                                                                                                  // 1620
      }var num = n * 2 - denom + 1;                                                                                   //
      return num / denom;                                                                                             // 1622
    };                                                                                                                //
                                                                                                                      //
    var stagger = computeStagger(replicaNumber);                                                                      // 1625
                                                                                                                      //
    SandstormDb.periodicCleanup = function (intervalMs, callback) {                                                   // 1627
      // Register a database cleanup function than should run periodically, roughly once every                        //
      // interval of the given length.                                                                                //
      //                                                                                                              //
      // In a blackrock deployment with multiple front-ends, the frequency of the cleanup will be                     //
      // scaled appropriately on the assumption that more data is being generated demanding more                      //
      // frequent cleanups.                                                                                           //
                                                                                                                      //
      check(intervalMs, Number);                                                                                      // 1635
      check(callback, Function);                                                                                      // 1636
                                                                                                                      //
      if (intervalMs < 120000) {                                                                                      // 1638
        throw new Error("less than 2-minute cleanup interval seems too fast; " + "are you using the right units?");   // 1639
      }                                                                                                               //
                                                                                                                      //
      // Schedule first cleanup to happen at the next intervalMs interval from the epoch, so that                     //
      // the schedule is independent of the exact startup time.                                                       //
      var first = intervalMs - Date.now() % intervalMs;                                                               // 1627
                                                                                                                      //
      // Stagger cleanups across replicas so that we don't have all replicas trying to clean the                      //
      // same data at the same time.                                                                                  //
      first += Math.floor(intervalMs * computeStagger(replicaNumber));                                                // 1627
                                                                                                                      //
      // If the stagger put us more than an interval away from now, back up.                                          //
      if (first > intervalMs) first -= intervalMs;                                                                    // 1627
                                                                                                                      //
      Meteor.setTimeout(function () {                                                                                 // 1654
        callback();                                                                                                   // 1655
        Meteor.setInterval(callback, intervalMs);                                                                     // 1656
      }, first);                                                                                                      //
    };                                                                                                                //
                                                                                                                      //
    // TODO(cleanup): Node 0.12 has a `gzipSync` but 0.10 (which Meteor still uses) does not.                         //
    var gzipSync = Meteor.wrapAsync(Zlib.gzip, Zlib);                                                                 // 1661
                                                                                                                      //
    var BufferSmallerThan = function BufferSmallerThan(limit) {                                                       // 1663
      return Match.Where(function (buf) {                                                                             // 1664
        check(buf, Buffer);                                                                                           // 1665
        return buf.length < limit;                                                                                    // 1666
      });                                                                                                             //
    };                                                                                                                //
                                                                                                                      //
    var DatabaseId = Match.Where(function (s) {                                                                       // 1670
      check(s, String);                                                                                               // 1671
      return !!s.match(/^[a-zA-Z0-9_]+$/);                                                                            // 1672
    });                                                                                                               //
                                                                                                                      //
    addStaticAsset = function addStaticAsset(metadata, content) {                                                     // 1675
      // Add a new static asset to the database. If `content` is a string rather than a buffer, it                    //
      // will be automatically gzipped before storage; do not specify metadata.encoding in this case.                 //
                                                                                                                      //
      if (typeof content === "string" && !metadata.encoding) {                                                        // 1679
        content = gzipSync(new Buffer(content, "utf8"));                                                              // 1680
        metadata.encoding = "gzip";                                                                                   // 1681
      }                                                                                                               //
                                                                                                                      //
      check(metadata, {                                                                                               // 1684
        mimeType: String,                                                                                             // 1685
        encoding: Match.Optional("gzip")                                                                              // 1686
      });                                                                                                             //
      check(content, BufferSmallerThan(1 << 20));                                                                     // 1688
                                                                                                                      //
      // Validate content type.                                                                                       //
      metadata.mimeType = ContentType.format(ContentType.parse(metadata.mimeType));                                   // 1675
                                                                                                                      //
      var hasher = Crypto.createHash("sha256");                                                                       // 1693
      hasher.update(metadata.mimeType + "\n" + metadata.encoding + "\n", "utf8");                                     // 1694
      hasher.update(content);                                                                                         // 1695
      var hash = hasher.digest("base64");                                                                             // 1696
                                                                                                                      //
      var existing = StaticAssets.findAndModify({                                                                     // 1698
        query: { hash: hash, refcount: { $gte: 1 } },                                                                 // 1699
        update: { $inc: { refcount: 1 } },                                                                            // 1700
        fields: { _id: 1, refcount: 1 }                                                                               // 1701
      });                                                                                                             //
      if (existing) {                                                                                                 // 1703
        return existing._id;                                                                                          // 1704
      }                                                                                                               //
                                                                                                                      //
      return StaticAssets.insert(_.extend({                                                                           // 1707
        hash: hash,                                                                                                   // 1708
        content: content,                                                                                             // 1709
        refcount: 1                                                                                                   // 1710
      }, metadata));                                                                                                  //
    };                                                                                                                //
                                                                                                                      //
    SandstormDb.prototype.addStaticAsset = addStaticAsset;                                                            // 1714
                                                                                                                      //
    SandstormDb.prototype.refStaticAsset = function (id) {                                                            // 1716
      // Increment the refcount on an existing static asset.                                                          //
      //                                                                                                              //
      // You must call this BEFORE adding the new reference to the DB, in case of failure between                     //
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                    //
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                      //
                                                                                                                      //
      check(id, String);                                                                                              // 1723
                                                                                                                      //
      var existing = StaticAssets.findAndModify({                                                                     // 1725
        query: { hash: hash },                                                                                        // 1726
        update: { $inc: { refcount: 1 } },                                                                            // 1727
        fields: { _id: 1, refcount: 1 }                                                                               // 1728
      });                                                                                                             //
      if (!existing) {                                                                                                // 1730
        throw new Error("refStaticAsset() called on asset that doesn't exist");                                       // 1731
      }                                                                                                               //
    };                                                                                                                //
                                                                                                                      //
    SandstormDb.prototype.unrefStaticAsset = function (id) {                                                          // 1735
      // Decrement refcount on a static asset and delete if it has reached zero.                                      //
      //                                                                                                              //
      // You must call this AFTER removing the reference from the DB, in case of failure between                      //
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                    //
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                      //
                                                                                                                      //
      check(id, String);                                                                                              // 1742
                                                                                                                      //
      var existing = StaticAssets.findAndModify({                                                                     // 1744
        query: { _id: id },                                                                                           // 1745
        update: { $inc: { refcount: -1 } },                                                                           // 1746
        fields: { _id: 1, refcount: 1 },                                                                              // 1747
        "new": true                                                                                                   // 1748
      });                                                                                                             //
      if (!existing) {                                                                                                // 1750
        console.error(new Error("unrefStaticAsset() called on asset that doesn't exist").stack);                      // 1751
      } else if (existing.refcount <= 0) {                                                                            //
        StaticAssets.remove({ _id: existing._id });                                                                   // 1753
      }                                                                                                               //
    };                                                                                                                //
                                                                                                                      //
    SandstormDb.prototype.getStaticAsset = function (id) {                                                            // 1757
      // Get a static asset's mimeType, encoding, and raw content.                                                    //
                                                                                                                      //
      check(id, String);                                                                                              // 1760
                                                                                                                      //
      var asset = StaticAssets.findOne(id, { fields: { _id: 0, mimeType: 1, encoding: 1, content: 1 } });             // 1762
      if (asset) {                                                                                                    // 1763
        // TODO(perf): Mongo converts buffers to something else. Figure out a way to avoid a copy                     //
        //   here.                                                                                                    //
        asset.content = new Buffer(asset.content);                                                                    // 1766
      }                                                                                                               //
                                                                                                                      //
      return asset;                                                                                                   // 1769
    };                                                                                                                //
                                                                                                                      //
    SandstormDb.prototype.newAssetUpload = function (purpose) {                                                       // 1772
      check(purpose, { profilePicture: { userId: DatabaseId, identityId: DatabaseId } });                             // 1773
                                                                                                                      //
      return AssetUploadTokens.insert({                                                                               // 1775
        purpose: purpose,                                                                                             // 1776
        expires: new Date(Date.now() + 300000) });                                                                    // 1777
    };                                                                                                                //
                                                                                                                      //
    // in 5 minutes                                                                                                   //
    SandstormDb.prototype.fulfillAssetUpload = function (id) {                                                        // 1781
      // Indicates that the given asset upload has completed. It will be removed and its purpose                      //
      // returned. If no matching upload exists, returns undefined.                                                   //
                                                                                                                      //
      check(id, String);                                                                                              // 1785
                                                                                                                      //
      var upload = AssetUploadTokens.findAndModify({                                                                  // 1787
        query: { _id: id },                                                                                           // 1788
        remove: true                                                                                                  // 1789
      });                                                                                                             //
                                                                                                                      //
      if (upload.expires.valueOf() < Date.now()) {                                                                    // 1792
        return undefined; // already expired                                                                          // 1793
      } else {                                                                                                        // 1792
          return upload.purpose;                                                                                      // 1795
        }                                                                                                             //
    };                                                                                                                //
                                                                                                                      //
    SandstormDb.periodicCleanup(3600000, cleanupExpiredAssetUploads);                                                 // 1804
                                                                                                                      //
    var packageCache = {};                                                                                            // 1806
    // Package info is immutable. Let's cache to save on mongo queries.                                               //
                                                                                                                      //
    SandstormDb.prototype.getPackage = function (packageId) {                                                         // 1809
      // Get the given package record. Since package info is immutable, cache the data in the server                  //
      // to reduce mongo query overhead, since it turns out we have to fetch specific packages a                      //
      // lot.                                                                                                         //
                                                                                                                      //
      if (packageId in packageCache) {                                                                                // 1814
        return packageCache[packageId];                                                                               // 1815
      }                                                                                                               //
                                                                                                                      //
      var pkg = Packages.findOne(packageId);                                                                          // 1818
      if (pkg && pkg.status === "ready") {                                                                            // 1819
        packageCache[packageId] = pkg;                                                                                // 1820
      }                                                                                                               //
                                                                                                                      //
      return pkg;                                                                                                     // 1823
    };                                                                                                                //
                                                                                                                      //
    SandstormDb.prototype.sendAppUpdateNotifications = function (appId, packageId, name, versionNumber, marketingVersion) {
      var _this = this;                                                                                               // 1828
      var actions = _this.collections.userActions.find({ appId: appId, appVersion: { $lt: versionNumber } }, { fields: { userId: 1 } });
      actions.forEach(function (action) {                                                                             // 1831
        var userId = action.userId;                                                                                   // 1832
        var updater = {                                                                                               // 1833
          userId: userId,                                                                                             // 1834
          timestamp: new Date(),                                                                                      // 1835
          isUnread: true                                                                                              // 1836
        };                                                                                                            //
                                                                                                                      //
        // Set only the appId that we care about. Use mongo's dot notation to specify only a single                   //
        // field inside of an object to update                                                                        //
        updater["appUpdates." + appId] = {                                                                            // 1831
          marketingVersion: marketingVersion,                                                                         // 1842
          packageId: packageId,                                                                                       // 1843
          name: name,                                                                                                 // 1844
          version: versionNumber                                                                                      // 1845
        };                                                                                                            //
        _this.collections.notifications.upsert({ userId: userId }, { $set: updater });                                // 1847
      });                                                                                                             //
                                                                                                                      //
      _this.collections.appIndex.update({ _id: appId }, { $set: { hasSentNotifications: true } });                    // 1850
                                                                                                                      //
      // In the case where we replaced a previous notification and that was the only reference to the                 //
      // package, we need to clean it up                                                                              //
      Meteor.call("deleteUnusedPackages", appId);                                                                     // 1827
    };                                                                                                                //
                                                                                                                      //
    SandstormDb.prototype.sendReferralProgramNotification = sendReferralProgramNotification;                          // 1857
                                                                                                                      //
    SandstormDb.prototype.upgradeGrains = function (appId, version, packageId, backend) {                             // 1859
      check(appId, String);                                                                                           // 1860
      check(version, Match.Integer);                                                                                  // 1861
      check(packageId, String);                                                                                       // 1862
                                                                                                                      //
      var selector = {                                                                                                // 1864
        userId: Meteor.userId(),                                                                                      // 1865
        appId: appId,                                                                                                 // 1866
        appVersion: { $lte: version },                                                                                // 1867
        packageId: { $ne: packageId }                                                                                 // 1868
      };                                                                                                              //
                                                                                                                      //
      if (!this.isSimulation) {                                                                                       // 1871
        Grains.find(selector).forEach(function (grain) {                                                              // 1872
          backend.shutdownGrain(grain._id, grain.userId);                                                             // 1873
        });                                                                                                           //
      }                                                                                                               //
                                                                                                                      //
      Grains.update(selector, { $set: { appVersion: version, packageId: packageId } }, { multi: true });              // 1877
    };                                                                                                                //
                                                                                                                      //
    SandstormDb.prototype.startInstall = function (packageId, url, retryFailed, isAutoUpdated) {                      // 1880
      // Mark package for possible installation.                                                                      //
                                                                                                                      //
      var fields = {                                                                                                  // 1883
        status: "download",                                                                                           // 1884
        progress: 0,                                                                                                  // 1885
        url: url,                                                                                                     // 1886
        isAutoUpdated: !!isAutoUpdated                                                                                // 1887
      };                                                                                                              //
                                                                                                                      //
      if (retryFailed) {                                                                                              // 1890
        Packages.update({ _id: packageId, status: "failed" }, { $set: fields });                                      // 1891
      } else {                                                                                                        //
        try {                                                                                                         // 1893
          fields._id = packageId;                                                                                     // 1894
          Packages.insert(fields);                                                                                    // 1895
        } catch (err) {                                                                                               //
          console.error("Simultaneous startInstall()s?", err.stack);                                                  // 1897
        }                                                                                                             //
      }                                                                                                               //
    };                                                                                                                //
                                                                                                                      //
    var ValidKeyFingerprint = Match.Where(function (keyFingerprint) {                                                 // 1902
      check(keyFingerprint, String);                                                                                  // 1903
      return !!keyFingerprint.match(/^[0-9A-F]{40}$/);                                                                // 1904
    });                                                                                                               //
                                                                                                                      //
    SandstormDb.prototype.updateKeybaseProfileAsync = function (keyFingerprint) {                                     // 1907
      // Asynchronously fetch the given Keybase profile and populate the KeybaseProfiles collection.                  //
                                                                                                                      //
      check(keyFingerprint, ValidKeyFingerprint);                                                                     // 1910
                                                                                                                      //
      console.log("fetching keybase", keyFingerprint);                                                                // 1912
                                                                                                                      //
      HTTP.get("https://keybase.io/_/api/1.0/user/lookup.json?key_fingerprint=" + keyFingerprint + "&fields=basics,profile,proofs_summary", {
        timeout: 5000                                                                                                 // 1917
      }, function (err, keybaseResponse) {                                                                            //
        if (err) {                                                                                                    // 1919
          console.log("keybase lookup error:", err.stack);                                                            // 1920
          return;                                                                                                     // 1921
        }                                                                                                             //
                                                                                                                      //
        if (!keybaseResponse.data) {                                                                                  // 1924
          console.log("keybase didn't return JSON? Headers:", keybaseResponse.headers);                               // 1925
          return;                                                                                                     // 1926
        }                                                                                                             //
                                                                                                                      //
        var profile = (keybaseResponse.data.them || [])[0];                                                           // 1929
                                                                                                                      //
        if (profile) {                                                                                                // 1931
          // jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                      //
          var record = {                                                                                              // 1933
            displayName: (profile.profile || {}).full_name,                                                           // 1934
            handle: (profile.basics || {}).username,                                                                  // 1935
            proofs: (profile.proofs_summary || {}).all || []                                                          // 1936
          };                                                                                                          //
          // jscs:enable requireCamelCaseOrUpperCaseIdentifiers                                                       //
                                                                                                                      //
          record.proofs.forEach(function (proof) {                                                                    // 1931
            // Remove potentially Mongo-incompatible stuff. (Currently Keybase returns nothing that                   //
            // this would filter.)                                                                                    //
            for (var field in meteorBabelHelpers.sanitizeForInObject(proof)) {                                        // 1943
              // Don't allow field names containing '.' or '$'. Also don't allow sub-objects mainly                   //
              // because I'm too lazy to check the field names recursively (and Keybase doesn't                       //
              // return any objects anyway).                                                                          //
              if (field.match(/[.$]/) || (0, _typeof3["default"])(proof[field]) === "object") {                       // 1947
                delete proof[field];                                                                                  // 1948
              }                                                                                                       //
            }                                                                                                         //
                                                                                                                      //
            // Indicate not verified.                                                                                 //
            // TODO(security): Asynchronously verify proofs. Presumably we can borrow code from the                   //
            //   Keybase node-based CLI.                                                                              //
            proof.status = "unverified";                                                                              // 1940
          });                                                                                                         //
                                                                                                                      //
          KeybaseProfiles.update(keyFingerprint, { $set: record }, { upsert: true });                                 // 1958
        } else {                                                                                                      //
          // Keybase reports no match, so remove what we know of this user. We don't want to remove                   //
          // the item entirely from the cache as this will cause us to repeatedly re-fetch the data                   //
          // from Keybase.                                                                                            //
          //                                                                                                          //
          // TODO(someday): We could perhaps keep the proofs if we can still verify them directly,                    //
          //   but at present we don't have the ability to verify proofs.                                             //
          KeybaseProfiles.update(keyFingerprint, { $unset: { displayName: "", handle: "", proofs: "" } }, { upsert: true });
        }                                                                                                             //
      });                                                                                                             //
    };                                                                                                                //
                                                                                                                      //
    SandstormDb.prototype.deleteUnusedAccount = function (backend, identityId) {                                      // 1972
      // If there is an *unused* account that has `identityId` as a login identity, deletes it.                       //
                                                                                                                      //
      check(identityId, String);                                                                                      // 1975
      var account = Meteor.users.findOne({ "loginIdentities.id": identityId });                                       // 1976
      if (account && account.loginIdentities.length == 1 && account.nonloginIdentities.length == 0 && !Grains.findOne({ userId: account._id }) && !ApiTokens.findOne({ accountId: account._id }) && (!account.plan || account.plan === "free") && !(account.payments && account.payments.id) && !Contacts.findOne({ ownerId: account._id })) {
        Meteor.users.remove({ _id: account._id });                                                                    // 1985
        backend.deleteUser(account._id);                                                                              // 1986
      }                                                                                                               //
    };                                                                                                                //
                                                                                                                      //
    Meteor.publish("keybaseProfile", function (keyFingerprint) {                                                      // 1990
      check(keyFingerprint, ValidKeyFingerprint);                                                                     // 1991
      var db = this.connection.sandstormDb;                                                                           // 1992
                                                                                                                      //
      var cursor = db.collections.keybaseProfiles.find(keyFingerprint);                                               // 1994
      if (cursor.count() === 0) {                                                                                     // 1995
        // Fire off async update.                                                                                     //
        db.updateKeybaseProfileAsync(keyFingerprint);                                                                 // 1997
      }                                                                                                               //
                                                                                                                      //
      return cursor;                                                                                                  // 2000
    });                                                                                                               //
                                                                                                                      //
    Meteor.publish("appIndex", function (appId) {                                                                     // 2003
      check(appId, String);                                                                                           // 2004
      var db = this.connection.sandstormDb;                                                                           // 2005
      var cursor = db.collections.appIndex.find({ _id: appId });                                                      // 2006
      return cursor;                                                                                                  // 2007
    });                                                                                                               //
                                                                                                                      //
    Meteor.publish("userPackages", function () {                                                                      // 2010
      var _this2 = this;                                                                                              //
                                                                                                                      //
      // Users should be able to see packages that are either:                                                        //
      // 1. referenced by one of their userActions                                                                    //
      // 2. referenced by one of their grains                                                                         //
      var db = this.connection.sandstormDb;                                                                           // 2014
                                                                                                                      //
      // Note that package information, once it is in the database, is static. There's no need to                     //
      // reactively subscribe to changes to a package since they don't change. It's also unecessary                   //
      // to reactively remove a package from the client side when it is removed on the server, or                     //
      // when the client stops using it, because the worst case is the client has a small amount                      //
      // of extra info on a no-longer-used package held in memory until they refresh Sandstorm.                       //
      // So, we implement this as a cache: the first time each package ID shows up among the user's                   //
      // stuff, we push the package info to the client, and then we never update it.                                  //
      //                                                                                                              //
      // Alternatively, we could subscribe to each individual package query, but this would waste                     //
      // lots of server-side resources watching for events that will never happen or don't matter.                    //
      var hasPackage = {};                                                                                            // 2010
      var refPackage = function refPackage(packageId) {                                                               // 2027
        // Ignore dev apps.                                                                                           //
        if (packageId.lastIndexOf("dev-", 0) === 0) return;                                                           // 2029
                                                                                                                      //
        if (!hasPackage[packageId]) {                                                                                 // 2031
          hasPackage[packageId] = true;                                                                               // 2032
          var pkg = db.getPackage(packageId);                                                                         // 2033
          if (pkg) {                                                                                                  // 2034
            _this2.added("packages", packageId, pkg);                                                                 // 2035
          } else {                                                                                                    //
            console.error("shouldn't happen: missing package referenced by user's stuff:", packageId);                // 2037
          }                                                                                                           //
        }                                                                                                             //
      };                                                                                                              //
                                                                                                                      //
      // package source 1: packages referred to by actions                                                            //
      var actions = db.userActions(this.userId);                                                                      // 2010
      var actionsHandle = actions.observe({                                                                           // 2045
        added: function () {                                                                                          // 2046
          function added(newAction) {                                                                                 // 2046
            refPackage(newAction.packageId);                                                                          // 2047
          }                                                                                                           //
                                                                                                                      //
          return added;                                                                                               //
        }(),                                                                                                          //
                                                                                                                      //
        changed: function () {                                                                                        // 2050
          function changed(oldAction, newAction) {                                                                    // 2050
            refPackage(newAction.packageId);                                                                          // 2051
          }                                                                                                           //
                                                                                                                      //
          return changed;                                                                                             //
        }()                                                                                                           //
      });                                                                                                             //
                                                                                                                      //
      // package source 2: packages referred to by grains directly                                                    //
      var grains = db.userGrains(this.userId);                                                                        // 2010
      var grainsHandle = grains.observe({                                                                             // 2057
        added: function () {                                                                                          // 2058
          function added(newGrain) {                                                                                  // 2058
            refPackage(newGrain.packageId);                                                                           // 2059
          }                                                                                                           //
                                                                                                                      //
          return added;                                                                                               //
        }(),                                                                                                          //
                                                                                                                      //
        changed: function () {                                                                                        // 2062
          function changed(oldGrain, newGrain) {                                                                      // 2062
            refPackage(newGrain.packageId);                                                                           // 2063
          }                                                                                                           //
                                                                                                                      //
          return changed;                                                                                             //
        }()                                                                                                           //
      });                                                                                                             //
                                                                                                                      //
      this.onStop(function () {                                                                                       // 2067
        actionsHandle.stop();                                                                                         // 2068
        grainsHandle.stop();                                                                                          // 2069
      });                                                                                                             //
                                                                                                                      //
      this.ready();                                                                                                   // 2072
    });                                                                                                               //
  })();                                                                                                               //
}                                                                                                                     //
                                                                                                                      //
if (Meteor.isServer) {                                                                                                // 2076
  SandstormDb.prototype.currentFeatureKey = function () {                                                             // 2077
    // Returns an object with all of the current signed feature key properties,                                       //
    // or undefined, if the feature key is missing or not correctly signed.                                           //
    var doc = this.collections.featureKey.findOne({ _id: "currentFeatureKey" });                                      // 2080
    if (!doc) return undefined;                                                                                       // 2081
    var buf = new Buffer(doc.value);                                                                                  // 2082
    // We use loadSignedFeatureKey from server/feature-key.js.  This should probably get refactored                   //
    // once we can use ES6 modules.                                                                                   //
    return loadSignedFeatureKey(buf);                                                                                 // 2077
  };                                                                                                                  //
} else {                                                                                                              //
  SandstormDb.prototype.currentFeatureKey = function () {                                                             // 2088
    var featureKey = this.collections.featureKey.findOne({ _id: "currentFeatureKey" });                               // 2089
    if (featureKey && !featureKey.isFreeKey && featureKey.isTrial && parseInt(featureKey.expires) * 1000 < Date.now()) {
      // If feature key was a trial (but not explicitly a free key), and the trial is past its                        //
      // expiration date, mark as a free key instead, with a 15-user limit.                                           //
      featureKey.isFreeKey = true;                                                                                    // 2096
      featureKey.userLimit = 15;                                                                                      // 2097
    }                                                                                                                 //
                                                                                                                      //
    return featureKey;                                                                                                // 2100
  };                                                                                                                  //
}                                                                                                                     //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"profile.js":["babel-runtime/helpers/typeof",function(require){

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sandstorm-db/profile.js                                                                                   //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
var _typeof2 = require("babel-runtime/helpers/typeof");                                                               //
                                                                                                                      //
var _typeof3 = _interopRequireDefault(_typeof2);                                                                      //
                                                                                                                      //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                     //
                                                                                                                      //
// Sandstorm - Personal Cloud Sandbox                                                                                 //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                              //
// All rights reserved.                                                                                               //
//                                                                                                                    //
// Licensed under the Apache License, Version 2.0 (the "License");                                                    //
// you may not use this file except in compliance with the License.                                                   //
// You may obtain a copy of the License at                                                                            //
//                                                                                                                    //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                       //
//                                                                                                                    //
// Unless required by applicable law or agreed to in writing, software                                                //
// distributed under the License is distributed on an "AS IS" BASIS,                                                  //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                           //
// See the License for the specific language governing permissions and                                                //
// limitations under the License.                                                                                     //
                                                                                                                      //
var makeIdenticon = void 0;                                                                                           // 17
var httpProtocol = void 0;                                                                                            // 18
                                                                                                                      //
if (Meteor.isServer) {                                                                                                // 20
  SandstormDb.ensureSubscriberHasIdentity = function (publishHandler, identityId) {                                   // 21
    // Helper for publish functions that need to restrict access based on whether the subscriber                      //
    // has a given identity linked. Automatically stops the subscription if the user loses the                        //
    // identity. Returns a boolean indicating whether the user initially has the identity.                            //
                                                                                                                      //
    var userId = publishHandler.userId;                                                                               // 26
    if (userId === identityId) {                                                                                      // 27
      return true;                                                                                                    // 28
    } else {                                                                                                          //
      var _ret = function () {                                                                                        //
        var hasIdentityCursor = Meteor.users.find({                                                                   // 30
          $or: [{                                                                                                     // 31
            _id: userId,                                                                                              // 33
            "loginIdentities.id": identityId                                                                          // 34
          }, {                                                                                                        //
            _id: userId,                                                                                              // 37
            "nonloginIdentities.id": identityId                                                                       // 38
          }]                                                                                                          //
        });                                                                                                           //
        if (hasIdentityCursor.count() == 0) {                                                                         // 42
          publishHandler.stop();                                                                                      // 43
          return {                                                                                                    // 44
            v: false                                                                                                  //
          };                                                                                                          //
        }                                                                                                             //
                                                                                                                      //
        var handle = hasIdentityCursor.observe({ removed: function () {                                               // 47
            function removed() {                                                                                      // 47
              publishHandler.stop();                                                                                  // 47
            }                                                                                                         //
                                                                                                                      //
            return removed;                                                                                           //
          }() });                                                                                                     //
                                                                                                                      //
        publishHandler.onStop(function () {                                                                           // 49
          handle.stop();                                                                                              // 49
        });                                                                                                           //
                                                                                                                      //
        return {                                                                                                      // 51
          v: true                                                                                                     //
        };                                                                                                            //
      }();                                                                                                            //
                                                                                                                      //
      if ((typeof _ret === "undefined" ? "undefined" : (0, _typeof3["default"])(_ret)) === "object") return _ret.v;   //
    }                                                                                                                 //
  };                                                                                                                  //
                                                                                                                      //
  Meteor.publish("identityProfile", function (identityId) {                                                           // 55
    check(identityId, String);                                                                                        // 56
    if (!SandstormDb.ensureSubscriberHasIdentity(this, identityId)) return;                                           // 57
                                                                                                                      //
    return Meteor.users.find({ _id: identityId }, { fields: {                                                         // 59
        profile: 1,                                                                                                   // 61
        unverifiedEmail: 1,                                                                                           // 62
        expires: 1,                                                                                                   // 63
        createdAt: 1,                                                                                                 // 64
                                                                                                                      //
        "services.dev.name": 1,                                                                                       // 66
                                                                                                                      //
        "services.google.id": 1,                                                                                      // 68
        "services.google.email": 1,                                                                                   // 69
        "services.google.verified_email": 1,                                                                          // 70
        "services.google.name": 1,                                                                                    // 71
        "services.google.picture": 1,                                                                                 // 72
        "services.google.gender": 1,                                                                                  // 73
        "services.google.hd": 1,                                                                                      // 74
                                                                                                                      //
        "services.github.id": 1,                                                                                      // 76
        "services.github.email": 1,                                                                                   // 77
        "services.github.emails": 1,                                                                                  // 78
        "services.github.username": 1,                                                                                // 79
                                                                                                                      //
        "services.email.email": 1,                                                                                    // 81
                                                                                                                      //
        "services.ldap.id": 1,                                                                                        // 83
        "services.ldap.username": 1,                                                                                  // 84
        "services.ldap.rawAttrs": 1,                                                                                  // 85
                                                                                                                      //
        "services.saml.id": 1,                                                                                        // 87
        "services.saml.email": 1,                                                                                     // 88
        "services.saml.displayName": 1                                                                                // 89
      }                                                                                                               //
    });                                                                                                               //
  }), Meteor.publish("accountIdentities", function () {                                                               //
    // Maybe this should be folded into the "credentials" subscription?                                               //
                                                                                                                      //
    if (!this.userId) return [];                                                                                      // 97
                                                                                                                      //
    return Meteor.users.find({ _id: this.userId }, { fields: {                                                        // 99
        profile: 1,                                                                                                   // 102
        verifiedEmail: 1,                                                                                             // 103
        loginIdentities: 1,                                                                                           // 104
        nonloginIdentities: 1,                                                                                        // 105
        expires: 1,                                                                                                   // 106
        primaryEmail: 1                                                                                               // 107
      } });                                                                                                           //
  });                                                                                                                 //
                                                                                                                      //
  makeIdenticon = function makeIdenticon(id) {                                                                        // 111
    // We only make identicons client-side.                                                                           //
    return undefined;                                                                                                 // 113
  };                                                                                                                  //
                                                                                                                      //
  var Url = Npm.require("url");                                                                                       // 116
  httpProtocol = Url.parse(process.env.ROOT_URL).protocol;                                                            // 117
} else {                                                                                                              //
  (function () {                                                                                                      //
    var identiconCache = {};                                                                                          // 119
                                                                                                                      //
    makeIdenticon = function makeIdenticon(id) {                                                                      // 121
      // Given a cryptographic hash as input, generate an identicon. We always use the user's                         //
      // identity ID as the input hash (the same thing passed to apps as the user ID).                                //
                                                                                                                      //
      // Pass to identicon.js exactly the hash that we'd pass to apps as X-Sandstorm-User-Id, so                      //
      // that apps can themselves use identicon.js to produce consistent identicons. As it turns out                  //
      // identicon.js doesn't use the second half of the hash even if we provide it, but slice it                     //
      // anyway to be safe.                                                                                           //
      id = id.slice(0, 32);                                                                                           // 129
                                                                                                                      //
      if (id in identiconCache) {                                                                                     // 131
        return identiconCache[id];                                                                                    // 132
      }                                                                                                               //
                                                                                                                      //
      // Unfortunately, Github's algorithm uses MD5. Whatever, we don't expect these to be secure.                    //
      var data = new Identicon(id, 512).toString();                                                                   // 121
      var result = "data:image/png;base64," + data;                                                                   // 137
      identiconCache[id] = result;                                                                                    // 138
      return result;                                                                                                  // 139
    };                                                                                                                //
                                                                                                                      //
    httpProtocol = window.location.protocol;                                                                          // 142
  })();                                                                                                               //
}                                                                                                                     //
                                                                                                                      //
var GENDERS = { male: "male", female: "female", neutral: "neutral", robot: "robot" };                                 // 145
                                                                                                                      //
function staticAssetUrl(id, staticHost) {                                                                             // 147
  if (id) {                                                                                                           // 148
    return staticHost + "/" + id;                                                                                     // 149
  } else {                                                                                                            //
    return undefined;                                                                                                 // 151
  }                                                                                                                   //
}                                                                                                                     //
                                                                                                                      //
function filterHandle(handle) {                                                                                       // 155
  // Convert disallowed letters into underscores, but no more than one underscore in a row.                           //
  return handle && handle.toLowerCase().split(/[^a-z0-9_]+/g).join("_");                                              // 157
}                                                                                                                     //
                                                                                                                      //
function emailToHandle(email) {                                                                                       // 160
  // Turn an email address into a handle.                                                                             //
                                                                                                                      //
  if (!email) return undefined;                                                                                       // 163
                                                                                                                      //
  // Use the stuff before the @. Ignore stuff after '+' because it's commonly used for filters                        //
  // on the same account.                                                                                             //
  var parts = email.split("@");                                                                                       // 160
  var base = filterHandle(parts[0].split("+")[0]);                                                                    // 168
                                                                                                                      //
  var domain = (parts[1] || "").split(".");                                                                           // 170
  if (domain[domain.length - 1] === "name") {                                                                         // 171
    // Oh, a .name domain. Let's use                                                                                  //
    base = filterHandle(domain.slice(0, domain.length - 1).join("."));                                                // 173
  } else if (_.contains(["me", "self", "contact", "admin", "administrator", "root", "info", "sandstorm", "sandstormio", "inbox", "indiegogo", "mail", "email"], base)) {
    // This is probably an address at a vanity domain. Use the domain itself as the handle.                           //
    base = filterHandle(domain[0]);                                                                                   // 181
  }                                                                                                                   //
                                                                                                                      //
  return filterHandle(base);                                                                                          // 184
}                                                                                                                     //
                                                                                                                      //
SandstormDb.fillInProfileDefaults = function (user) {                                                                 // 187
  var profile = user.profile;                                                                                         // 188
  if (profile.service === "github") {                                                                                 // 189
    profile.name = profile.name || user.services.github.username || "Name Unknown";                                   // 190
    profile.handle = profile.handle || filterHandle(user.services.github.username) || filterHandle(profile.name);     // 191
  } else if (profile.service === "google") {                                                                          //
    profile.name = profile.name || user.services.google.name || "Name Unknown";                                       // 194
    profile.handle = profile.handle || emailToHandle(user.services.google.email) || filterHandle(profile.name);       // 195
    profile.pronoun = profile.pronoun || GENDERS[user.services.google.gender] || "neutral";                           // 197
  } else if (profile.service === "email") {                                                                           //
    var email = user.services.email.email;                                                                            // 199
    profile.name = profile.name || emailToHandle(email);                                                              // 200
    profile.handle = profile.handle || emailToHandle(email);                                                          // 201
  } else if (profile.service === "dev") {                                                                             //
    var lowerCaseName = user.services.dev.name.split(" ")[0].toLowerCase();                                           // 203
    profile.name = profile.name || user.services.dev.name;                                                            // 204
    profile.handle = profile.handle || filterHandle(lowerCaseName);                                                   // 205
    profile.pronoun = profile.pronoun || (_.contains(["alice", "carol", "eve"], lowerCaseName) ? "female" : _.contains(["bob", "dave"], lowerCaseName) ? "male" : "neutral");
  } else if (profile.service === "demo") {                                                                            //
    profile.name = profile.name || "Demo User";                                                                       // 210
    profile.handle = profile.handle || "demo";                                                                        // 211
  } else if (profile.service === "ldap") {                                                                            //
    var setting = Settings.findOne({ _id: "ldapNameField" });                                                         // 213
    var key = setting ? setting.value : "";                                                                           // 214
    profile.handle = profile.handle || user.services.ldap.username;                                                   // 215
    profile.name = profile.name || user.services.ldap.rawAttrs[key] || profile.handle;                                // 216
  } else if (profile.service === "saml") {                                                                            //
    profile.handle = profile.handle || emailToHandle(user.services.saml.email);                                       // 218
    profile.name = profile.name || user.services.saml.displayName || profile.handle;                                  // 219
  } else {                                                                                                            //
    throw new Error("unrecognized identity service: ", profile.service);                                              // 221
  }                                                                                                                   //
                                                                                                                      //
  profile.pronoun = profile.pronoun || "neutral";                                                                     // 224
};                                                                                                                    //
                                                                                                                      //
SandstormDb.fillInIntrinsicName = function (user) {                                                                   // 227
  var profile = user.profile;                                                                                         // 228
  if (profile.service === "github") {                                                                                 // 229
    profile.intrinsicName = user.services.github.username;                                                            // 230
  } else if (profile.service === "google") {                                                                          //
    profile.intrinsicName = user.services.google.name;                                                                // 232
    user.privateIntrinsicName = user.services.google.email;                                                           // 233
  } else if (profile.service === "email") {                                                                           //
    profile.intrinsicName = user.services.email.email;                                                                // 235
  } else if (profile.service === "dev") {                                                                             //
    profile.intrinsicName = user.services.dev.name;                                                                   // 237
  } else if (profile.service === "demo") {                                                                            //
    profile.intrinsicName = "demo on " + user.createdAt.toISOString().substring(0, 10);                               // 239
  } else if (profile.service === "ldap") {                                                                            //
    profile.intrinsicName = user.services.ldap.username;                                                              // 241
  } else if (profile.service === "saml") {                                                                            //
    profile.intrinsicName = user.services.saml.id;                                                                    // 243
  } else {                                                                                                            //
    throw new Error("unrecognized identity service: ", profile.service);                                              // 245
  }                                                                                                                   //
};                                                                                                                    //
                                                                                                                      //
SandstormDb.fillInLoginId = function (identity) {                                                                     // 249
  var service = identity.profile.service;                                                                             // 250
  identity.loginId = Accounts.identityServices[service].getLoginId(identity);                                         // 251
};                                                                                                                    //
                                                                                                                      //
SandstormDb.getVerifiedEmails = function (identity) {                                                                 // 254
  if (identity.services.google && identity.services.google.email && identity.services.google.verified_email) {        // 255
    // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers                                                             //
    return [{ email: identity.services.google.email, primary: true }];                                                // 257
  } else if (identity.services.email) {                                                                               //
    return [{ email: identity.services.email.email, primary: true }];                                                 // 259
  } else if (identity.services.github && identity.services.github.emails) {                                           //
    return _.chain(identity.services.github.emails).filter(function (email) {                                         // 261
      return email.verified;                                                                                          // 262
    }).map(function (email) {                                                                                         //
      return _.pick(email, "email", "primary");                                                                       //
    }).value();                                                                                                       //
  } else if (identity.services.ldap) {                                                                                //
    var email = identity.services.ldap.rawAttrs[SandstormDb.prototype.getLdapEmailField()];                           // 266
    if (email) {                                                                                                      // 267
      return [{ email: email, primary: true }];                                                                       // 268
    }                                                                                                                 //
  } else if (identity.services.saml && identity.services.saml.email) {                                                //
    return [{ email: identity.services.saml.email, primary: true }];                                                  // 271
  }                                                                                                                   //
                                                                                                                      //
  return [];                                                                                                          // 274
};                                                                                                                    //
                                                                                                                      //
SandstormDb.prototype.findIdentitiesByEmail = function (email) {                                                      // 277
  // Returns an array of identities which have the given email address as one of their verified                       //
  // addresses.                                                                                                       //
                                                                                                                      //
  check(email, String);                                                                                               // 281
                                                                                                                      //
  return Meteor.users.find({ $or: [{ "services.google.email": email }, { "services.email.email": email }, { "services.github.emails.email": email }, { "services.saml.email": email }] }).fetch().filter(function (identity) {
    // Verify that the email is verified, since our query doesn't technically do that.                                //
    return !!_findWhere(SandstormDb.getVerifiedEmails(identity), { email: email });                                   // 290
  });                                                                                                                 //
};                                                                                                                    //
                                                                                                                      //
SandstormDb.prototype.findAccountsByEmail = function (email) {                                                        // 294
  var identityIds = _.pluck(this.findIdentitiesByEmail(email), "_id");                                                // 295
  return Meteor.users.find({ $or: [{ "loginIdentities.id": { $in: identityIds } }, { "nonloginIdentities.id": { $in: identityIds } }] }).fetch();
};                                                                                                                    //
                                                                                                                      //
SandstormDb.fillInPictureUrl = function (user) {                                                                      // 302
  var staticHost = httpProtocol + "//" + makeWildcardHost("static");                                                  // 303
  user.profile.pictureUrl = staticAssetUrl(user.profile.picture, staticHost) || makeIdenticon(user._id);              // 304
};                                                                                                                    //
                                                                                                                      //
SandstormDb.getUserIdentityIds = function (user) {                                                                    // 308
  // Given an account user object, returns an array containing the ID of each identity linked to the                  //
  // account. Always returns the most recently added login identity first.                                            //
  if (user && user.loginIdentities) {                                                                                 // 311
    return _.pluck(user.nonloginIdentities.concat(user.loginIdentities), "id").reverse();                             // 312
  } else {                                                                                                            //
    return [];                                                                                                        // 314
  }                                                                                                                   //
};                                                                                                                    //
                                                                                                                      //
SandstormDb.getUserEmails = function (user) {                                                                         // 318
  // Given a user object, returns an array containing all email addresses associated with that user.                  //
  // Each entry in the array is an object of the form:                                                                //
  //     `{email: String, verified: Bool, primary: Optional(Bool)}`                                                   //
  //                                                                                                                  //
  // At most one entry in the result has `primary = true`.                                                            //
  //                                                                                                                  //
  // TODO(cleanup): This actually does need to query the database to fetch profile information                        //
  //   for linked identities, so it probably makes more sense for it to be a non-static method                        //
  //   on SandstormDb.                                                                                                //
                                                                                                                      //
  var identityIds = SandstormDb.getUserIdentityIds(user);                                                             // 329
  var verifiedEmails = {};                                                                                            // 330
  var unverifiedEmails = {};                                                                                          // 331
                                                                                                                      //
  identityIds.forEach(function (id) {                                                                                 // 333
    var identity = Meteor.users.findOne({ _id: id });                                                                 // 334
    if (identity && identity.services) {                                                                              // 335
      SandstormDb.getVerifiedEmails(identity).forEach(function (verifiedEmail) {                                      // 336
        if (verifiedEmail) {                                                                                          // 337
          verifiedEmails[verifiedEmail.email] = true;                                                                 // 338
        }                                                                                                             //
      });                                                                                                             //
    }                                                                                                                 //
                                                                                                                      //
    if (identity && identity.unverifiedEmail) {                                                                       // 343
      unverifiedEmails[identity.unverifiedEmail] = true;                                                              // 344
    }                                                                                                                 //
  });                                                                                                                 //
                                                                                                                      //
  var result = [];                                                                                                    // 348
  _.keys(verifiedEmails).map(function (email) {                                                                       // 349
    result.push({ email: email,                                                                                       // 350
      verified: true,                                                                                                 // 351
      primary: email === user.primaryEmail });                                                                        // 352
  });                                                                                                                 //
                                                                                                                      //
  _.keys(unverifiedEmails).map(function (email) {                                                                     // 355
    if (!(email in verifiedEmails)) {                                                                                 // 356
      result.push({ email: email, verified: false });                                                                 // 356
    }                                                                                                                 //
  });                                                                                                                 //
                                                                                                                      //
  // If `user.primaryEmail` is not among the verified emails, mark the first as primary.                              //
  if (!(user.primaryEmail in verifiedEmails) && result.length > 0) {                                                  // 318
    result[0].primary = true;                                                                                         // 361
  }                                                                                                                   //
                                                                                                                      //
  return result;                                                                                                      // 364
};                                                                                                                    //
                                                                                                                      //
SandstormDb.prototype.addContact = function () {                                                                      // 367
  function addContact(ownerId, identityId) {                                                                          // 367
    check(ownerId, String);                                                                                           // 368
    check(identityId, String);                                                                                        // 369
    var profile = this.getIdentity(identityId).profile;                                                               // 370
    this.collections.contacts.upsert({ ownerId: ownerId, identityId: identityId }, {                                  // 371
      ownerId: ownerId,                                                                                               // 372
      petname: profile && profile.name,                                                                               // 373
      created: new Date(),                                                                                            // 374
      identityId: identityId                                                                                          // 375
    });                                                                                                               //
  }                                                                                                                   //
                                                                                                                      //
  return addContact;                                                                                                  //
}();                                                                                                                  //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"user.js":function(require){

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sandstorm-db/user.js                                                                                      //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
// Sandstorm - Personal Cloud Sandbox                                                                                 //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                              //
// All rights reserved.                                                                                               //
//                                                                                                                    //
// Licensed under the Apache License, Version 2.0 (the "License");                                                    //
// you may not use this file except in compliance with the License.                                                   //
// You may obtain a copy of the License at                                                                            //
//                                                                                                                    //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                       //
//                                                                                                                    //
// Unless required by applicable law or agreed to in writing, software                                                //
// distributed under the License is distributed on an "AS IS" BASIS,                                                  //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                           //
// See the License for the specific language governing permissions and                                                //
// limitations under the License.                                                                                     //
                                                                                                                      //
var Crypto = Npm.require("crypto");                                                                                   // 17
var Future = Npm.require("fibers/future");                                                                            // 18
                                                                                                                      //
userPictureUrl = function userPictureUrl(user) {                                                                      // 20
  if (user.services && !(user.profile && user.profile.picture)) {                                                     // 21
    // Try to determine user's avatar URL from login service.                                                         //
                                                                                                                      //
    var google = user.services.google;                                                                                // 24
    if (google && google.picture) {                                                                                   // 25
      return google.picture;                                                                                          // 26
    }                                                                                                                 //
                                                                                                                      //
    var github = user.services.github;                                                                                // 29
    if (github && github.id) {                                                                                        // 30
      return "https://avatars.githubusercontent.com/u/" + github.id;                                                  // 31
    }                                                                                                                 //
                                                                                                                      //
    // Note that we do NOT support Gravatar for email addresses because pinging Gravatar would be                     //
    // a data leak, revealing that the user has logged into this Sandstorm server. Google and                         //
    // Github are different because they are actually the identity providers, so they already know                    //
    // the user logged in.                                                                                            //
  }                                                                                                                   // 21
};                                                                                                                    //
                                                                                                                      //
fetchPicture = function fetchPicture(url) {                                                                           // 41
  try {                                                                                                               // 42
    var result = HTTP.get(url, {                                                                                      // 43
      npmRequestOptions: { encoding: null },                                                                          // 44
      timeout: 5000                                                                                                   // 45
    });                                                                                                               //
                                                                                                                      //
    var metadata = {};                                                                                                // 48
                                                                                                                      //
    metadata.mimeType = result.headers["content-type"];                                                               // 50
    if (metadata.mimeType.lastIndexOf("image/png", 0) === -1 && metadata.mimeType.lastIndexOf("image/jpeg", 0) === -1) {
      throw new Error("unexpected Content-Type:", metadata.mimeType);                                                 // 53
    }                                                                                                                 //
                                                                                                                      //
    var enc = result.headers["content-encoding"];                                                                     // 56
    if (enc && enc !== "identity") {                                                                                  // 57
      metadata.encoding = enc;                                                                                        // 58
    }                                                                                                                 //
                                                                                                                      //
    return addStaticAsset(metadata, result.content);                                                                  // 61
  } catch (err) {                                                                                                     //
    console.error("failed to fetch user profile picture:", url, err.stack);                                           // 63
  }                                                                                                                   //
};                                                                                                                    //
                                                                                                                      //
var ValidHandle = Match.Where(function (handle) {                                                                     // 67
  check(handle, String);                                                                                              // 68
  return !!handle.match(/^[a-z_][a-z0-9_]*$/);                                                                        // 69
});                                                                                                                   //
                                                                                                                      //
var localSandstormDb = new SandstormDb();                                                                             // 72
// TODO(someday): fix this when SandstormDb actually stores meaningful state on the object.                           //
// Unfortunately, onCreateUser doesn't pass along the connection object.                                              //
                                                                                                                      //
Accounts.onCreateUser(function (options, user) {                                                                      // 76
  if (user.loginIdentities) {                                                                                         // 77
    // it's an account                                                                                                //
    check(user, { _id: String,                                                                                        // 79
      createdAt: Date,                                                                                                // 80
      isAdmin: Match.Optional(Boolean),                                                                               // 81
      hasCompletedSignup: Match.Optional(Boolean),                                                                    // 82
      signupKey: Match.Optional(String),                                                                              // 83
      signupNote: Match.Optional(String),                                                                             // 84
      signupEmail: Match.Optional(String),                                                                            // 85
      expires: Match.Optional(Date),                                                                                  // 86
      appDemoId: Match.Optional(String),                                                                              // 87
      loginIdentities: [{ id: String }],                                                                              // 88
      nonloginIdentities: [{ id: String }] });                                                                        // 89
                                                                                                                      //
    if (Meteor.settings["public"].quotaEnabled) {                                                                     // 91
      user.experiments = user.experiments || {};                                                                      // 92
      user.experiments = {                                                                                            // 93
        firstTimeBillingPrompt: Math.random() < 0.5 ? "control" : "test"                                              // 94
      };                                                                                                              //
      if (!("expires" in user)) {                                                                                     // 96
        sendReferralProgramNotification(user._id);                                                                    // 97
      }                                                                                                               //
    }                                                                                                                 //
                                                                                                                      //
    return user;                                                                                                      // 101
  }                                                                                                                   //
                                                                                                                      //
  if (localSandstormDb.getOrganizationDisallowGuests() && !localSandstormDb.isIdentityInOrganization(user)) {         // 104
    throw new Meteor.Error(400, "User not in organization.");                                                         // 106
  }                                                                                                                   //
                                                                                                                      //
  // Check profile.                                                                                                   //
  if (options.profile) {                                                                                              // 76
    // TODO(cleanup): This check also appears in accounts-ui-methods.js.                                              //
    check(options.profile, Match.ObjectIncluding({                                                                    // 112
      name: Match.OneOf(null, Match.Optional(String)),                                                                // 113
      handle: Match.Optional(ValidHandle),                                                                            // 114
      pronoun: Match.Optional(Match.OneOf("male", "female", "neutral", "robot"))                                      // 115
    }));                                                                                                              //
  }                                                                                                                   //
                                                                                                                      //
  check(options.unverifiedEmail, Match.Optional(String));                                                             // 119
                                                                                                                      //
  if (options.unverifiedEmail) {                                                                                      // 121
    user.unverifiedEmail = options.unverifiedEmail;                                                                   // 122
  }                                                                                                                   //
                                                                                                                      //
  user.profile = _.pick(options.profile || {}, "name", "handle", "pronouns");                                         // 125
                                                                                                                      //
  // Try downloading avatar.                                                                                          //
  var url = userPictureUrl(user);                                                                                     // 76
  if (url) {                                                                                                          // 129
    var assetId = fetchPicture(url);                                                                                  // 130
    if (assetId) {                                                                                                    // 131
      user.profile.picture = assetId;                                                                                 // 132
    }                                                                                                                 //
  }                                                                                                                   //
                                                                                                                      //
  var serviceUserId = void 0;                                                                                         // 136
  if (user.services && user.services.dev) {                                                                           // 137
    check(user.services.dev, { name: String, isAdmin: Boolean, hasCompletedSignup: Boolean });                        // 138
    serviceUserId = user.services.dev.name;                                                                           // 139
    user.profile.service = "dev";                                                                                     // 140
  } else if ("expires" in user) {                                                                                     //
    serviceUserId = user._id;                                                                                         // 142
    user.profile.service = "demo";                                                                                    // 143
  } else if (user.services && user.services.email) {                                                                  //
    check(user.services.email, { email: String,                                                                       // 145
      tokens: [{ digest: String, algorithm: String, createdAt: Date }] });                                            // 147
    serviceUserId = user.services.email.email;                                                                        // 148
    user.profile.service = "email";                                                                                   // 149
  } else if (user.services && "google" in user.services) {                                                            //
    serviceUserId = user.services.google.id;                                                                          // 151
    user.profile.service = "google";                                                                                  // 152
  } else if (user.services && "github" in user.services) {                                                            //
    serviceUserId = user.services.github.id;                                                                          // 154
    user.profile.service = "github";                                                                                  // 155
  } else if (user.services && "ldap" in user.services) {                                                              //
    serviceUserId = user.services.ldap.id;                                                                            // 157
    user.profile.service = "ldap";                                                                                    // 158
  } else if (user.services && "saml" in user.services) {                                                              //
    serviceUserId = user.services.saml.id;                                                                            // 160
    user.profile.service = "saml";                                                                                    // 161
  } else {                                                                                                            //
    throw new Meteor.Error(400, "user does not have a recognized identity provider: " + JSON.stringify(user));        // 163
  }                                                                                                                   //
                                                                                                                      //
  user._id = Crypto.createHash("sha256").update(user.profile.service + ":" + serviceUserId).digest("hex");            // 167
                                                                                                                      //
  return user;                                                                                                        // 170
});                                                                                                                   //
                                                                                                                      //
Accounts.validateLoginAttempt(function (attempt) {                                                                    // 173
  if (!attempt.allowed) {                                                                                             // 174
    return false;                                                                                                     // 175
  }                                                                                                                   //
                                                                                                                      //
  var db = attempt.connection.sandstormDb;                                                                            // 178
  var user = attempt.user;                                                                                            // 179
  if (user.loginIdentities) {                                                                                         // 180
    // it's an account                                                                                                //
    if (db.getOrganizationDisallowGuests() && !db.isUserInOrganization(user)) {                                       // 182
      throw new Meteor.Error(403, "User not in organization.");                                                       // 184
    }                                                                                                                 //
  } else {                                                                                                            //
    if (db.getOrganizationDisallowGuests() && !db.isIdentityInOrganization(user)) {                                   // 187
      throw new Meteor.Error(403, "User not in organization.");                                                       // 189
    }                                                                                                                 //
  }                                                                                                                   //
                                                                                                                      //
  return true;                                                                                                        // 193
});                                                                                                                   //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"migrations.js":function(require){

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sandstorm-db/migrations.js                                                                                //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
// Minimal tooling for doing run-at-least-once, ordered migrations.                                                   //
//                                                                                                                    //
// Because migrations can experience partial failure and likely have                                                  //
// side-effects, we should be careful to make sure all migrations are                                                 //
// idempotent and safe to accidentally run multiple times.                                                            //
                                                                                                                      //
var Future = Npm.require("fibers/future");                                                                            // 7
var Url = Npm.require("url");                                                                                         // 8
var Crypto = Npm.require("crypto");                                                                                   // 9
                                                                                                                      //
var updateLoginStyleToRedirect = function updateLoginStyleToRedirect() {                                              // 11
  var configurations = Package["service-configuration"].ServiceConfiguration.configurations;                          // 12
  ["google", "github"].forEach(function (serviceName) {                                                               // 13
    var config = configurations.findOne({ service: serviceName });                                                    // 14
    if (config && config.loginStyle !== "redirect") {                                                                 // 15
      configurations.update({ service: serviceName }, { $set: { loginStyle: "redirect" } });                          // 16
    }                                                                                                                 //
  });                                                                                                                 //
};                                                                                                                    //
                                                                                                                      //
var enableLegacyOAuthProvidersIfNotInSettings = function enableLegacyOAuthProvidersIfNotInSettings() {                // 21
  // In the before time, Google and Github login were enabled by default.                                             //
  //                                                                                                                  //
  // This actually didn't make much sense, required the first user to configure                                       //
  // OAuth, and had some trust-the-first-user properties that weren't totally                                         //
  // secure.                                                                                                          //
  //                                                                                                                  //
  // Now, we have admin-token, so we wish to disable all logins by default                                            //
  // (since they need to be configured anyway) but since users may have never                                         //
  // explicitly told Sandstorm that Google or Github login should be enabled,                                         //
  // we can't just use the value in the Settings collection, since it might                                           //
  // never have been set.                                                                                             //
  //                                                                                                                  //
  // Thus, if the service is configured but absent from Settings, we should                                           //
  // explicitly enable it in Settings, and then the rest of the logic can just                                        //
  // depend on what value is in Settings and default to false without breaking                                        //
  // user installations.                                                                                              //
  var configurations = Package["service-configuration"].ServiceConfiguration.configurations;                          // 38
  ["google", "github"].forEach(function (serviceName) {                                                               // 39
    var config = configurations.findOne({ service: serviceName });                                                    // 40
    var serviceConfig = Settings.findOne({ _id: serviceName });                                                       // 41
    if (config && !serviceConfig) {                                                                                   // 42
      // Only explicitly enable the login service if:                                                                 //
      // 1) the service is already configured                                                                         //
      // 2) there is no sandstorm configuration already present (the user was                                         //
      //    using the previous default behavior).                                                                     //
      Settings.insert({ _id: serviceName, value: true });                                                             // 47
    }                                                                                                                 //
  });                                                                                                                 //
};                                                                                                                    //
                                                                                                                      //
var denormalizeInviteInfo = function denormalizeInviteInfo() {                                                        // 52
  // When a user is invited via a signup token, the `signupKey` field of their user table entry                       //
  // has always been populated to indicate the key they used. This points into the SignupKeys table                   //
  // which has more information about the key, namely a freeform note entered by the admin when                       //
  // they created the key. In the case that the email invite form was used, the note has the form                     //
  // "E-mail invite to <address>".                                                                                    //
  //                                                                                                                  //
  // Later, we decided it was useful to indicate in the users table visible to the admin                              //
  // information about the invite terms. Namely, for email invites we want to show the address                        //
  // and for others we want to show the note. To make this efficient, fields `signupNote` and                         //
  // `signupEmail` were added to the users table. We can backfill these values by denormalizing                       //
  // from the SignupKeys table.                                                                                       //
                                                                                                                      //
  Meteor.users.find().forEach(function (user) {                                                                       // 65
    if (user.signupKey && typeof user.signupKey === "string" && user.signupKey !== "admin") {                         // 66
      var signupInfo = SignupKeys.findOne(user.signupKey);                                                            // 67
      if (signupInfo && signupInfo.note) {                                                                            // 68
        var newFields = { signupNote: signupInfo.note };                                                              // 69
                                                                                                                      //
        var prefix = "E-mail invite to ";                                                                             // 71
        if (signupInfo.note.lastIndexOf(prefix) === 0) {                                                              // 72
          newFields.signupEmail = signupInfo.note.slice(prefix.length);                                               // 73
        }                                                                                                             //
                                                                                                                      //
        Meteor.users.update(user._id, { $set: newFields });                                                           // 76
      }                                                                                                               //
    }                                                                                                                 //
  });                                                                                                                 //
};                                                                                                                    //
                                                                                                                      //
function mergeRoleAssignmentsIntoApiTokens() {                                                                        // 82
  RoleAssignments.find().forEach(function (roleAssignment) {                                                          // 83
    ApiTokens.insert({                                                                                                // 84
      grainId: roleAssignment.grainId,                                                                                // 85
      userId: roleAssignment.sharer,                                                                                  // 86
      roleAssignment: roleAssignment.roleAssignment,                                                                  // 87
      petname: roleAssignment.petname,                                                                                // 88
      created: roleAssignment.created,                                                                                // 89
      owner: {                                                                                                        // 90
        user: {                                                                                                       // 91
          userId: roleAssignment.recipient,                                                                           // 92
          title: roleAssignment.title                                                                                 // 93
        }                                                                                                             //
      }                                                                                                               //
    });                                                                                                               //
  });                                                                                                                 //
}                                                                                                                     //
                                                                                                                      //
function fixOasisStorageUsageStats() {}                                                                               // 100
// This migration only pertained to Oasis and it was successfully applied there. Since it referred                    //
// to some global variables that we later wanted to remove and/or rename, we've since replaced it                     //
// with a no-op.                                                                                                      //
                                                                                                                      //
function fetchProfilePictures() {                                                                                     // 105
  Meteor.users.find({}).forEach(function (user) {                                                                     // 106
    var url = userPictureUrl(user);                                                                                   // 107
    if (url) {                                                                                                        // 108
      console.log("Fetching user picture:", url);                                                                     // 109
      var assetId = fetchPicture(url);                                                                                // 110
      if (assetId) {                                                                                                  // 111
        Meteor.users.update(user._id, { $set: { "profile.picture": assetId } });                                      // 112
      }                                                                                                               //
    }                                                                                                                 //
  });                                                                                                                 //
}                                                                                                                     //
                                                                                                                      //
function assignPlans() {                                                                                              // 118
  if (Meteor.settings["public"].quotaEnabled && SandstormDb.paymentsMigrationHook) {                                  // 119
    SandstormDb.paymentsMigrationHook(SignupKeys, Plans.find().fetch());                                              // 120
  }                                                                                                                   //
}                                                                                                                     //
                                                                                                                      //
function removeKeyrings() {                                                                                           // 124
  // These blobs full of public keys were not intended to find their way into mongo and while                         //
  // harmless they slow things down because they're huge. Remove them.                                                //
  Packages.update({ "manifest.metadata.pgpKeyring": { $exists: true } }, { $unset: { "manifest.metadata.pgpKeyring": "" } }, { multi: true });
}                                                                                                                     //
                                                                                                                      //
function useLocalizedTextInUserActions() {                                                                            // 132
  function toLocalizedText(newObj, oldObj, field) {                                                                   // 133
    if (field in oldObj) {                                                                                            // 134
      if (typeof oldObj[field] === "string") {                                                                        // 135
        newObj[field] = { defaultText: oldObj[field] };                                                               // 136
      } else {                                                                                                        //
        newObj[field] = oldObj[field];                                                                                // 138
      }                                                                                                               //
    }                                                                                                                 //
  }                                                                                                                   //
                                                                                                                      //
  UserActions.find({}).forEach(function (userAction) {                                                                // 143
    var fields = {};                                                                                                  // 144
    toLocalizedText(fields, userAction, "appTitle");                                                                  // 145
    toLocalizedText(fields, userAction, "title");                                                                     // 146
    toLocalizedText(fields, userAction, "nounPhrase");                                                                // 147
    UserActions.update(userAction._id, { $set: fields });                                                             // 148
  });                                                                                                                 //
}                                                                                                                     //
                                                                                                                      //
function verifyAllPgpSignatures() {                                                                                   // 152
  Packages.find({}).forEach(function (pkg) {                                                                          // 153
    try {                                                                                                             // 154
      console.log("checking PGP signature for package:", pkg._id);                                                    // 155
      var info = waitPromise(globalBackend.cap().tryGetPackage(pkg._id));                                             // 156
      if (info.authorPgpKeyFingerprint) {                                                                             // 157
        console.log("  " + info.authorPgpKeyFingerprint);                                                             // 158
        Packages.update(pkg._id, { $set: { authorPgpKeyFingerprint: info.authorPgpKeyFingerprint } });                // 159
      } else {                                                                                                        //
        console.log("  no signature");                                                                                // 162
      }                                                                                                               //
    } catch (err) {                                                                                                   //
      console.error(err.stack);                                                                                       // 165
    }                                                                                                                 //
  });                                                                                                                 //
}                                                                                                                     //
                                                                                                                      //
function splitUserIdsIntoAccountIdsAndIdentityIds() {                                                                 // 170
  Meteor.users.find().forEach(function (user) {                                                                       // 171
    var identity = {};                                                                                                // 172
    var serviceUserId = void 0;                                                                                       // 173
    if ("devName" in user) {                                                                                          // 174
      identity.service = "dev";                                                                                       // 175
      serviceUserId = user.devName;                                                                                   // 176
    } else if ("expires" in user) {                                                                                   //
      identity.service = "demo";                                                                                      // 178
      serviceUserId = user._id;                                                                                       // 179
    } else if (user.services && "google" in user.services) {                                                          //
      identity.service = "google";                                                                                    // 181
      if (user.services.google.email && user.services.google.verified_email) {                                        // 182
        // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers                                                         //
        identity.verifiedEmail = user.services.google.email;                                                          // 183
      }                                                                                                               //
                                                                                                                      //
      serviceUserId = user.services.google.id;                                                                        // 186
    } else if (user.services && "github" in user.services) {                                                          //
      identity.service = "github";                                                                                    // 188
      identity.unverifiedEmail = user.services.github.email;                                                          // 189
      serviceUserId = user.services.github.id;                                                                        // 190
    } else if (user.services && "emailToken" in user.services) {                                                      //
      identity.service = "emailToken";                                                                                // 192
      identity.verifiedEmail = user.services.emailToken.email;                                                        // 193
      serviceUserId = user.services.emailToken.email;                                                                 // 194
    }                                                                                                                 //
                                                                                                                      //
    identity.id = Crypto.createHash("sha256").update(identity.service + ":" + serviceUserId).digest("hex");           // 197
                                                                                                                      //
    if (user.profile) {                                                                                               // 200
      if (user.profile.name) {                                                                                        // 201
        identity.name = user.profile.name;                                                                            // 202
      }                                                                                                               //
                                                                                                                      //
      if (user.profile.handle) {                                                                                      // 205
        identity.handle = user.profile.handle;                                                                        // 206
      }                                                                                                               //
                                                                                                                      //
      if (user.profile.picture) {                                                                                     // 209
        identity.picture = user.profile.picture;                                                                      // 210
      }                                                                                                               //
                                                                                                                      //
      if (user.profile.pronoun) {                                                                                     // 213
        identity.pronoun = user.profile.pronoun;                                                                      // 214
      }                                                                                                               //
                                                                                                                      //
      if (user.profile.email) {                                                                                       // 217
        identity.unverifiedEmail = user.profile.email;                                                                // 218
      }                                                                                                               //
    }                                                                                                                 //
                                                                                                                      //
    identity.main = true;                                                                                             // 222
                                                                                                                      //
    Meteor.users.update(user._id, { $set: { identities: [identity] } });                                              // 224
                                                                                                                      //
    Grains.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });                      // 226
    Sessions.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });                    // 227
    ApiTokens.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });                   // 228
    ApiTokens.update({ "owner.user.userId": user._id }, { $set: { "owner.user.identityId": identity.id } }, { multi: true });
    ApiTokens.update({ "owner.grain.introducerUser": user._id }, { $set: { "owner.grain.introducerIdentity": identity.id } }, { multi: true });
                                                                                                                      //
    while (ApiTokens.update({ "requirements.permissionsHeld.userId": user._id }, { $set: { "requirements.$.permissionsHeld.identityId": identity.id },
      $unset: { "requirements.$.permissionsHeld.userId": 1 } }, { multi: true }) > 0) {}                              // 240
    // The `$` operatorer modifies the first element in the array that matches the query. Since                       //
    // there may be many matches, we need to repeat until no documents are modified.                                  //
  });                                                                                                                 //
                                                                                                                      // 171
  ApiTokens.remove({ userInfo: { $exists: true } });                                                                  // 247
  // We've renamed `Grain.UserInfo.userId` to `Grain.userInfo.identityId`. The only place                             //
  // that this field could show up in the database was in this deprecated, no-longer-functional                       //
  // form of API token.                                                                                               //
}                                                                                                                     // 170
                                                                                                                      //
function appUpdateSettings() {                                                                                        // 253
  Settings.insert({ _id: "appMarketUrl", value: "https://apps.sandstorm.io" });                                       // 254
  Settings.insert({ _id: "appIndexUrl", value: "https://app-index.sandstorm.io" });                                   // 255
  Settings.insert({ _id: "appUpdatesEnabled", value: true });                                                         // 256
}                                                                                                                     //
                                                                                                                      //
function moveDevAndEmailLoginDataIntoIdentities() {                                                                   // 259
  Meteor.users.find().forEach(function (user) {                                                                       // 260
    if (user.identities.length != 1) {                                                                                // 261
      throw new Error("User does not have exactly one identity: ", user);                                             // 262
    }                                                                                                                 //
                                                                                                                      //
    var identity = user.identities[0];                                                                                // 265
    if (Match.test(identity.service, Object)) {                                                                       // 266
      return;                                                                                                         // 266
    } // Already migrated.                                                                                            //
                                                                                                                      //
    var newIdentity = _.pick(identity, "id", "main", "noLogin", "verifiedEmail", "unverifiedEmail");                  // 260
    newIdentity.profile = _.pick(identity, "name", "handle", "picture", "pronoun");                                   // 269
                                                                                                                      //
    var serviceObject = {};                                                                                           // 271
    var fieldsToUnset = {};                                                                                           // 272
                                                                                                                      //
    if (identity.service === "dev") {                                                                                 // 274
      serviceObject.name = user.devName;                                                                              // 275
      fieldsToUnset.devName = 1;                                                                                      // 276
    } else if (identity.service === "emailToken") {                                                                   //
      serviceObject.tokens = user.services.emailToken.tokens;                                                         // 278
      serviceObject.email = user.services.emailToken.email;                                                           // 279
      fieldsToUnset["services.emailToken"] = 1;                                                                       // 280
    }                                                                                                                 //
                                                                                                                      //
    newIdentity.service = {};                                                                                         // 283
    newIdentity.service[identity.service] = serviceObject;                                                            // 284
                                                                                                                      //
    var modifier = { $set: { identities: [newIdentity] } };                                                           // 286
    if (Object.keys(fieldsToUnset).length > 0) {                                                                      // 287
      modifier.$unset = fieldsToUnset;                                                                                // 288
    }                                                                                                                 //
                                                                                                                      //
    Meteor.users.update({ _id: user._id }, modifier);                                                                 // 291
  });                                                                                                                 //
}                                                                                                                     //
                                                                                                                      //
function repairEmailIdentityIds() {                                                                                   // 295
  Meteor.users.find({ "identities.service.emailToken": { $exists: 1 } }).forEach(function (user) {                    // 296
    if (user.identities.length != 1) {                                                                                // 297
      throw new Error("User does not have exactly one identity: ", user);                                             // 298
    }                                                                                                                 //
                                                                                                                      //
    var identity = user.identities[0];                                                                                // 301
    var newIdentity = _.pick(identity, "main", "noLogin", "verifiedEmail", "unverifiedMail", "profile");              // 302
    newIdentity.service = { email: identity.service.emailToken };                                                     // 304
    newIdentity.id = Crypto.createHash("sha256").update("email:" + identity.service.emailToken.email).digest("hex");  // 305
                                                                                                                      //
    Grains.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });            // 308
    Sessions.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });          // 309
    ApiTokens.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });         // 310
    ApiTokens.update({ "owner.user.identityId": identity.id }, { $set: { "owner.user.identityId": newIdentity.id } }, { multi: true });
    ApiTokens.update({ "owner.grain.introducerIdentity": identity.id }, { $set: { "owner.grain.introducerIdentity": newIdentity.id } }, { multi: true });
                                                                                                                      //
    while (ApiTokens.update({ "requirements.permissionsHeld.identityId": identity.id }, { $set: { "requirements.$.permissionsHeld.identityId": newIdentity.id } }, { multi: true }) > 0) {}
                                                                                                                      //
    Meteor.users.update({ _id: user._id }, { $set: { identities: [newIdentity] } });                                  // 324
  });                                                                                                                 //
}                                                                                                                     //
                                                                                                                      //
function splitAccountUsersAndIdentityUsers() {                                                                        // 328
  Meteor.users.find({ identities: { $exists: true } }).forEach(function (user) {                                      // 329
    if (user.identities.length != 1) {                                                                                // 330
      throw new Error("User does not have exactly one identity: ", user);                                             // 331
    }                                                                                                                 //
                                                                                                                      //
    var identity = user.identities[0];                                                                                // 334
    var identityUser = _.pick(user, "createdAt", "lastActive", "expires");                                            // 335
    identityUser._id = identity.id;                                                                                   // 336
    identityUser.profile = identity.profile;                                                                          // 337
    _.extend(identityUser, _.pick(identity, "unverifiedEmail"));                                                      // 338
    identityUser.profile.service = Object.keys(identity.service)[0];                                                  // 339
                                                                                                                      //
    // Updating this user needs to be a two step process because the `services` field typically                       //
    // contains subfields that are constrained to be unique by Mongo indices.                                         //
    identityUser.stagedServices = _.omit(user.services, "resume");                                                    // 329
    if (identity.service.dev) {                                                                                       // 344
      identityUser.stagedServices.dev = identity.service.dev;                                                         // 345
    } else if (identity.service.email) {                                                                              //
      identityUser.stagedServices.email = identity.service.email;                                                     // 347
    }                                                                                                                 //
                                                                                                                      //
    var accountUser = _.pick(user, "_id", "createdAt", "lastActive", "expires", "isAdmin", "signupKey", "signupNote", "signupEmail", "plan", "storageUsage", "isAppDemoUser", "appDemoId", "payments", "dailySentMailCount", "hasCompletedSignup");
    accountUser.loginIdentities = [_.pick(identity, "id")];                                                           // 354
    accountUser.nonloginIdentities = [];                                                                              // 355
    if (user.services && user.services.resume) {                                                                      // 356
      accountUser.services = { resume: user.services.resume };                                                        // 357
    }                                                                                                                 //
                                                                                                                      //
    accountUser.stashedOldUser = user;                                                                                // 360
                                                                                                                      //
    ApiTokens.update({ identityId: identityUser._id }, { $set: { accountId: user._id } }, { multi: true });           // 362
                                                                                                                      //
    Meteor.users.upsert({ _id: identityUser._id }, identityUser);                                                     // 365
    Meteor.users.update({ _id: user._id }, accountUser);                                                              // 366
  });                                                                                                                 //
                                                                                                                      //
  Meteor.users.find({ stagedServices: { $exists: true } }).forEach(function (identity) {                              // 369
    Meteor.users.update({ _id: identity._id }, { $unset: { stagedServices: 1 },                                       // 370
      $set: { services: identity.stagedServices } });                                                                 // 371
  });                                                                                                                 //
}                                                                                                                     //
                                                                                                                      //
function populateContactsFromApiTokens() {                                                                            // 375
  ApiTokens.find({ "owner.user.identityId": { $exists: 1 },                                                           // 376
    accountId: { $exists: 1 } }).forEach(function (token) {                                                           // 377
    var identityId = token.owner.user.identityId;                                                                     // 378
    var identity = SandstormDb.prototype.getIdentity(identityId);                                                     // 379
    if (identity) {                                                                                                   // 380
      var profile = identity.profile;                                                                                 // 381
      Contacts.upsert({ ownerId: token.accountId, identityId: identityId }, {                                         // 382
        ownerId: token.accountId,                                                                                     // 383
        petname: profile && profile.name,                                                                             // 384
        created: new Date(),                                                                                          // 385
        identityId: identityId,                                                                                       // 386
        profile: profile                                                                                              // 387
      });                                                                                                             //
    }                                                                                                                 //
  });                                                                                                                 //
}                                                                                                                     //
                                                                                                                      //
function cleanUpApiTokens() {                                                                                         // 393
  // The `splitUserIdsIntoAccountIdsAndIdentityIds()` migration only added `identityId` in cases                      //
  // where the user still existed in the database.                                                                    //
  ApiTokens.remove({ userId: { $exists: true }, identityId: { $exists: false } });                                    // 396
  ApiTokens.remove({ "owner.user.userId": { $exists: true },                                                          // 397
    "owner.user.identityId": { $exists: false } });                                                                   // 398
                                                                                                                      //
  // For a while we were accidentally setting `appIcon` instead of `icon`.                                            //
  ApiTokens.find({ "owner.user.denormalizedGrainMetadata.appIcon": { $exists: true } }).forEach(function (apiToken) {
    var icon = apiToken.owner.user.denormalizedGrainMetadata.appIcon;                                                 // 403
    ApiTokens.update({ _id: apiToken._id }, { $set: { "owner.user.denormalizedGrainMetadata.icon": icon },            // 404
      $unset: { "owner.user.denormalizedGrainMetadata.appIcon": true } });                                            // 406
  });                                                                                                                 //
                                                                                                                      //
  // For a while the `identityId` field of child UiView tokens was not getting set.                                   //
  function repairChain(parentToken) {                                                                                 // 393
    ApiTokens.find({ parentToken: parentToken._id, grainId: { $exists: true },                                        // 411
      identityId: { $exists: false } }).forEach(function (childToken) {                                               // 412
      ApiTokens.update({ _id: childToken._id }, { $set: { identityId: parentToken.identityId } });                    // 413
      repairChain(childToken);                                                                                        // 414
    });                                                                                                               //
  }                                                                                                                   //
                                                                                                                      //
  ApiTokens.find({ grainId: { $exists: true }, identityId: { $exists: true },                                         // 418
    parentToken: { $exists: false } }).forEach(repairChain);                                                          // 419
}                                                                                                                     //
                                                                                                                      //
function initServerTitleAndReturnAddress() {                                                                          // 422
  var hostname = Url.parse(process.env.ROOT_URL).hostname;                                                            // 423
  Settings.insert({ _id: "serverTitle", value: hostname });                                                           // 424
  Settings.insert({ _id: "returnAddress", value: "no-reply@" + hostname });                                           // 425
}                                                                                                                     //
                                                                                                                      //
function sendReferralNotifications() {                                                                                // 428
  if (Meteor.settings["public"].quotaEnabled) {                                                                       // 429
    Meteor.users.find({                                                                                               // 430
      loginIdentities: { $exists: true },                                                                             // 431
      expires: { $exists: false }                                                                                     // 432
    }, { fields: { _id: 1 } }).forEach(function (user) {                                                              //
      sendReferralProgramNotification(user._id);                                                                      // 434
    });                                                                                                               //
  }                                                                                                                   //
}                                                                                                                     //
                                                                                                                      //
function assignBonuses() {                                                                                            // 439
  if (Meteor.settings["public"].quotaEnabled && SandstormDb.bonusesMigrationHook) {                                   // 440
    SandstormDb.bonusesMigrationHook();                                                                               // 441
  }                                                                                                                   //
}                                                                                                                     //
                                                                                                                      //
function splitSmtpUrl() {                                                                                             // 445
  var smtpUrlSetting = Settings.findOne({ _id: "smtpUrl" });                                                          // 446
  var smtpUrl = smtpUrlSetting ? smtpUrlSetting.value : process.env.MAIL_URL;                                         // 447
  var returnAddress = Settings.findOne({ _id: "returnAddress" });                                                     // 448
                                                                                                                      //
  // Default values.                                                                                                  //
  var smtpConfig = {                                                                                                  // 445
    hostname: "localhost",                                                                                            // 452
    port: "25",                                                                                                       // 453
    auth: undefined,                                                                                                  // 454
    returnAddress: returnAddress.value                                                                                // 455
  };                                                                                                                  //
                                                                                                                      //
  var parsed = void 0;                                                                                                // 458
  try {                                                                                                               // 459
    parsed = smtpUrl && Url.parse(smtpUrl);                                                                           // 460
  } catch (e) {}                                                                                                      //
                                                                                                                      //
  if (parsed) {                                                                                                       // 463
    // If there was a SMTP URL previously defined, import its data.                                                   //
    var auth = undefined;                                                                                             // 465
    if (parsed.auth) {                                                                                                // 466
      var colonIndex = parsed.auth.indexOf(":");                                                                      // 467
      var user = undefined;                                                                                           // 468
      var pass = undefined;                                                                                           // 469
      if (colonIndex !== -1) {                                                                                        // 470
        user = parsed.auth.slice(0, colonIndex);                                                                      // 471
        pass = parsed.auth.slice(colonIndex + 1);                                                                     // 472
      }                                                                                                               //
                                                                                                                      //
      auth = {                                                                                                        // 475
        user: user,                                                                                                   // 476
        pass: pass                                                                                                    // 477
      };                                                                                                              //
    }                                                                                                                 //
                                                                                                                      //
    // Override defaults with previous config's values.                                                               //
    smtpConfig.hostname = parsed.hostname || "localhost";                                                             // 463
    smtpConfig.port = parsed.port || "25";                                                                            // 483
    smtpConfig.auth = auth;                                                                                           // 484
  }                                                                                                                   //
                                                                                                                      //
  Settings.upsert({ _id: "smtpConfig" }, { value: smtpConfig });                                                      // 487
  Settings.remove({ _id: "returnAddress" });                                                                          // 488
  Settings.remove({ _id: "smtpUrl" });                                                                                // 489
}                                                                                                                     //
                                                                                                                      //
function smtpPortShouldBeNumber() {                                                                                   // 492
  var entry = Settings.findOne({ _id: "smtpConfig" });                                                                // 493
  if (entry) {                                                                                                        // 494
    var setting = entry.value;                                                                                        // 495
    if (setting.port) {                                                                                               // 496
      setting.port = _.isNumber(setting.port) ? setting.port : parseInt(setting.port);                                // 497
      Settings.upsert({ _id: "smtpConfig" }, { value: setting });                                                     // 498
    }                                                                                                                 //
  }                                                                                                                   //
}                                                                                                                     //
                                                                                                                      //
function consolidateOrgSettings() {                                                                                   // 503
  var orgGoogleDomain = Settings.findOne({ _id: "organizationGoogle" });                                              // 504
  var orgEmailDomain = Settings.findOne({ _id: "organizationEmail" });                                                // 505
  var orgLdap = Settings.findOne({ _id: "organizationLdap" });                                                        // 506
  var orgSaml = Settings.findOne({ _id: "organizationSaml" });                                                        // 507
                                                                                                                      //
  var orgMembership = {                                                                                               // 509
    google: {                                                                                                         // 510
      enabled: orgGoogleDomain ? !!orgGoogleDomain.value : false,                                                     // 511
      domain: orgGoogleDomain ? orgGoogleDomain.value : ""                                                            // 512
    },                                                                                                                //
    email: {                                                                                                          // 514
      enabled: orgEmailDomain ? !!orgEmailDomain.value : false,                                                       // 515
      domain: orgEmailDomain ? orgEmailDomain.value : ""                                                              // 516
    },                                                                                                                //
    ldap: {                                                                                                           // 518
      enabled: orgLdap ? orgLdap.value : false                                                                        // 519
    },                                                                                                                //
    saml: {                                                                                                           // 521
      enabled: orgSaml ? orgSaml.value : false                                                                        // 522
    }                                                                                                                 //
  };                                                                                                                  //
                                                                                                                      //
  Settings.upsert({ _id: "organizationMembership" }, { value: orgMembership });                                       // 526
  Settings.remove({ _id: "organizationGoogle" });                                                                     // 527
  Settings.remove({ _id: "organizationEmail" });                                                                      // 528
  Settings.remove({ _id: "organizationLdap" });                                                                       // 529
  Settings.remove({ _id: "organizationSaml" });                                                                       // 530
}                                                                                                                     //
                                                                                                                      //
function unsetSmtpDefaultHostnameIfNoUsersExist() {                                                                   // 533
  // We don't actually want to have the default hostname "localhost" set.                                             //
  // If the user has already finished configuring their server, then this migration should do                         //
  // nothing (since we might break their deployment), but for new installs (which will have no users                  //
  // at the time this migration runs) we'll unset the hostname if it's still the previously-filled                    //
  // default value.                                                                                                   //
  var hasUsers = Meteor.users.findOne();                                                                              // 539
  if (!hasUsers) {                                                                                                    // 540
    var entry = Settings.findOne({ _id: "smtpConfig" });                                                              // 541
    var smtpConfig = entry.value;                                                                                     // 542
    if (smtpConfig.hostname === "localhost") {                                                                        // 543
      smtpConfig.hostname = "";                                                                                       // 544
      Settings.upsert({ _id: "smtpConfig" }, { value: smtpConfig });                                                  // 545
    }                                                                                                                 //
  }                                                                                                                   //
}                                                                                                                     //
                                                                                                                      //
function extractLastUsedFromApiTokenOwner() {                                                                         // 550
  // We used to store lastUsed as a field on owner.user.  It makes more sense to store lastUsed on                    //
  // the apiToken as a whole.  This migration hoists such values from owner.user onto the apiToken                    //
  // itself.                                                                                                          //
  ApiTokens.find({ "owner.user": { $exists: true } }).forEach(function (token) {                                      // 554
    var lastUsed = token.owner.user.lastUsed;                                                                         // 555
    ApiTokens.update({ _id: token._id }, {                                                                            // 556
      $set: { lastUsed: lastUsed },                                                                                   // 557
      $unset: { "owner.user.lastUsed": true }                                                                         // 558
    });                                                                                                               //
  });                                                                                                                 //
}                                                                                                                     //
                                                                                                                      //
function setUpstreamTitles() {                                                                                        // 563
  // Initializes the `upstreamTitle` and `renamed` fields of `ApiToken.owner.user`.                                   //
                                                                                                                      //
  var apiTokensRaw = ApiTokens.rawCollection();                                                                       // 566
  var aggregateApiTokens = Meteor.wrapAsync(apiTokensRaw.aggregate, apiTokensRaw);                                    // 567
                                                                                                                      //
  // First, construct a list of all *shared* grains. We will need to do a separate update()                           //
  // for each of these, so we'd like to skip those which have nothing to update.                                      //
  var grainIds = aggregateApiTokens([{ $match: { "owner.user": { $exists: true }, grainId: { $exists: true } } }, { $group: { _id: "$grainId" } }]).map(function (grain) {
    return grain._id;                                                                                                 //
  });                                                                                                                 //
                                                                                                                      //
  var count = 0;                                                                                                      // 576
  Grains.find({ _id: { $in: grainIds } }, { fields: { title: 1 } }).forEach(function (grain) {                        // 577
    if (count % 100 == 0) {                                                                                           // 578
      console.log(count + " / " + grainIds.length);                                                                   // 579
    }                                                                                                                 //
                                                                                                                      //
    ++count;                                                                                                          // 582
                                                                                                                      //
    // For ApiTokens whose petname titles do not match the upstream title, we need to set                             //
    // `upstreamTitle` and `renamed`. We have no way of knowing which of the two names was the                        //
    // original name, so we don't know whether it was the owner or the receiver who renamed their                     //
    // copy post-sharaing. We assume it was the owner, because:                                                       //
    // 1. It's probably unusual for people to try to rename a grain they don't own.                                   //
    // 2. This results in UI that is reasonably non-confusing even if we guessed wrong. Namely,                       //
    //    the user sees "Owner's title (was: User's title)", which is reasonably OK even if it                        //
    //    was the user who had renamed their copy. They can rename it again if they like. On the                      //
    //    other hand, if we guessed wrongly in the other direction, the user would see                                //
    //    "User's title (renamed from: Owners title)", which would be wrong if it was in fact the                     //
    //    owner who renamed post-sharing.                                                                             //
    ApiTokens.update({                                                                                                // 577
      grainId: grain._id,                                                                                             // 596
      "owner.user.title": { $exists: true, $ne: grain.title }                                                         // 597
    }, { $set: { "owner.user.upstreamTitle": grain.title } }, { multi: true });                                       //
  });                                                                                                                 //
}                                                                                                                     //
                                                                                                                      //
// This must come after all the functions named within are defined.                                                   //
// Only append to this list!  Do not modify or remove list entries;                                                   //
// doing so is likely change the meaning and semantics of user databases.                                             //
var MIGRATIONS = [updateLoginStyleToRedirect, enableLegacyOAuthProvidersIfNotInSettings, denormalizeInviteInfo, mergeRoleAssignmentsIntoApiTokens, fixOasisStorageUsageStats, fetchProfilePictures, assignPlans, removeKeyrings, useLocalizedTextInUserActions, verifyAllPgpSignatures, splitUserIdsIntoAccountIdsAndIdentityIds, appUpdateSettings, moveDevAndEmailLoginDataIntoIdentities, repairEmailIdentityIds, splitAccountUsersAndIdentityUsers, populateContactsFromApiTokens, cleanUpApiTokens, initServerTitleAndReturnAddress, sendReferralNotifications, assignBonuses, splitSmtpUrl, smtpPortShouldBeNumber, consolidateOrgSettings, unsetSmtpDefaultHostnameIfNoUsersExist, extractLastUsedFromApiTokenOwner, setUpstreamTitles];
                                                                                                                      //
function migrateToLatest() {                                                                                          // 634
  if (Meteor.settings.replicaNumber) {                                                                                // 635
    (function () {                                                                                                    //
      // This is a replica. Wait for the first replica to perform migrations.                                         //
                                                                                                                      //
      console.log("Waiting for migrations on replica zero...");                                                       // 638
                                                                                                                      //
      var done = new Future();                                                                                        // 640
      var change = function change(doc) {                                                                             // 641
        console.log("Migrations applied elsewhere: " + doc.value + "/" + MIGRATIONS.length);                          // 642
        if (doc.value >= MIGRATIONS.length) done["return"]();                                                         // 643
      };                                                                                                              //
                                                                                                                      //
      var observer = Migrations.find({ _id: "migrations_applied" }).observe({                                         // 646
        added: change,                                                                                                // 647
        changed: change                                                                                               // 648
      });                                                                                                             //
                                                                                                                      //
      done.wait();                                                                                                    // 651
      observer.stop();                                                                                                // 652
      console.log("Migrations have completed on replica zero.");                                                      // 653
    })();                                                                                                             //
  } else {                                                                                                            //
    var applied = Migrations.findOne({ _id: "migrations_applied" });                                                  // 656
    var start = void 0;                                                                                               // 657
    if (!applied) {                                                                                                   // 658
      // Migrations table is not yet seeded with a value.  This means it has                                          //
      // applied 0 migrations.  Persist this.                                                                         //
      Migrations.insert({ _id: "migrations_applied", value: 0 });                                                     // 661
      start = 0;                                                                                                      // 662
    } else {                                                                                                          //
      start = applied.value;                                                                                          // 664
    }                                                                                                                 //
                                                                                                                      //
    console.log("Migrations already applied: " + start + "/" + MIGRATIONS.length);                                    // 667
                                                                                                                      //
    for (var i = start; i < MIGRATIONS.length; i++) {                                                                 // 669
      // Apply migration i, then record that migration i was successfully run.                                        //
      console.log("Applying migration " + (i + 1));                                                                   // 671
      MIGRATIONS[i]();                                                                                                // 672
      Migrations.update({ _id: "migrations_applied" }, { $set: { value: i + 1 } });                                   // 673
      console.log("Applied migration " + (i + 1));                                                                    // 674
    }                                                                                                                 //
  }                                                                                                                   //
}                                                                                                                     //
                                                                                                                      //
SandstormDb.prototype.migrateToLatest = migrateToLatest;                                                              // 679
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-db/db.js");
require("./node_modules/meteor/sandstorm-db/profile.js");
require("./node_modules/meteor/sandstorm-db/user.js");
require("./node_modules/meteor/sandstorm-db/migrations.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-db'] = {}, {
  SandstormDb: SandstormDb
});

})();

//# sourceMappingURL=sandstorm-db.js.map
